/*************************************************************************/
/* Copyright (C) 1995-1997 Marlis Hochbruck, Christian Lubich, Hubert    */
/* Selhofer. All rights reserved.                                        */
/*                                                                       */
/* C code written by Mathias Froehlich.                                  */
/*                                                                       */
/* This code is part of a copyrighted package. For details, see the file */
/* "COPYING" in the top-level directory.                                 */
/*************************************************************************/

#ifndef ARNOLDI_H
#define ARNOLDI_H

#ifdef  __cplusplus
extern "C" {
#endif

typedef struct {
  Complex *V;
} ArnoldiPrivat;

extern struct Krylov *PREC(Exp4GetArnoldiHandle) (finteger MaxKrylovDim,
      finteger neq,int HaveOwnV);

extern void PREC(Exp4FillHandleWithArnoldi) (struct Krylov *Kry,
      finteger MaxKrylovDim,finteger neq,int HaveOwnV);

/* accesses the pointer to V, Data is here the Krylov struct pointer */
#define ArnoldiVData(Data) (KrylovPrivat(Data).Arnoldi.V)

/* accesses the i - th vector in V */
#define ArnoldiV(Data,i) (KrylovPrivat(Data).Arnoldi.V+(i)*KrylovLdBig(Data))

#ifdef  __cplusplus
}
#endif
#endif
