/*************************************************************************/
/* Copyright (C) 1995-1997 Marlis Hochbruck, Christian Lubich, Hubert    */
/* Selhofer. All rights reserved.                                        */
/*                                                                       */
/* C code written by Mathias Froehlich.                                  */
/*                                                                       */
/* This code is part of a copyrighted package. For details, see the file */
/* "COPYING" in the top-level directory.                                 */
/*************************************************************************/

#ifndef HISTORY_H
#define HISTORY_H

#include <limits.h>

/* #define HISTORY_DEBUG */

#ifdef HISTORY_DEBUG
# define HistoryDebugMessage(Name,Hist) \
{ \
  int __i; \
  fprintf(DEBUG_FILE,"\tHistory: " Name " \"" #Hist"\" Len = %2d, Pos = %3d," \
        " Data:",(Hist).Length,(Hist).Position); \
  for (__i = 0;__i < min((Hist).Length,(Hist).Position+1);__i++) \
  { \
    fprintf(DEBUG_FILE,"%3d ", \
          (Hist).Data[((Hist).Position-__i)%(Hist).Length]); \
  } \
  fputc('\n',DEBUG_FILE); \
}
#else
# define HistoryDebugMessage(Name,Hist) ((void)0)
#endif


typedef struct {
  finteger *Data;
  int Length;
  int Position;
} History;

#define GetHistoryLength(Hist) (min((Hist).Length,(Hist).Position+1))

#ifdef  __cplusplus
extern "C" {
#endif

extern History *InitHistory(int Length);

extern void AppendToHistory(History *Hist,finteger Value);

extern void CopyLastEntry(History *Hist);

extern finteger GetMaximalHistoryEntry(History *Hist);

extern finteger GetHistoryEntry(History *Hist,int Number);

#ifdef  __cplusplus
}
#endif

#endif
