/*************************************************************************/
/* Copyright (C) 1995-1997 Marlis Hochbruck, Christian Lubich, Hubert    */
/* Selhofer. All rights reserved.                                        */
/*                                                                       */
/* C code written by Mathias Froehlich.                                  */
/*                                                                       */
/* This code is part of a copyrighted package. For details, see the file */
/* "COPYING" in the top-level directory.                                 */
/*************************************************************************/

/* Header file for krystep.c */
#ifndef KRYSTEP_H
#define KRYSTEP_H

#include "history.h"
#include "krylov.h"

#define GetHKry(h_kry,h,Kry1,Hist1,Kry2,Hist2,Kry3,Hist3) \
{ \
  Real __Fac1,__Fac2,__Fac3; \
 \
  __Fac1 = PREC(GetKryFac) (Kry1,Hist1); \
  __Fac2 = PREC(GetKryFac) (Kry2,Hist2); \
  __Fac3 = PREC(GetKryFac) (Kry3,Hist3); \
 \
  (h_kry) = (h)*min (__Fac1,min(__Fac2,__Fac3)); \
}

#ifdef  __cplusplus
extern "C" {
#endif

extern Real PREC(GetKryFac) (krylov *Kry,History *Hist);

extern int PREC(GetNearestIndex) (fdouble Val,finteger *index,int indexlen);

#ifdef  __cplusplus
}
#endif
#endif
