/*************************************************************************/
/* Copyright (C) 1995-1997 Marlis Hochbruck, Christian Lubich, Hubert    */
/* Selhofer. All rights reserved.                                        */
/*                                                                       */
/* C code written by Mathias Froehlich.                                  */
/*                                                                       */
/* This code is part of a copyrighted package. For details, see the file */
/* "COPYING" in the top-level directory.                                 */
/*************************************************************************/

/* header file for pfuns.h */

#ifndef PFUNS_H
#define PFUNS_H

typedef enum {Righthandside, Jacobian, FullJac, Mv, Mtv} Exp4FunctionType;

#ifdef  __cplusplus
extern "C" {
#endif

extern void PREC(Exp4SetProblemFunctions) (Exp4FunctionType Type,...);

extern void PREC(Exp4EvalRhs) (finteger neq,Complex *fy,
      Complex *y);

extern void PREC(Exp4GetNewFullJac) (finteger neq,Complex *a,finteger ld,
      Complex *y);

extern void PREC(Exp4GetNewJac) (finteger neq,Complex *y);

extern void PREC(Exp4Mv) (finteger neq,Complex *Mv,Complex *v,
      int normed_v);

extern void PREC(Exp4vM) (finteger neq,Complex *vM,Complex *v);

extern void PREC(Exp4SetNormJacApproach) (Real val1);

extern Real PREC(Exp4GetNormJacApproach) (void);

extern long PREC(FunEvals)(void);

extern long PREC(JacEvals)(void);

extern long PREC(MvEvals)(void);

extern long PREC(vMEvals)(void);

#ifdef  __cplusplus
}
#endif

#endif
