#ifndef FLAPACK_H
#define FLAPACK_H
/*************************************************************************/
/* Copyright (C) 1995-1997 Marlis Hochbruck, Christian Lubich, Hubert    */
/* Selhofer. All rights reserved.                                        */
/*                                                                       */
/* C code written by Mathias Froehlich.                                  */
/*                                                                       */
/* This code is part of a copyrighted package. For details, see the file */
/* "COPYING" in the top-level directory.                                 */
/*************************************************************************/

/* collection of external declarations of Fortran 77 LAPACK routines */

#include "ftypes.h"

#ifdef  __cplusplus
extern "C" {
#endif

typedef flogical (*fsselectfunction) (const fsingle*,const fsingle*);
typedef flogical (*fdselectfunction) (const fdouble*,const fdouble*);
typedef flogical (*fcselectfunction) (const fsinglecomplex*);
typedef flogical (*fzselectfunction) (const fdoublecomplex*);

extern void F77CALL (cbdsqr) (const char*,const finteger*,const finteger*,
      const finteger*,const finteger*,fsingle*,fsingle*,fsinglecomplex*,
      const finteger*,fsinglecomplex*,const finteger*,fsinglecomplex*,
      const finteger*,fsingle*,finteger*);

extern void F77CALL (cgbbrd) (const char*,const finteger*,const finteger*,
      const finteger*,const finteger*,const finteger*,fsinglecomplex*,
      const finteger*,fsingle*,fsingle*,fsinglecomplex*,const finteger*,
      fsinglecomplex*,const finteger*,fsinglecomplex*,const finteger*,
      fsinglecomplex*,fsingle*,finteger*);

extern void F77CALL (cgbcon) (const char*,const finteger*,const finteger*,
      const finteger*,const fsinglecomplex*,const finteger*,const finteger*,
      const fsingle*,fsingle*,fsinglecomplex*,fsingle*,finteger*);

extern void F77CALL (cgbequ) (const finteger*,const finteger*,const finteger*,
      const finteger*,const fsinglecomplex*,const finteger*,fsingle*,fsingle*,
      fsingle*,fsingle*,fsingle*,finteger*);

extern void F77CALL (cgbrfs) (const char*,const finteger*,const finteger*,
      const finteger*,const finteger*,const fsinglecomplex*,const finteger*,
      const fsinglecomplex*,const finteger*,const finteger*,
      const fsinglecomplex*,const finteger*,fsinglecomplex*,const finteger*,
      fsingle*,fsingle*,fsinglecomplex*,fsingle*,finteger*);

extern void F77CALL (cgbsv) (const finteger*,const finteger*,const finteger*,
      const finteger*,fsinglecomplex*,const finteger*,finteger*,
      fsinglecomplex*,const finteger*,finteger*);

extern void F77CALL (cgbsvx) (const char*,const char*,const finteger*,
      const finteger*,const finteger*,const finteger*,fsinglecomplex*,
      const finteger*,fsinglecomplex*,const finteger*,finteger*,char*,fsingle*,
      fsingle*,fsinglecomplex*,const finteger*,fsinglecomplex*,const finteger*,
      fsingle*,fsingle*,fsingle*,fsinglecomplex*,fsingle*,finteger*);

extern void F77CALL (cgbtf2) (const finteger*,const finteger*,const finteger*,
      const finteger*,fsinglecomplex*,const finteger*,finteger*,finteger*);

extern void F77CALL (cgbtrf) (const finteger*,const finteger*,const finteger*,
      const finteger*,fsinglecomplex*,const finteger*,finteger*,finteger*);

extern void F77CALL (cgbtrs) (const char*,const finteger*,const finteger*,
      const finteger*,const finteger*,const fsinglecomplex*,const finteger*,
      const finteger*,fsinglecomplex*,const finteger*,finteger*);

extern void F77CALL (cgebak) (const char*,const char*,const finteger*,
      const finteger*,const finteger*,const fsingle*,const finteger*,
      fsinglecomplex*,const finteger*,finteger*);

extern void F77CALL (cgebal) (const char*,const finteger*,fsinglecomplex*,
      const finteger*,finteger*,finteger*,fsingle*,finteger*);

extern void F77CALL (cgebd2) (const finteger*,const finteger*,
      fsinglecomplex*,const finteger*,fsingle*,fsingle*,fsinglecomplex*,
      fsinglecomplex*,fsinglecomplex*,finteger*);

extern void F77CALL (cgebrd) (const finteger*,const finteger*,fsinglecomplex*,
      const finteger*,fsingle*,fsingle*,fsinglecomplex*,fsinglecomplex*,
      fsinglecomplex*,const finteger*,finteger*);

extern void F77CALL (cgecon) (const char*,const finteger*,
      const fsinglecomplex*,const finteger*,const fsingle*,fsingle*,
      fsinglecomplex*,fsingle*,finteger*);

extern void F77CALL (cgeequ) (const finteger*,const finteger*,
      const fsinglecomplex*,const finteger*,fsingle*,fsingle*,fsingle*,
      fsingle*,fsingle*,finteger*);

extern void F77CALL (cgees) (const char*,const char*,fcselectfunction,
      const finteger*,fsinglecomplex*,const finteger*,finteger*,
      fsinglecomplex*,fsinglecomplex*,const finteger*,fsinglecomplex*,
      const finteger*,fsingle*,flogical*,finteger*);

extern void F77CALL (cgeesx) (const char*,const char*,fcselectfunction,
      const char*,const finteger*,fsinglecomplex*,const finteger*,finteger*,
      fsinglecomplex*,fsinglecomplex*,const finteger*,fsingle*,fsingle*,
      fsinglecomplex*,const finteger*,fsingle*,flogical*,finteger*);

extern void F77CALL (cgeev) (const char*,const char*,const finteger*,
      fsinglecomplex*,const finteger*,fsinglecomplex*,fsinglecomplex*,
      const finteger*,fsinglecomplex*,const finteger*,fsinglecomplex*,
      const finteger*,fsingle*,finteger*);

extern void F77CALL (cgeevx) (const char*,const char*,const char*,const char*,
      const finteger*,fsinglecomplex*,const finteger*,fsinglecomplex*,
      fsinglecomplex*,const finteger*,fsinglecomplex*,const finteger*,
      finteger*,finteger*,fsingle*,fsingle*,fsingle*,fsingle*,fsinglecomplex*,
      const finteger*,fsingle*,finteger*);

extern void F77CALL (cgegs) (const char*,const char*,const finteger*,
      fsinglecomplex*,const finteger*,fsinglecomplex*,const finteger*,
      fsinglecomplex*,fsinglecomplex*,fsinglecomplex*,const finteger*,
      fsinglecomplex*,const finteger*,fsinglecomplex*,const finteger*,
      fsingle*,finteger*);

extern void F77CALL (cgegv) (const char*,const char*,const finteger*,
      fsinglecomplex*,const finteger*,fsinglecomplex*,const finteger*,
      fsinglecomplex*,fsinglecomplex*,fsinglecomplex*,const finteger*,
      fsinglecomplex*,const finteger*,fsinglecomplex*,const finteger*,
      fsingle*,finteger*);

extern void F77CALL (cgehd2) (const finteger*,const finteger*,const finteger*,
      fsinglecomplex*,const finteger*,fsinglecomplex*,fsinglecomplex*,
      finteger*);

extern void F77CALL (cgehrd) (const finteger*,const finteger*,const finteger*,
      fsinglecomplex*,const finteger*,fsinglecomplex*,fsinglecomplex*,
      const finteger*,finteger*);

extern void F77CALL (cgelq2) (const finteger*,const finteger*,fsinglecomplex*,
      const finteger*,fsinglecomplex*,fsinglecomplex*,finteger*);

extern void F77CALL (cgelqf) (const finteger*,const finteger*,fsinglecomplex*,
      const finteger*,fsinglecomplex*,fsinglecomplex*,const finteger*,
      finteger*);

extern void F77CALL (cgels) (const char*,const finteger*,const finteger*,
      const finteger*,fsinglecomplex*,const finteger*,fsinglecomplex*,
      const finteger*,fsinglecomplex*,const finteger*,finteger*);

extern void F77CALL (cgelss) (const finteger*,const finteger*,const finteger*,
      fsinglecomplex*,const finteger*,fsinglecomplex*,const finteger*,
      fsingle*,const fsingle*,finteger*,fsinglecomplex*,const finteger*,
      fsingle*,finteger*);

extern void F77CALL (cgelsx) (const finteger*,const finteger*,const finteger*,
      fsinglecomplex*,const finteger*,fsinglecomplex*,const finteger*,
      finteger*,const fsingle*,finteger*,fsinglecomplex*,fsingle*,finteger*);

extern void F77CALL (cgeql2) (const finteger*,const finteger*,fsinglecomplex*,
      const finteger*,fsinglecomplex*,fsinglecomplex*,finteger*);

extern void F77CALL (cgeqlf) (const finteger*,const finteger*,fsinglecomplex*,
      const finteger*,fsinglecomplex*,fsinglecomplex*,const finteger*,
      finteger*);

extern void F77CALL (cgeqpf) (const finteger*,const finteger*,fsinglecomplex*,
      const finteger*,finteger*,fsinglecomplex*,fsinglecomplex*,fsingle*,
      finteger*);

extern void F77CALL (cgeqr2) (const finteger*,const finteger*,fsinglecomplex*,
      const finteger*,fsinglecomplex*,fsinglecomplex*,finteger*);

extern void F77CALL (cgeqrf) (const finteger*,const finteger*,fsinglecomplex*,
      const finteger*,fsinglecomplex*,fsinglecomplex*,const finteger*,
      finteger*);

extern void F77CALL (cgerfs) (const char*,const finteger*,const finteger*,
      const fsinglecomplex*,const finteger*,const fsinglecomplex*,
      const finteger*,const finteger*,const fsinglecomplex*,const finteger*,
      fsinglecomplex*,const finteger*,fsingle*,fsingle*,fsinglecomplex*,
      fsingle*,finteger*);

extern void F77CALL (cgerq2) (const finteger*,const finteger*,fsinglecomplex*,
      const finteger*,fsinglecomplex*,fsinglecomplex*,finteger*);

extern void F77CALL (cgerqf) (const finteger*,const finteger*,fsinglecomplex*,
      const finteger*,fsinglecomplex*,fsinglecomplex*,const finteger*,
      finteger*);

extern void F77CALL (cgesv) (const finteger*,const finteger*,fsinglecomplex*,
      const finteger*,finteger*,fsinglecomplex*,const finteger*,finteger*);

extern void F77CALL (cgesvd) (const char*,const char*,const finteger*,
      const finteger*,fsinglecomplex*,const finteger*,fsingle*,fsinglecomplex*,
      const finteger*,fsinglecomplex*,const finteger*,fsinglecomplex*,
      const finteger*,fsingle*,finteger*);

extern void F77CALL (cgesvx) (const char*,const char*,const finteger*,
      const finteger*,fsinglecomplex*,const finteger*,fsinglecomplex*,
      const finteger*,finteger*,char*,fsingle*,fsingle*,fsinglecomplex*,
      const finteger*,fsinglecomplex*,const finteger*,fsingle*,fsingle*,
      fsingle*,fsinglecomplex*,fsingle*,finteger*);

extern void F77CALL (cgetf2) (const finteger*,const finteger*,fsinglecomplex*,
      const finteger*,finteger*,finteger*);

extern void F77CALL (cgetrf) (const finteger*,const finteger*,fsinglecomplex*,
      const finteger*,finteger*,finteger*);

extern void F77CALL (cgetri) (const finteger*,fsinglecomplex*,const finteger*,
      const finteger*,fsinglecomplex*,const finteger*,finteger*);

extern void F77CALL (cgetrs) (const char*,const finteger*,const finteger*,
      const fsinglecomplex*,const finteger*,const finteger*,fsinglecomplex*,
      const finteger*,finteger*);

extern void F77CALL (cggbak) (const char*,const char*,const finteger*,
      const finteger*,const finteger*,const fsingle*,const fsingle*,
      const finteger*,fsinglecomplex*,const finteger*,finteger*);

extern void F77CALL (cggbal) (const char*,const finteger*,fsinglecomplex*,
      const finteger*,fsinglecomplex*,const finteger*,finteger*,finteger*,
      fsingle*,fsingle*,fsingle*,finteger*);

extern void F77CALL (cggglm) (const finteger*,const finteger*,const finteger*, 
      fsinglecomplex*,const finteger*,fsinglecomplex*,const finteger*,
      fsinglecomplex*,fsinglecomplex*,fsinglecomplex*,fsinglecomplex*,
      const finteger*,finteger*);

extern void F77CALL (cgghrd) (const char*,const char*,const finteger*,
      const finteger*,const finteger*,fsinglecomplex*,const finteger*,
      fsinglecomplex*,const finteger*,fsinglecomplex*,const finteger*,
      fsinglecomplex*,const finteger*,finteger*);

extern void F77CALL (cgglse) (const finteger*,const finteger*,const finteger*, 
      fsinglecomplex*,const finteger*,fsinglecomplex*,const finteger*,
      fsinglecomplex*,fsinglecomplex*,fsinglecomplex*,fsinglecomplex*,
      const finteger*,finteger*);

extern void F77CALL (cggqrf) (const finteger*,const finteger*,const finteger*,
      fsinglecomplex*,const finteger*,fsinglecomplex*,fsinglecomplex*,
      const finteger*,fsinglecomplex*,fsinglecomplex*,const finteger*,
      finteger*);

extern void F77CALL (cggrqf) (const finteger*,const finteger*,const finteger*, 
      fsinglecomplex*,const finteger*,fsinglecomplex*,fsinglecomplex*,
      const finteger*,fsinglecomplex*,fsinglecomplex*,const finteger*,
      finteger*);

extern void F77CALL (cggsvd) (const char*,const char*,const char*,
      const finteger*,const finteger*,const finteger*,finteger*,finteger*,
      fsinglecomplex*,const finteger*,fsinglecomplex*,const finteger*,
      fsingle*,fsingle*,fsinglecomplex*,const finteger*,fsinglecomplex*,
      const finteger*,fsinglecomplex*,const finteger*,fsinglecomplex*,fsingle*,
      finteger*,finteger*);

extern void F77CALL (cggsvp) (const char*,const char*,const char*,
      const finteger*,const finteger*,const finteger*,fsinglecomplex*,
      const finteger*,fsinglecomplex*,const finteger*,const fsingle*,
      const fsingle*,finteger*,finteger*,fsinglecomplex*,const finteger*,
      fsinglecomplex*,const finteger*,fsinglecomplex*,const finteger*,
      finteger*,fsingle*,fsinglecomplex*,fsinglecomplex*,finteger*);

extern void F77CALL (cgtcon) (const char*,const finteger*,
      const fsinglecomplex*,const fsinglecomplex*,const fsinglecomplex*,
      const fsinglecomplex*,const finteger*,const fsingle*,fsingle*,
      fsinglecomplex*,finteger*);

extern void F77CALL (cgtrfs) (const char*,const finteger*,const finteger*,
      const fsinglecomplex*,const fsinglecomplex*,const fsinglecomplex*,
      const fsinglecomplex*,const fsinglecomplex*,const fsinglecomplex*,
      const fsinglecomplex*,const finteger*,const fsinglecomplex*,
      const finteger*,fsinglecomplex*,const finteger*,fsingle*,fsingle*,
      fsinglecomplex*,fsingle*,finteger*);

extern void F77CALL (cgtsv) (const finteger*,const finteger*,fsinglecomplex*,
      fsinglecomplex*,fsinglecomplex*,fsinglecomplex*,const finteger*,
      finteger*);

extern void F77CALL (cgtsvx) (const char*,const char*,const finteger*,
      const finteger*,const fsinglecomplex*,const fsinglecomplex*,
      const fsinglecomplex*,fsinglecomplex*,fsinglecomplex*,fsinglecomplex*,
      fsinglecomplex*,finteger*,const fsinglecomplex*,const finteger*,
      fsinglecomplex*,const finteger*,fsingle*,fsingle*,fsingle*,
      fsinglecomplex*,fsingle*,finteger*);

extern void F77CALL (cgttrf) (const finteger*,fsinglecomplex*,fsinglecomplex*,
      fsinglecomplex*,fsinglecomplex*,finteger*,finteger*);

extern void F77CALL (cgttrs) (const char*,const finteger*,const finteger*,
      const fsinglecomplex*,const fsinglecomplex*,const fsinglecomplex*,
      const fsinglecomplex*,const finteger*,fsinglecomplex*,const finteger*,
      finteger*);

extern void F77CALL (chbev) (const char*,const char*,const finteger*,
      const finteger*,fsinglecomplex*,const finteger*,fsingle*,fsinglecomplex*,
      const finteger*,fsinglecomplex*,fsingle*,finteger*);

extern void F77CALL (chbevd) (const char*,const char*,const finteger*,
      const finteger*,fsinglecomplex*,const finteger*,fsingle*,
      fsinglecomplex*,const finteger*,fsinglecomplex*,const finteger*,fsingle*,
      const finteger*,finteger*,const finteger*,finteger*);

extern void F77CALL (chbevx) (const char*,const char*,const char*,
      const finteger*,const finteger*,fsinglecomplex*,const finteger*,
      fsinglecomplex*,const finteger*,const fsingle*,const fsingle*,
      const finteger*,const finteger*,const fsingle*,finteger*,fsingle*,
      fsinglecomplex*,const finteger*,fsinglecomplex*,fsingle*,finteger*,
      finteger*,finteger*);

extern void F77CALL (chbgst) (const char*,const char*,const finteger*,
      const finteger*,const finteger*,fsinglecomplex*,const finteger*,
      const fsinglecomplex*,const finteger*,fsinglecomplex*,const finteger*,
      fsinglecomplex*,fsingle*,finteger*);

extern void F77CALL (chbgv) (const char*,const char*,const finteger*,const finteger*,const finteger*,
      fsinglecomplex*,const finteger*,fsinglecomplex*,const finteger*,fsingle*,
      fsinglecomplex*,const finteger*,fsinglecomplex*,fsingle*,finteger*);

extern void F77CALL (chbtrd) (const char*,const char*,const finteger*,
      const finteger*,fsinglecomplex*,const finteger*,fsingle*,fsingle*,
      fsinglecomplex*,const finteger*,fsinglecomplex*,finteger*);

extern void F77CALL (checon) (const char*,const finteger*,
      const fsinglecomplex*,const finteger*,const finteger*,const fsingle*,
      fsingle*,fsinglecomplex*,finteger*);

extern void F77CALL (cheev) (const char*,const char*,const finteger*,
      fsinglecomplex*,const finteger*,fsingle*,fsinglecomplex*,const finteger*,
      fsingle*,finteger*);

extern void F77CALL (cheevd) (const char*,const char*,const finteger*,
      fsinglecomplex*,const finteger*,fsingle*,fsinglecomplex*,
      const finteger*,fsingle*,const finteger*,finteger*,const finteger*,
      finteger*);

extern void F77CALL (cheevx) (const char*,const char*,const char*,
      const finteger*,fsinglecomplex*,const finteger*,const fsingle*,
      const fsingle*,const finteger*,const finteger*,const fsingle*,finteger*,
      fsingle*,fsinglecomplex*,const finteger*,fsinglecomplex*,const finteger*,
      fsingle*,finteger*,finteger*,finteger*);

extern void F77CALL (chegs2) (const finteger*,const char*,const finteger*,
      fsinglecomplex*,const finteger*,const fsinglecomplex*,const finteger*,
      finteger*);

extern void F77CALL (chegst) (const finteger*,const char*,const finteger*,
      fsinglecomplex*,const finteger*,const fsinglecomplex*,const finteger*,
      finteger*);

extern void F77CALL (chegv) (const finteger*,const char*,const char*,
      const finteger*,fsinglecomplex*,const finteger*,fsinglecomplex*,
      const finteger*,fsingle*,fsinglecomplex*,const finteger*,fsingle*,
      finteger*);

extern void F77CALL (cherfs) (const char*,const finteger*,const finteger*,
      const fsinglecomplex*,const finteger*,const fsinglecomplex*,
      const finteger*,const finteger*,const fsinglecomplex*,const finteger*,
      fsinglecomplex*,const finteger*,fsingle*,fsingle*,fsinglecomplex*,
      fsingle*,finteger*);

extern void F77CALL (chesv) (const char*,const finteger*,const finteger*,
      fsinglecomplex*,const finteger*,finteger*,fsinglecomplex*,
      const finteger*,fsinglecomplex*,const finteger*,finteger*);

extern void F77CALL (chesvx) (const char*,const char*,const finteger*,
      const finteger*,const fsinglecomplex*,const finteger*,fsinglecomplex*,
      const finteger*,finteger*,const fsinglecomplex*,const finteger*,
      fsinglecomplex*,const finteger*,fsingle*,fsingle*,fsingle*,
      fsinglecomplex*,const finteger*,fsingle*,finteger*);

extern void F77CALL (chetd2) (const char*,const finteger*,fsinglecomplex*,
      const finteger*,fsingle*,fsingle*,fsinglecomplex*,finteger*);

extern void F77CALL (chetf2) (const char*,const finteger*,fsinglecomplex*,
      const finteger*,finteger*,finteger*);

extern void F77CALL (chetrd) (const char*,const finteger*,fsinglecomplex*,
      const finteger*,fsingle*,fsingle*,fsinglecomplex*,fsinglecomplex*,
      const finteger*,finteger*);

extern void F77CALL (chetrf) (const char*,const finteger*,fsinglecomplex*,
      const finteger*,finteger*,fsinglecomplex*,const finteger*,finteger*);

extern void F77CALL (chetri) (const char*,const finteger*,fsinglecomplex*,
      const finteger*,const finteger*,fsinglecomplex*,finteger*);

extern void F77CALL (chetrs) (const char*,const finteger*,const finteger*,
      const fsinglecomplex*,const finteger*,const finteger*,fsinglecomplex*,
      const finteger*,finteger*);

extern void F77CALL (chgeqz) (const char*,const char*,const char*,
      const finteger*,const finteger*,const finteger*,fsinglecomplex*,
      const finteger*,fsinglecomplex*,const finteger*,fsinglecomplex*,
      fsinglecomplex*,fsinglecomplex*,const finteger*,fsinglecomplex*,
      const finteger*,fsinglecomplex*,const finteger*,fsingle*,finteger*);

extern void F77CALL (chpcon) (const char*,const finteger*,
      const fsinglecomplex*,const finteger*,const fsingle*,fsingle*,
      fsinglecomplex*,finteger*);

extern void F77CALL (chpev) (const char*,const char*,const finteger*,
      fsinglecomplex*,fsingle*,fsinglecomplex*,const finteger*,
      fsinglecomplex*,fsingle*,finteger*);

extern void F77CALL (chpevd) (const char*,const char*,const finteger*,
      fsinglecomplex*,fsingle*,fsinglecomplex*,const finteger*,fsinglecomplex*,
      const finteger*,fsingle*,const finteger*,finteger*,const finteger*,
      finteger*);

extern void F77CALL (chpevx) (const char*,const char*,const char*,
      const finteger*,fsinglecomplex*,const fsingle*,const fsingle*,
      const finteger*,const finteger*,const fsingle*,finteger*,fsingle*,
      fsinglecomplex*,const finteger*,fsinglecomplex*,fsingle*,finteger*,
      finteger*,finteger*);

extern void F77CALL (chpgst) (const finteger*,const char*,const finteger*,
      fsinglecomplex*,const fsinglecomplex*,finteger*);

extern void F77CALL (chpgv) (const finteger*,const char*,const char*,
      const finteger*,fsinglecomplex*,fsinglecomplex*,fsingle*,fsinglecomplex*,
      const finteger*,fsinglecomplex*,fsingle*,finteger*);

extern void F77CALL (chprfs) (const char*,const finteger*,const finteger*,
      const fsinglecomplex*,const fsinglecomplex*,const finteger*,
      const fsinglecomplex*,const finteger*,fsinglecomplex*,const finteger*,
      fsingle*,fsingle*,fsinglecomplex*,fsingle*,finteger*);

extern void F77CALL (chpsv) (const char*,const finteger*,const finteger*,
      fsinglecomplex*,finteger*,fsinglecomplex*,const finteger*,finteger*);

extern void F77CALL (chpsvx) (const char*,const char*,const finteger*,
      const finteger*,const fsinglecomplex*,fsinglecomplex*,finteger*,
      const fsinglecomplex*,const finteger*,fsinglecomplex*,const finteger*,
      fsingle*,fsingle*,fsingle*,fsinglecomplex*,fsingle*,finteger*);

extern void F77CALL (chptrd) (const char*,const finteger*,fsinglecomplex*,
      fsingle*,fsingle*,fsinglecomplex*,finteger*);

extern void F77CALL (chptrf) (const char*,const finteger*,fsinglecomplex*,
      finteger*,finteger*);

extern void F77CALL (chptri) (const char*,const finteger*,fsinglecomplex*,
      const finteger*,fsinglecomplex*,finteger*);

extern void F77CALL (chptrs) (const char*,const finteger*,const finteger*,
      const fsinglecomplex*,const finteger*,fsinglecomplex*,const finteger*,
      finteger*);

extern void F77CALL (chsein) (const char*,const char*,const char*,flogical*,
      const finteger*,const fsinglecomplex*,const finteger*,
      const fsinglecomplex*,fsinglecomplex*,finteger*,const fsinglecomplex*,
      finteger*,const finteger*,const finteger*,fsinglecomplex*,fsingle*,
      finteger*,finteger*,finteger*);

extern void F77CALL (chseqr) (const char*,const char*,const finteger*,
      const finteger*,const finteger*,fsinglecomplex*,const finteger*,
      fsinglecomplex*,fsinglecomplex*,const finteger*,fsinglecomplex*,
      const finteger*,finteger*);

extern void F77CALL (clabrd) (const finteger*,const finteger*,const finteger*,
      fsinglecomplex*,const finteger*,fsingle*,fsingle*,fsinglecomplex*,
      fsinglecomplex*,fsinglecomplex*,const finteger*,fsinglecomplex*,
      finteger*);

extern void F77CALL (clacgv) (const finteger*,fsinglecomplex*,const finteger*);


extern void F77CALL (clacon) (const finteger*,fsinglecomplex*,
      fsinglecomplex*,fsingle*,finteger*);

extern void F77CALL (clacpy) (const char*,const finteger*,const finteger*,
      const fsinglecomplex*,const finteger*,fsinglecomplex*,const finteger*);

extern void F77CALL (clacrm) (const finteger*,const finteger*,
      const fsinglecomplex*,const finteger*,const fsingle*,const finteger*,
      const fsinglecomplex*,const finteger*,fsingle*);

extern void F77CALL (clacrt) (const finteger*,fsinglecomplex*,const finteger*,
      fsinglecomplex*,const finteger*,const fsinglecomplex*,
      const fsinglecomplex*);

#ifdef USE_F2C
extern void F77CALL (cladiv) (fsinglecomplex* ret_,const fsinglecomplex*,
      const fsinglecomplex*);
#else
extern fsinglecomplex F77CALL (cladiv) (const fsinglecomplex*,
      const fsinglecomplex*);
#endif

extern void F77CALL (claed0) (const finteger*,const finteger*,fsingle*,
      fsingle*,fsinglecomplex*,const finteger*,fsinglecomplex*,finteger*,
      fsingle*,const finteger*,finteger*);

extern void F77CALL (claed7) (const finteger*,const finteger*,const finteger*,
      const finteger*,const finteger*,const finteger*,fsingle*,fsinglecomplex*,
      const finteger*,const fsingle*,finteger*,fsingle*,finteger*,finteger*,
      finteger*,finteger*,const finteger*,const fsingle*,const fsinglecomplex*,
      const fsingle*,const finteger*,finteger*);

extern void F77CALL (claed8) (finteger*,const finteger*,const finteger*,
      fsinglecomplex*,const finteger*,fsingle*,fsingle*,const finteger*,
      const fsingle*,fsingle*,fsinglecomplex*,const finteger*,fsingle*,
      finteger*,finteger*,const finteger*,finteger*,finteger*,finteger*,
      fsingle*,finteger*);

extern void F77CALL (claein) (const flogical*,const flogical*,const finteger*,
      const fsinglecomplex*,const finteger*,const fsinglecomplex*,
      fsinglecomplex*,fsinglecomplex*,const finteger*,fsingle*,const fsingle*,
      const fsingle*,finteger*);

extern void F77CALL (claesy) (const fsinglecomplex*,const fsinglecomplex*,
      const fsinglecomplex*,fsinglecomplex*,fsinglecomplex*,fsinglecomplex*,
      fsinglecomplex*,fsinglecomplex*);

extern void F77CALL (claev2) (const fsinglecomplex*,const fsinglecomplex*,
      const fsinglecomplex*,fsingle*,fsingle*,fsingle*,fsinglecomplex*);

extern void F77CALL (clags2) (const flogical*,const fsingle*,
      const fsinglecomplex*,const fsingle*,const fsingle*,
      const fsinglecomplex*,const fsingle*,fsingle*,fsinglecomplex*,fsingle*,
      fsinglecomplex*,fsingle*,fsinglecomplex*);

extern void F77CALL (clagtm) (const char*,const finteger*,const finteger*,
      const fsingle*,const fsinglecomplex*,const fsinglecomplex*,
      const fsinglecomplex*,const fsinglecomplex*,const finteger*,
      const fsingle*,fsinglecomplex*,const finteger*);

extern void F77CALL (clahef) (const char*,const finteger*,const finteger*,
      finteger*,fsinglecomplex*,const finteger*,finteger*,fsinglecomplex*,
      const finteger*,finteger*);

extern void F77CALL (clahqr) (const flogical*,const flogical*,const finteger*,
      const finteger*,const finteger*,fsinglecomplex*,const finteger*,
      fsinglecomplex*,const finteger*,const finteger*,fsinglecomplex*,
      const finteger*,finteger*);

extern void F77CALL (clahrd) (const finteger*,const finteger*,const finteger*,
      fsinglecomplex*,const finteger*,fsinglecomplex*,fsinglecomplex*,
      const finteger*,fsinglecomplex*,const finteger*);

extern void F77CALL (claic1) (const finteger*,const finteger*,
      const fsinglecomplex*,const fsingle*,const fsinglecomplex*,
      const fsinglecomplex*,fsingle*,fsinglecomplex*,fsinglecomplex*);

#ifdef USE_F2C
extern fdouble F77CALL (clangb) (const char*,const finteger*,const finteger*,
      const finteger*,const fsinglecomplex*,const finteger*,fsingle*);

extern fdouble F77CALL (clange) (const char*,const finteger*,const finteger*,
      const fsinglecomplex*,const finteger*,fsingle*);

extern fdouble F77CALL (clangt) (const char*,const finteger*,
      const fsinglecomplex*,const fsinglecomplex*,const fsinglecomplex*);

extern fdouble F77CALL (clanhb) (const char*,const char*,const finteger*,
      const finteger*,const fsinglecomplex*,const finteger*,fsingle*);

extern fdouble F77CALL (clanhe) (const char*,const char*,const finteger*,
      const fsinglecomplex*,const finteger*,fsingle*);

extern fdouble F77CALL (clanhp) (const char*,const char*,const finteger*,
      const fsinglecomplex*,fsingle*);

extern fdouble F77CALL (clanhs) (const char*,const finteger*,
      const fsinglecomplex*,const finteger*,fsingle*);

extern fdouble F77CALL (clanht) (const char*,const finteger*,const fsingle*,
      const fsinglecomplex*);

extern fdouble F77CALL (clansb) (const char*,const char*,const finteger*,
      const finteger*, const fsinglecomplex*,const finteger*,fsingle*);

extern fdouble F77CALL (clansp) (const char*,const char*,const finteger*,
      const fsinglecomplex*,fsingle*);

extern fdouble F77CALL (clansy) (const char*,const char*,const finteger*,
      const fsinglecomplex*,const finteger*,fsingle*);

extern fdouble F77CALL (clantb) (const char*,const char*,const char*,
      const finteger*,const finteger*,const fsinglecomplex*,const finteger*,
      fsingle*);

extern fdouble F77CALL (clantp) (const char*,const char*,const char*,
      const finteger*,const fsinglecomplex*,fsingle*);

extern fdouble F77CALL (clantr) (const char*,const char*,const char*,
      const finteger*,const finteger*,const fsinglecomplex*,const finteger*,
      fsingle*);
#else
extern fsingle F77CALL (clangb) (const char*,const finteger*,const finteger*,
      const finteger*,const fsinglecomplex*,const finteger*,fsingle*);

extern fsingle F77CALL (clange) (const char*,const finteger*,const finteger*,
      const fsinglecomplex*,const finteger*,fsingle*);

extern fsingle F77CALL (clangt) (const char*,const finteger*,
      const fsinglecomplex*,const fsinglecomplex*,const fsinglecomplex*);

extern fsingle F77CALL (clanhb) (const char*,const char*,const finteger*,
      const finteger*,const fsinglecomplex*,const finteger*,fsingle*);

extern fsingle F77CALL (clanhe) (const char*,const char*,const finteger*,
      const fsinglecomplex*,const finteger*,fsingle*);

extern fsingle F77CALL (clanhp) (const char*,const char*,const finteger*,
      const fsinglecomplex*,fsingle*);

extern fsingle F77CALL (clanhs) (const char*,const finteger*,
      const fsinglecomplex*,const finteger*,fsingle*);

extern fsingle F77CALL (clanht) (const char*,const finteger*,const fsingle*,
      const fsinglecomplex*);

extern fsingle F77CALL (clansb) (const char*,const char*,const finteger*,
      const finteger*, const fsinglecomplex*,const finteger*,fsingle*);

extern fsingle F77CALL (clansp) (const char*,const char*,const finteger*,
      const fsinglecomplex*,fsingle*);

extern fsingle F77CALL (clansy) (const char*,const char*,const finteger*,
      const fsinglecomplex*,const finteger*,fsingle*);

extern fsingle F77CALL (clantb) (const char*,const char*,const char*,
      const finteger*,const finteger*,const fsinglecomplex*,const finteger*,
      fsingle*);

extern fsingle F77CALL (clantp) (const char*,const char*,const char*,
      const finteger*,const fsinglecomplex*,fsingle*);

extern fsingle F77CALL (clantr) (const char*,const char*,const char*,
      const finteger*,const finteger*,const fsinglecomplex*,const finteger*,
      fsingle*);
#endif

extern void F77CALL (clapll) (const finteger*,fsinglecomplex*,const finteger*,
      fsinglecomplex*,const finteger*,fsingle*);

extern void F77CALL (clapmt) (const flogical*,const finteger*,const finteger*,
      fsinglecomplex*,const finteger*,const finteger*);

extern void F77CALL (claqgb) (const finteger*,const finteger*,const finteger*,
      const finteger*,fsinglecomplex*,const finteger*,fsingle*,fsingle*,
      fsingle*,fsingle*,const fsingle*,char*);

extern void F77CALL (claqge) (const finteger*,const finteger*,fsinglecomplex*,
      const finteger*,const fsingle*,const fsingle*,const fsingle*,
      const fsingle*,const fsingle*,char*);

extern void F77CALL (claqhb) (const char*,const finteger*,const finteger*,
      fsinglecomplex*,const finteger*,fsingle*,const fsingle*,const fsingle*,
      char*);

extern void F77CALL (claqhe) (const char*,const finteger*,fsinglecomplex*,
      const finteger*,const fsingle*,const fsingle*,const fsingle*,char*);

extern void F77CALL (claqhp) (const char*,const finteger*,fsinglecomplex*,
      const fsingle*,const fsingle*,const fsingle*,char*);

extern void F77CALL (claqsb) (const char*,const finteger*,const finteger*,
      fsinglecomplex*,const finteger*,fsingle*,const fsingle*,const fsingle*,char*);

extern void F77CALL (claqsp) (const char*,const finteger*,fsinglecomplex*,
      const fsingle*,const fsingle*,const fsingle*,char*);

extern void F77CALL (claqsy) (const char*,const finteger*,fsinglecomplex*,
      const finteger*,const fsingle*,const fsingle*,const fsingle*,char*);

extern void F77CALL (clar2v) (const finteger*,fsinglecomplex*,fsinglecomplex*,
      fsinglecomplex*,const finteger*,const fsingle*,const fsinglecomplex*,
      const finteger*);

extern void F77CALL (clarf) (char*,finteger*,finteger*,fsinglecomplex*,
      finteger*,fsinglecomplex*,const fsinglecomplex*,finteger*,
      const fsinglecomplex*);

extern void F77CALL (clarfb) (const char*,const char*,const char*,const char*,
      const finteger*,const finteger*,const finteger*,const fsinglecomplex*,
      const finteger*,const fsinglecomplex*,const finteger*,fsinglecomplex*,
      const finteger*,fsinglecomplex*,const finteger*);

extern void F77CALL (clarfg) (const finteger*,fsinglecomplex*,fsinglecomplex*,
      const finteger*,fsinglecomplex*);

extern void F77CALL (clarft) (const char*,const char*,const finteger*,
      const finteger*,fsinglecomplex*,const finteger*,const fsinglecomplex*,
      fsinglecomplex*,const finteger*);

extern void F77CALL (clarfx) (const char*,const finteger*,const finteger*,
      const fsinglecomplex*,const fsinglecomplex*,fsinglecomplex*,
      const finteger*,fsinglecomplex*);

extern void F77CALL (clargv) (const finteger*,fsinglecomplex*,const finteger*,
      fsinglecomplex*,const finteger*,fsingle*,const finteger*);

extern void F77CALL (clarnv) (const finteger*,finteger*,const finteger*,
      fsinglecomplex*);

extern void F77CALL (clartg) (const fsinglecomplex*,const fsinglecomplex*,
      fsingle*,fsinglecomplex*,fsinglecomplex*);

extern void F77CALL (clartv) (const finteger*,fsinglecomplex*,const finteger*,
      fsinglecomplex*,const finteger*,const fsingle*,const fsinglecomplex*,
      const finteger*);

extern void F77CALL (clascl) (const char*,const finteger*,const finteger*,
      const fsingle*,const fsingle*,const finteger*,const finteger*,
      fsinglecomplex*,const finteger*,finteger*);

extern void F77CALL (claset) (const char*,const finteger*,const finteger*,
      const fsinglecomplex*,const fsinglecomplex*,fsinglecomplex*,
      const finteger*);

extern void F77CALL (clasr) (const char*,const char*,const char*,
      const finteger*,const finteger*,const fsingle*,const fsingle*,
      fsinglecomplex*,const finteger*);

extern void F77CALL (classq) (const finteger*,const fsinglecomplex*,
      const finteger*,fsingle*,fsingle*);

extern void F77CALL (claswp) (const finteger*,fsinglecomplex*,const finteger*,
      const finteger*,const finteger*,const finteger*,const finteger*);

extern void F77CALL (clasyf) (const char*,const finteger*,const finteger*,
      finteger*,fsinglecomplex*,const finteger*,finteger*,fsinglecomplex*,
      const finteger*,finteger*);

extern void F77CALL (clatbs) (const char*,const char*,const char*,const char*,
      const finteger*,const finteger*,const fsinglecomplex*,const finteger*,
      fsinglecomplex*,fsingle*,fsingle*,finteger*);

extern void F77CALL (clatps) (const char*,const char*,const char*,const char*,
      const finteger*,const fsinglecomplex*,fsinglecomplex*,fsingle*,fsingle*,
      finteger*);

extern void F77CALL (clatrd) (const char*,const finteger*,const finteger*,
      fsinglecomplex*,const finteger*,fsingle*,fsinglecomplex*,
      fsinglecomplex*,const finteger*);

extern void F77CALL (clatrs) (const char*,const char*,const char*,const char*,
      const finteger*,const fsinglecomplex*,const finteger*,fsinglecomplex*,
      fsingle*,fsingle*,finteger*);

extern void F77CALL (clatzm) (const char*,const finteger*,const finteger*,
      const fsinglecomplex*,const finteger*,const fsinglecomplex*,
      fsinglecomplex*,fsinglecomplex*,const finteger*,fsinglecomplex*);

extern void F77CALL (clauu2) (const char*,const finteger*,fsinglecomplex*,
      const finteger*,finteger*);

extern void F77CALL (clauum) (const char*,const finteger*,fsinglecomplex*,
      const finteger*,finteger*);

extern void F77CALL (cpbcon) (const char*,const finteger*,const finteger*,
      const fsinglecomplex*,const finteger*,const fsingle*,fsingle*,
      fsinglecomplex*,fsingle*,finteger*);

extern void F77CALL (cpbequ) (const char*,const finteger*,const finteger*,
      const fsinglecomplex*,const finteger*,fsingle*,fsingle*,fsingle*,
      finteger*);

extern void F77CALL (cpbrfs) (const char*,const finteger*,const finteger*,
      const finteger*,const fsinglecomplex*,const finteger*,
      const fsinglecomplex*,const finteger*,const fsinglecomplex*,
      const finteger*,fsinglecomplex*,const finteger*,fsingle*,fsingle*,
      fsinglecomplex*,fsingle*,finteger*);

extern void F77CALL (cpbstf) (const char*,const finteger*,const finteger*,
      fsinglecomplex*,const finteger*,finteger*);

extern void F77CALL (cpbsv) (const char*,const finteger*,const finteger*,
      const finteger*,fsinglecomplex*,const finteger*,fsinglecomplex*,
      const finteger*,finteger*);

extern void F77CALL (cpbsvx) (const char*,const char*,const finteger*,
      const finteger*,const finteger*,fsinglecomplex*,const finteger*,
      fsinglecomplex*,const finteger*,char*,fsingle*,fsinglecomplex*,
      const finteger*,fsinglecomplex*,const finteger*,fsingle*,fsingle*,
      fsingle*,fsinglecomplex*,fsingle*,finteger*);

extern void F77CALL (cpbtf2) (const char*,const finteger*,const finteger*,
      fsinglecomplex*,const finteger*,finteger*);

extern void F77CALL (cpbtrf) (const char*,const finteger*,const finteger*,
      fsinglecomplex*,const finteger*,finteger*);

extern void F77CALL (cpbtrs) (const char*,const finteger*,const finteger*,
      const finteger*,const fsinglecomplex*,const finteger*,fsinglecomplex*,
      const finteger*,finteger*);

extern void F77CALL (cpocon) (const char*,const finteger*,
      const fsinglecomplex*,const finteger*,const fsingle*,fsingle*,
      fsinglecomplex*,fsingle*,finteger*);

extern void F77CALL (cpoequ) (const finteger*,const fsinglecomplex*,
      const finteger*,fsingle*,fsingle*,fsingle*,finteger*);

extern void F77CALL (cporfs) (const char*,const finteger*,const finteger*,
      const fsinglecomplex*,const finteger*,const fsinglecomplex*,
      const finteger*,const fsinglecomplex*,const finteger*,fsinglecomplex*,
      const finteger*,fsingle*,fsingle*,fsinglecomplex*,fsingle*,finteger*);

extern void F77CALL (cposv) (const char*,const finteger*,const finteger*,
      fsinglecomplex*,const finteger*,fsinglecomplex*,const finteger*,
      finteger*);

extern void F77CALL (cposvx) (const char*,const char*,const finteger*,
      const finteger*,fsinglecomplex*,const finteger*,fsinglecomplex*,
      const finteger*,char*,fsingle*,fsinglecomplex*,const finteger*,
      fsinglecomplex*,const finteger*,fsingle*,fsingle*,fsingle*,
      fsinglecomplex*,fsingle*,finteger*);

extern void F77CALL (cpotf2) (const char*,const finteger*,fsinglecomplex*,
      const finteger*,finteger*);

extern void F77CALL (cpotrf) (const char*,const finteger*,fsinglecomplex*,
      const finteger*,finteger*);

extern void F77CALL (cpotri) (const char*,const finteger*,fsinglecomplex*,
      const finteger*,finteger*);

extern void F77CALL (cpotrs) (const char*,const finteger*,const finteger*,
      const fsinglecomplex*,const finteger*,fsinglecomplex*,const finteger*,
      finteger*);

extern void F77CALL (cppcon) (const char*,const finteger*,
      const fsinglecomplex*,const fsingle*,fsingle*,fsinglecomplex*,fsingle*,
      finteger*);

extern void F77CALL (cppequ) (const char*,const finteger*,
      const fsinglecomplex*,fsingle*,fsingle*,fsingle*,finteger*);

extern void F77CALL (cpprfs) (const char*,const finteger*,const finteger*,
      const fsinglecomplex*,const fsinglecomplex*,const fsinglecomplex*,
      const finteger*,fsinglecomplex*,const finteger*,fsingle*,fsingle*,
      fsinglecomplex*,fsingle*,finteger*);

extern void F77CALL (cppsv) (const char*,const finteger*,const finteger*,
      fsinglecomplex*,fsinglecomplex*,const finteger*,finteger*);

extern void F77CALL (cppsvx) (const char*,const char*,const finteger*,
      const finteger*,fsinglecomplex*,fsinglecomplex*,char*,fsingle*,
      fsinglecomplex*,const finteger*,fsinglecomplex*,const finteger*,fsingle*,
      fsingle*,fsingle*,fsinglecomplex*,fsingle*,finteger*);

extern void F77CALL (cpptrf) (const char*,const finteger*,fsinglecomplex*,
      finteger*);

extern void F77CALL (cpptri) (const char*,const finteger*,fsinglecomplex*,
      finteger*);

extern void F77CALL (cpptrs) (const char*,const finteger*,const finteger*,
      const fsinglecomplex*,fsinglecomplex*,const finteger*,finteger*);

extern void F77CALL (cptcon) (const finteger*,const fsingle*,
      const fsinglecomplex*,const fsingle*,fsingle*,fsingle*,finteger*);

extern void F77CALL (cpteqr) (const char*,const finteger*,fsingle*,fsingle*,
      fsinglecomplex*,const finteger*,fsingle*,finteger*);

extern void F77CALL (cptrfs) (const char*,const finteger*,const finteger*,
      const fsingle*,const fsinglecomplex*,const fsingle*,
      const fsinglecomplex*,const fsinglecomplex*,const finteger*,
      fsinglecomplex*,const finteger*,fsingle*,fsingle*,fsinglecomplex*,
      fsingle*,finteger*);

extern void F77CALL (cptsv) (const finteger*,const finteger*,fsingle*,
      fsinglecomplex*,fsinglecomplex*,const finteger*,finteger*);

extern void F77CALL (cptsvx) (const char*,const finteger*,const finteger*,
      const fsingle*,const fsinglecomplex*,fsingle*,fsinglecomplex*,
      const fsinglecomplex*,const finteger*,fsinglecomplex*,const finteger*,
      fsingle*,fsingle*,fsingle*,fsinglecomplex*,fsingle*,finteger*);

extern void F77CALL (cpttrf) (const finteger*,fsingle*,fsinglecomplex*,
      finteger*);

extern void F77CALL (cpttrs) (const char*,const finteger*,const finteger*,
      const fsingle*,const fsinglecomplex*,fsinglecomplex*,const finteger*,
      finteger*);

extern void F77CALL (crot) (const finteger*,fsinglecomplex*,const finteger*,
      fsinglecomplex*,const finteger*,const fsingle*,const fsinglecomplex*);

extern void F77CALL (cspcon) (const char*,const finteger*,
      const fsinglecomplex*,const finteger*,const fsingle*,fsingle*,
      fsinglecomplex*,finteger*);

extern void F77CALL (cspmv) (const char*,const finteger*,const fsinglecomplex*,
      const fsinglecomplex*,const fsinglecomplex*,const finteger*,
      const fsinglecomplex*,fsinglecomplex*,const finteger*);

extern void F77CALL (cspr) (const char*,const finteger*,const fsinglecomplex*,
      const fsinglecomplex*,const finteger*,fsinglecomplex*);

extern void F77CALL (csprfs) (const char*,const finteger*,const finteger*,
      const fsinglecomplex*,const fsinglecomplex*,const finteger*,
      const fsinglecomplex*,const finteger*,fsinglecomplex*,const finteger*,
      fsingle*,fsingle*,fsinglecomplex*,fsingle*,finteger*);

extern void F77CALL (cspsv) (const char*,const finteger*,const finteger*,
      fsinglecomplex*,finteger*,fsinglecomplex*,const finteger*,finteger*);

extern void F77CALL (cspsvx) (const char*,const char*,const finteger*,
      const finteger*,const fsinglecomplex*,fsinglecomplex*,finteger*,
      const fsinglecomplex*,const finteger*,fsinglecomplex*,const finteger*,
      fsingle*,fsingle*,fsingle*,fsinglecomplex*,fsingle*,finteger*);

extern void F77CALL (csptrf) (const char*,const finteger*,fsinglecomplex*,
      finteger*,finteger*);

extern void F77CALL (csptri) (const char*,const finteger*,fsinglecomplex*,
      const finteger*,fsinglecomplex*,finteger*);

extern void F77CALL (csptrs) (const char*,const finteger*,const finteger*,
      const fsinglecomplex*, const finteger*,fsinglecomplex*,const finteger*,
      finteger*);

extern void F77CALL (csrot) (const finteger*,fsinglecomplex*,const finteger*,
      fsinglecomplex*,const finteger*,const fsingle*,const fsingle*);

extern void F77CALL (csrscl) (const finteger*,const fsingle*,fsinglecomplex*,
      const finteger*);

extern void F77CALL (cstedc) (const char*,const finteger*,fsingle*,fsingle*,
      fsinglecomplex*,const finteger*,fsinglecomplex*,const finteger*,fsingle*,
      const finteger*,finteger*,const finteger*,finteger*);

extern void F77CALL (cstein) (const finteger*,const fsingle*,const fsingle*,
      const finteger*,const fsingle*,const finteger*,const finteger*,
      fsinglecomplex*,const finteger*,fsingle*,finteger*,finteger*,finteger*);

extern void F77CALL (csteqr) (const char*,const finteger*,fsingle*,fsingle*,
      fsinglecomplex*,const finteger*,fsingle*,finteger*);

extern void F77CALL (csycon) (const char*,const finteger*,
      const fsinglecomplex*,const finteger*,const finteger*,const fsingle*,
      fsingle*,fsinglecomplex*,finteger*);

extern void F77CALL (csymv) (const char*,const finteger*,const fsinglecomplex*,
      const fsinglecomplex*,const finteger*,const fsinglecomplex*,
      const finteger*,const fsinglecomplex*,fsinglecomplex*,const finteger*);

extern void F77CALL (csyr) (const char*,const finteger*,const fsinglecomplex*,
      const fsinglecomplex*,const finteger*,fsinglecomplex*,const finteger*);

extern void F77CALL (csyrfs) (const char*,const finteger*,const finteger*,
      const fsinglecomplex*,const finteger*,const fsinglecomplex*,
      const finteger*,const finteger*,const fsinglecomplex*,const finteger*,
      fsinglecomplex*,const finteger*,fsingle*,fsingle*,fsinglecomplex*,
      fsingle*,finteger*);

extern void F77CALL (csysv) (const char*,const finteger*,const finteger*,
      fsinglecomplex*,const finteger*,finteger*,fsinglecomplex*,
      const finteger*,fsinglecomplex*,const finteger*,finteger*);

extern void F77CALL (csysvx) (const char*,const char*,const finteger*,
      const finteger*,const fsinglecomplex*,const finteger*,fsinglecomplex*,
      const finteger*,finteger*,const fsinglecomplex*,const finteger*,
      fsinglecomplex*,const finteger*,fsingle*,fsingle*,fsingle*,
      fsinglecomplex*,const finteger*,fsingle*,finteger*);

extern void F77CALL (csytf2) (const char*,const finteger*,fsinglecomplex*,
      const finteger*,finteger*,finteger*);

extern void F77CALL (csytrf) (const char*,const finteger*,fsinglecomplex*,
      const finteger*,finteger*,fsinglecomplex*,const finteger*,finteger*);

extern void F77CALL (csytri) (const char*,const finteger*,fsinglecomplex*,
      const finteger*,const finteger*,fsinglecomplex*,finteger*);

extern void F77CALL (csytrs) (const char*,const finteger*,const finteger*,
      const fsinglecomplex*,const finteger*,const finteger*,fsinglecomplex*,
      const finteger*,finteger*);

extern void F77CALL (ctbcon) (const char*,const char*,const char*,
      const finteger*,const finteger*,const fsinglecomplex*,const finteger*,
      fsingle*,fsinglecomplex*,fsingle*,finteger*);

extern void F77CALL (ctbrfs) (const char*,const char*,const char*,
      const finteger*,const finteger*,const finteger*,const fsinglecomplex*,
      const finteger*,const fsinglecomplex*,const finteger*,
      const fsinglecomplex*,const finteger*,fsingle*,fsingle*,fsinglecomplex*,
      fsingle*,finteger*);

extern void F77CALL (ctbtrs) (const char*,const char*,const char*,
      const finteger*,const finteger*,const finteger*,const fsinglecomplex*,
      const finteger*,fsinglecomplex*,const finteger*,finteger*);

extern void F77CALL (ctgevc) (const char*,const char*,const flogical*,
      const finteger*,const fsinglecomplex*,const finteger*,
      const fsinglecomplex*,const finteger*,fsinglecomplex*,const finteger*,
      fsinglecomplex*,const finteger*,const finteger*,finteger*,
      fsinglecomplex*,fsingle*,finteger*);

extern void F77CALL (ctgsja) (const char*,const char*,const char*,
      const finteger*,const finteger*,const finteger*,const finteger*,
      const finteger*,fsinglecomplex*,const finteger*,fsinglecomplex*,
      const finteger*,const fsingle*,const fsingle*,fsingle*,fsingle*,
      fsinglecomplex*,const finteger*,fsinglecomplex*,const finteger*,
      fsinglecomplex*,const finteger*,fsinglecomplex*,finteger*,finteger*);

extern void F77CALL (ctpcon) (const char*,const char*,const char*,
      const finteger*,const fsinglecomplex*,fsingle*,fsinglecomplex*,fsingle*,
      finteger*);

extern void F77CALL (ctprfs) (const char*,const char*,const char*,
      const finteger*,const finteger*,const fsinglecomplex*,
      const fsinglecomplex*,const finteger*,const fsinglecomplex*,
      const finteger*,fsingle*,fsingle*,fsinglecomplex*,fsingle*,finteger*);

extern void F77CALL (ctptri) (const char*,const char*,const finteger*,
      fsinglecomplex*,finteger*);

extern void F77CALL (ctptrs) (const char*,const char*,const char*,
      const finteger*,const finteger*,const fsinglecomplex*,fsinglecomplex*,
      const finteger*,finteger*);

extern void F77CALL (ctrcon) (const char*,const char*,const char*,
      const finteger*,const fsinglecomplex*,const finteger*,fsingle*,
      fsinglecomplex*,fsingle*,finteger*);

extern void F77CALL (ctrevc) (const char*,const char*,const flogical*,
      const finteger*,fsinglecomplex*,const finteger*,fsinglecomplex*,
      const finteger*,fsinglecomplex*,const finteger*,const finteger*,
      finteger*,fsinglecomplex*,fsingle*,finteger*);

extern void F77CALL (ctrexc) (const char*,const finteger*,fsinglecomplex*,
      const finteger*,fsinglecomplex*,const finteger*,const finteger*,
      const finteger*,finteger*);

extern void F77CALL (ctrrfs) (const char*,const char*,const char*,
      const finteger*,const finteger*,const fsinglecomplex*,const finteger*,
      const fsinglecomplex*,const finteger*,const fsinglecomplex*,
      const finteger*,fsingle*,fsingle*,fsinglecomplex*,fsingle*,finteger*);

extern void F77CALL (ctrsen) (const char*,const char*,const flogical*,
      const finteger*,fsinglecomplex*,const finteger*,fsinglecomplex*,
      const finteger*,fsinglecomplex*,finteger*,fsingle*,fsingle*,
      fsinglecomplex*,const finteger*,finteger*);

extern void F77CALL (ctrsna) (const char*,const char*,const flogical*,
      const finteger*,const fsinglecomplex*,const finteger*,
      const fsinglecomplex*,const finteger*,const fsinglecomplex*,
      const finteger*,fsingle*,fsingle*,const finteger*,finteger*,
      fsinglecomplex*,const finteger*,fsingle*,finteger*);

extern void F77CALL (ctrsyl) (const char*,const char*,const finteger*,
      const finteger*,const finteger*,const fsinglecomplex*,const finteger*,
      const fsinglecomplex*,const finteger*,fsinglecomplex*,const finteger*,
      fsingle*,finteger*);

extern void F77CALL (ctrti2) (const char*,const char*,const finteger*,
      fsinglecomplex*,const finteger*,finteger*);

extern void F77CALL (ctrtri) (const char*,const char*,const finteger*,
      fsinglecomplex*,const finteger*,finteger*);

extern void F77CALL (ctrtrs) (const char*,const char*,const char*,
      const finteger*,const finteger*,const fsinglecomplex*,const finteger*,
      fsinglecomplex*,const finteger*,finteger*);

extern void F77CALL (ctzrqf) (const finteger*,const finteger*,fsinglecomplex*,
      const finteger*,fsinglecomplex*,finteger*);

extern void F77CALL (cung2l) (const finteger*,const finteger*,const finteger*,
      fsinglecomplex*,const finteger*,const fsinglecomplex*,fsinglecomplex*,
      finteger*);

extern void F77CALL (cung2r) (const finteger*,const finteger*,const finteger*,
      fsinglecomplex*,const finteger*,const fsinglecomplex*,fsinglecomplex*,
      finteger*);

extern void F77CALL (cungbr) (const char*,const finteger*,const finteger*,
      const finteger*,fsinglecomplex*,const finteger*,const fsinglecomplex*,
      fsinglecomplex*,const finteger*,finteger*);

extern void F77CALL (cunghr) (const finteger*,const finteger*,const finteger*,
      fsinglecomplex*,const finteger*,const fsinglecomplex*,fsinglecomplex*,
      const finteger*,finteger*);

extern void F77CALL (cungl2) (const finteger*,const finteger*,const finteger*,
      fsinglecomplex*,const finteger*,const fsinglecomplex*,fsinglecomplex*,
      finteger*);

extern void F77CALL (cunglq) (const finteger*,const finteger*,const finteger*,
      fsinglecomplex*,const finteger*,const fsinglecomplex*,fsinglecomplex*,
      const finteger*,finteger*);

extern void F77CALL (cungql) (const finteger*,const finteger*,const finteger*,
      fsinglecomplex*,const finteger*,const fsinglecomplex*,fsinglecomplex*,
      const finteger*,finteger*);

extern void F77CALL (cungqr) (const finteger*,const finteger*,const finteger*,
      fsinglecomplex*,const finteger*,const fsinglecomplex*,fsinglecomplex*,
      const finteger*,finteger*);

extern void F77CALL (cungr2) (const finteger*,const finteger*,const finteger*,
      fsinglecomplex*,const finteger*,const fsinglecomplex*,fsinglecomplex*,
      finteger*);

extern void F77CALL (cungrq) (const finteger*,const finteger*,const finteger*,
      fsinglecomplex*,const finteger*,const fsinglecomplex*,fsinglecomplex*,
      const finteger*,finteger*);

extern void F77CALL (cungtr) (const char*,const finteger*,fsinglecomplex*,
      const finteger*,const fsinglecomplex*,fsinglecomplex*,const finteger*,
      finteger*);

extern void F77CALL (cunm2l) (const char*,const char*,const finteger*,
      const finteger*,const finteger*,const fsinglecomplex*,const finteger*,
      const fsinglecomplex*,fsinglecomplex*,const finteger*,fsinglecomplex*,
      finteger*);

extern void F77CALL (cunm2r) (const char*,const char*,const finteger*,
      const finteger*,const finteger*,const fsinglecomplex*,const finteger*,
      const fsinglecomplex*,fsinglecomplex*,const finteger*,fsinglecomplex*,
      finteger*);

extern void F77CALL (cunmbr) (const char*,const char*,const char*,
      const finteger*,const finteger*,const finteger*,const fsinglecomplex*,
      const finteger*,const fsinglecomplex*,fsinglecomplex*,const finteger*,
      fsinglecomplex*,const finteger*,finteger*);

extern void F77CALL (cunmhr) (const char*,const char*,const finteger*,
      const finteger*,const finteger*,const finteger*,const fsinglecomplex*,
      const finteger*,const fsinglecomplex*,fsinglecomplex*,const finteger*,
      fsinglecomplex*,const finteger*,finteger*);

extern void F77CALL (cunml2) (const char*,const char*,const finteger*,
      const finteger*,const finteger*,const fsinglecomplex*,const finteger*,
      const fsinglecomplex*,fsinglecomplex*,const finteger*,fsinglecomplex*,
      finteger*);

extern void F77CALL (cunmlq) (const char*,const char*,const finteger*,
      const finteger*,const finteger*,const fsinglecomplex*,const finteger*,
      const fsinglecomplex*,fsinglecomplex*,const finteger*,fsinglecomplex*,
      const finteger*,finteger*);

extern void F77CALL (cunmql) (const char*,const char*,const finteger*,
      const finteger*,const finteger*,const fsinglecomplex*,const finteger*,
      const fsinglecomplex*,fsinglecomplex*,const finteger*,fsinglecomplex*,
      const finteger*,finteger*);

extern void F77CALL (cunmqr) (const char*,const char*,const finteger*,
      const finteger*,const finteger*,const fsinglecomplex*,const finteger*,
      const fsinglecomplex*,fsinglecomplex*,const finteger*,fsinglecomplex*,
      const finteger*,finteger*);

extern void F77CALL (cunmr2) (const char*,const char*,const finteger*,
      const finteger*,const finteger*,const fsinglecomplex*,const finteger*,
      const fsinglecomplex*,fsinglecomplex*,const finteger*,fsinglecomplex*,
      finteger*);

extern void F77CALL (cunmrq) (const char*,const char*,const finteger*,
      const finteger*,const finteger*,const fsinglecomplex*,const finteger*,
      const fsinglecomplex*,fsinglecomplex*,const finteger*,fsinglecomplex*,
      const finteger*,finteger*);

extern void F77CALL (cunmtr) (const char*,const char*,const char*,
      const finteger*,const finteger*,const fsinglecomplex*,const finteger*,
      const fsinglecomplex*,fsinglecomplex*,const finteger*,fsinglecomplex*,
      const finteger*,finteger*);

extern void F77CALL (cupgtr) (const char*,const finteger*,
      const fsinglecomplex*,const fsinglecomplex*,fsinglecomplex*,
      const finteger*,fsinglecomplex*,finteger*);

extern void F77CALL (cupmtr) (const char*,const char*,const char*,
      const finteger*,const finteger*,const fsinglecomplex*,
      const fsinglecomplex*,fsinglecomplex*,const finteger*,
      fsinglecomplex*,finteger*);

extern void F77CALL (dbdsqr) (const char*,const finteger*,const finteger*,
      const finteger*,const finteger*,fdouble*,fdouble*,fdouble*,
      const finteger*,fdouble*,const finteger*,fdouble*,const finteger*,
      fdouble*,finteger*);

extern void F77CALL (ddisna) (const char*,const finteger*,const finteger*,
      const fdouble*,fdouble*,finteger*);

extern void F77CALL (dgbbrd) (const char*,const finteger*,const finteger*,
      const finteger*,const finteger*,const finteger*,fdouble*,const finteger*,
      fdouble*,fdouble*,fdouble*,const finteger*,fdouble*,const finteger*,
      fdouble*,const finteger*,fdouble*,finteger*);

extern void F77CALL (dgbcon) (const char*,const finteger*,const finteger*,
      const finteger*,const fdouble*,const finteger*,const finteger*,
      const fdouble*,fdouble*,fdouble*,finteger*,finteger*);

extern void F77CALL (dgbequ) (const finteger*,const finteger*,const finteger*,
      const finteger*,const fdouble*,const finteger*,fdouble*,fdouble*,
      fdouble*,fdouble*,fdouble*,finteger*);

extern void F77CALL (dgbrfs) (const char*,const finteger*,const
      finteger*,const finteger*,const finteger*,const fdouble*,const
      finteger*,const fdouble*,const finteger*,const finteger*,const
      fdouble*,const finteger*,fdouble*,const finteger*,fdouble*,fdouble*,
      fdouble*,finteger*,finteger*);

extern void F77CALL (dgbsv) (const finteger*,const finteger*,const finteger*,
      const finteger*,fdouble*,const finteger*,finteger*,fdouble*,
      const finteger*,finteger*);

extern void F77CALL (dgbsvx) (const char*,const char*,const finteger*,
      const finteger*,const finteger*,const finteger*,fdouble*,
      const finteger*,fdouble*,const finteger*,finteger*,char*,fdouble*,
      fdouble*,fdouble*,const finteger*,fdouble*,const finteger*,fdouble*,
      fdouble*,fdouble*,fdouble*,finteger*,finteger*);

extern void F77CALL (dgbtf2) (const finteger*,const finteger*,const finteger*,
      const finteger*,fdouble*,const finteger*,finteger*,finteger*);

extern void F77CALL (dgbtrf) (const finteger*,const finteger*,const finteger*,
      const finteger*,fdouble*,const finteger*,finteger*,finteger*);

extern void F77CALL (dgbtrs) (const char*,const finteger*,const finteger*,
      const finteger*,const finteger*,const fdouble*,const finteger*,
      const finteger*,fdouble*,const finteger*,finteger*);

extern void F77CALL (dgebak) (const char*,const char*,const finteger*,
      const finteger*,const finteger*,const fdouble*,const finteger*,fdouble*,
      const finteger*,finteger*);

extern void F77CALL (dgebal) (const char*,const finteger*,fdouble*,
      const finteger*,finteger*,finteger*,fdouble*,finteger*);

extern void F77CALL (dgebd2) (const finteger*,const finteger*,fdouble*,
      const finteger*,fdouble*,fdouble*,fdouble*,fdouble*,fdouble*,finteger*);

extern void F77CALL (dgebrd) (const finteger*,const finteger*,fdouble*,
      const finteger*,fdouble*,fdouble*,fdouble*,fdouble*,fdouble*,
      const finteger*,finteger*);

extern void F77CALL (dgecon) (const char*,const finteger*,const fdouble*,
      const finteger*,const fdouble*,fdouble*,fdouble*,finteger*,finteger*);

extern void F77CALL (dgeequ) (const finteger*,const finteger*,const fdouble*,
      const finteger*,fdouble*,fdouble*,fdouble*,fdouble*,fdouble*,finteger*);

extern void F77CALL (dgees) (const char*,const char*,fdselectfunction,
      const finteger*,fdouble*,const finteger*,finteger*,fdouble*,fdouble*,
      fdouble*,const finteger*,fdouble*,const finteger*,flogical*,finteger*);

extern void F77CALL (dgeesx) (const char*,const char*,fdselectfunction,
      const char*,const finteger*,fdouble*,const finteger*,finteger*,fdouble*,
      fdouble*,fdouble*,const finteger*,fdouble*,fdouble*,fdouble*,
      const finteger*,finteger*,const finteger*,flogical*,finteger*);

extern void F77CALL (dgeev) (const char*,const char*,const finteger*,fdouble*,
      const finteger*,fdouble*,fdouble*,fdouble*,const finteger*,fdouble*,
      const finteger*,fdouble*,const finteger*,finteger*);

extern void F77CALL (dgeevx) (const char*,const char*,const char*,const char*,
      const finteger*,fdouble*,const finteger*,fdouble*,fdouble*,fdouble*,
      const finteger*,fdouble*,const finteger*,finteger*,finteger*,fdouble*,
      fdouble*,fdouble*,fdouble*,fdouble*,const finteger*,finteger*,finteger*);

extern void F77CALL (dgegs) (const char*,const char*,const finteger*,fdouble*,
      const finteger*,fdouble*,const finteger*,fdouble*,fdouble*,fdouble*,
      fdouble*,const finteger*,fdouble*,const finteger*,fdouble*,
      const finteger*,finteger*);

extern void F77CALL (dgegv) (const char*,const char*,const finteger*,fdouble*,
      const finteger*,fdouble*,const finteger*,fdouble*,fdouble*,fdouble*,
      fdouble*,const finteger*,fdouble*,const finteger*,fdouble*,
      const finteger*,finteger*);

extern void F77CALL (dgehd2) (const finteger*,const finteger*,const finteger*,
      fdouble*,const finteger*,fdouble*,fdouble*,finteger*);

extern void F77CALL (dgehrd) (const finteger*,const finteger*,const finteger*,
      fdouble*,const finteger*,fdouble*,fdouble*,const finteger*,finteger*);

extern void F77CALL (dgelq2) (const finteger*,const finteger*,fdouble*,
      const finteger*,fdouble*,fdouble*,finteger*);

extern void F77CALL (dgelqf) (const finteger*,const finteger*,fdouble*,
      const finteger*,fdouble*,fdouble*,const finteger*,finteger*);

extern void F77CALL (dgels) (const char*,const finteger*,const finteger*,
      const finteger*,fdouble*,const finteger*,fdouble*,const finteger*,
      fdouble*,const finteger*,finteger*);

extern void F77CALL (dgelss) (const finteger*,const finteger*,const finteger*,
      fdouble*,const finteger*,fdouble*,const finteger*,fdouble*,
      const fdouble*,finteger*,fdouble*,const finteger*,finteger*);

extern void F77CALL (dgelsx) (const finteger*,const finteger*,const finteger*,
      fdouble*,const finteger*,fdouble*,const finteger*,finteger*,
      const fdouble*,finteger*,fdouble*,finteger*);

extern void F77CALL (dgeql2) (const finteger*,const finteger*,fdouble*,
      const finteger*,fdouble*,fdouble*,finteger*);

extern void F77CALL (dgeqlf) (const finteger*,const finteger*,fdouble*,
      const finteger*,fdouble*,fdouble*,const finteger*,finteger*);

extern void F77CALL (dgeqpf) (const finteger*,const finteger*,fdouble*,
      const finteger*,finteger*,fdouble*,fdouble*,finteger*);

extern void F77CALL (dgeqr2) (const finteger*,const finteger*,fdouble*,
      const finteger*,fdouble*,fdouble*,finteger*);

extern void F77CALL (dgeqrf) (const finteger*,const finteger*,fdouble*,
      const finteger*,fdouble*,fdouble*,const finteger*,finteger*);

extern void F77CALL (dgerfs) (const char*,const finteger*,const finteger*,
      const fdouble*,const finteger*,const fdouble*,const finteger*,
      const finteger*,const fdouble*,const finteger*,fdouble*,const finteger*,
      fdouble*,fdouble*,fdouble*,finteger*,finteger*);

extern void F77CALL (dgerq2) (const finteger*,const finteger*,fdouble*,
      const finteger*,fdouble*,fdouble*,finteger*);

extern void F77CALL (dgerqf) (const finteger*,const finteger*,fdouble*,
      const finteger*,fdouble*,fdouble*,const finteger*,finteger*);

extern void F77CALL (dgesv) (const finteger*,const finteger*,fdouble*,
      const finteger*,finteger*,fdouble*,const finteger*,finteger*);

extern void F77CALL (dgesvd) (const char*,const char*,const finteger*,
      const finteger*,fdouble*,const finteger*,fdouble*,fdouble*,
      const finteger*,fdouble*,const finteger*,fdouble*,const finteger*,
      finteger*);

extern void F77CALL (dgesvx) (const char*,const char*,const finteger*,
      const finteger*,fdouble*,const finteger*,fdouble*,const finteger*,
      finteger*,char*,fdouble*,fdouble*,fdouble*,const finteger*,fdouble*,
      const finteger*,fdouble*,fdouble*,fdouble*,fdouble*,finteger*,finteger*);

extern void F77CALL (dgetf2) (const finteger*,const finteger*,fdouble*,
      const finteger*,finteger*,finteger*);

extern void F77CALL (dgetrf) (const finteger*,const finteger*,fdouble*,
      const finteger*,finteger*,finteger*);

extern void F77CALL (dgetri) (const finteger*,fdouble*,const finteger*,
      const finteger*,fdouble*,const finteger*,finteger*);

extern void F77CALL (dgetrs) (const char*,const finteger*,const finteger*,
      const fdouble*,const finteger*,const finteger*,fdouble*,const finteger*,
      finteger*);

extern void F77CALL (dggbak) (const char*,const char*,const finteger*,
      const finteger*,const finteger*,const fdouble*,const fdouble*,
      const finteger*,fdouble*,const finteger*,finteger*);

extern void F77CALL (dggbal) (const char*,const finteger*,fdouble*,
      const finteger*,fdouble*,const finteger*,finteger*,finteger*,fdouble*,
      fdouble*,fdouble*,finteger*);

extern void F77CALL (dggglm) (const finteger*,const finteger*,const finteger*,
      fdouble*,const finteger*,fdouble*,const finteger*,fdouble*,fdouble*,
      fdouble*,fdouble*,const finteger*,finteger*);

extern void F77CALL (dgghrd) (const char*,const char*,const finteger*,
      const finteger*,const finteger*,fdouble*,const finteger*,fdouble*,
      const finteger*,fdouble*,const finteger*,fdouble*,const finteger*,
      finteger*);

extern void F77CALL (dgglse) (const finteger*,const finteger*,const finteger*,
      fdouble*,const finteger*,fdouble*,const finteger*,fdouble*,fdouble*,
      fdouble*,fdouble*,const finteger*,finteger*);

extern void F77CALL (dggqrf) (const finteger*,const finteger*,const finteger*,
      fdouble*,const finteger*,fdouble*,fdouble*,const finteger*,fdouble*,
      fdouble*,const finteger*,finteger*);

extern void F77CALL (dggrqf) (const finteger*,const finteger*,const finteger*,
      fdouble*,const finteger*,fdouble*,fdouble*,const finteger*,fdouble*,
      fdouble*,const finteger*,finteger*);

extern void F77CALL (dggsvd) (const char*,const char*,const char*,
      const finteger*,const finteger*,const finteger*,finteger*,finteger*,
      fdouble*,const finteger*,fdouble*,const finteger*,fdouble*,fdouble*,
      fdouble*,const finteger*,fdouble*,const finteger*,fdouble*,
      const finteger*,fdouble*,finteger*,finteger*);

extern void F77CALL (dggsvp) (const char*,const char*,const char*,
      const finteger*,const finteger*,const finteger*,fdouble*,const finteger*,
      fdouble*,const finteger*,const fdouble*,const fdouble*,finteger*,
      finteger*,fdouble*,const finteger*,fdouble*,const finteger*,fdouble*,
      const finteger*,finteger*,fdouble*,fdouble*,finteger*);

extern void F77CALL (dgtcon) (const char*,const finteger*,const fdouble*,
      const fdouble*,const fdouble*,const fdouble*,const finteger*,
      const fdouble*,fdouble*,fdouble*,finteger*,finteger*);

extern void F77CALL (dgtrfs) (const char*,const finteger*,const finteger*,
      const fdouble*,const fdouble*,const fdouble*,const fdouble*,
      const fdouble*,const fdouble*,const fdouble*,const finteger*,
      const fdouble*,const finteger*,fdouble*,const finteger*,fdouble*,
      fdouble*,fdouble*,finteger*,finteger*);

extern void F77CALL (dgtsv) (const finteger*,const finteger*,fdouble*,
      fdouble*,fdouble*,fdouble*,const finteger*,finteger*);

extern void F77CALL (dgtsvx) (const char*,const char*,const finteger*,
      const finteger*,const fdouble*,const fdouble*,const fdouble*,fdouble*,
      fdouble*,fdouble*,fdouble*,finteger*,const fdouble*,const finteger*,
      fdouble*,const finteger*,fdouble*,fdouble*,fdouble*,fdouble*,finteger*,
      finteger*);

extern void F77CALL (dgttrf) (const finteger*,fdouble*,fdouble*,fdouble*,
      fdouble*,finteger*,finteger*);

extern void F77CALL (dgttrs) (const char*,const finteger*,const finteger*,
      const fdouble*,const fdouble*,const fdouble*,const fdouble*,
      const finteger*,fdouble*,const finteger*,finteger*);

extern void F77CALL (dhgeqz) (const char*,const char*,const char*,
      const finteger*,const finteger*,const finteger*,fdouble*,
      const finteger*,fdouble*,const finteger*,fdouble*,fdouble*,fdouble*,
      fdouble*,const finteger*,fdouble*,const finteger*,fdouble*,
      const finteger*,finteger*);

extern void F77CALL (dhsein) (const char*,const char*,const char*,flogical*,
      const finteger*,const fdouble*,const finteger*,fdouble*,const fdouble*,
      fdouble*,const finteger*,fdouble*,const finteger*,const finteger*,
      finteger*,fdouble*,finteger*,finteger*,finteger*);

extern void F77CALL (dhseqr) (const char*,const char*,const finteger*,
      const finteger*,const finteger*,fdouble*,const finteger*,fdouble*,
      fdouble*,fdouble*,const finteger*,fdouble*,const finteger*,finteger*);

extern void F77CALL (dlabad) (fdouble*,fdouble*);

extern void F77CALL (dlabrd) (const finteger*,const finteger*,const finteger*,
      fdouble*,const finteger*,fdouble*,fdouble*,fdouble*,fdouble*,fdouble*,
      const finteger*,fdouble*,finteger*);

extern void F77CALL (dlacon) (const finteger*,fdouble*,fdouble*,finteger*,
      fdouble*,finteger*);

extern void F77CALL (dlacpy) (const char*,const finteger*,const finteger*,
      const fdouble*,const finteger*,fdouble*,const finteger*);

extern void F77CALL (dladiv) (const fdouble*,const fdouble*,const fdouble*,
      const fdouble*,fdouble*,fdouble*);

extern void F77CALL (dlae2) (const fdouble*,const fdouble*,const fdouble*,
      fdouble*,fdouble*);

extern void F77CALL (dlaebz) (const finteger*,const finteger*,const finteger*,
      const finteger*,const finteger*,const finteger*,const fdouble*,
      const fdouble*,const fdouble*,const fdouble*,const fdouble*,
      const fdouble*,finteger*,fdouble*,fdouble*,finteger*,finteger*,fdouble*,
      finteger*,finteger*);

extern void F77CALL (dlaed0) (const finteger*,const finteger*,const finteger*,
      fdouble*,const fdouble*,fdouble*,const finteger*,fdouble*,
      const finteger*,fdouble*,finteger*,finteger*);

extern void F77CALL (dlaed1) (const finteger*,fdouble*,fdouble*,
      const finteger*,finteger*,const fdouble*,const finteger*,fdouble*,
      finteger*,finteger*);

extern void F77CALL (dlaed2) (finteger*,const finteger*,fdouble*,fdouble*,
      const finteger*,finteger*,fdouble*,const finteger*,const fdouble*,
      fdouble*,fdouble*,const finteger*,finteger*,fdouble*,finteger*,finteger*,
      finteger*,finteger*);

extern void F77CALL (dlaed3) (const finteger*,const finteger*,const finteger*,
      const finteger*,fdouble*,fdouble*,const finteger*,const fdouble*,
      const finteger*,fdouble*,const fdouble*,const finteger*,const finteger*,
      const finteger*,fdouble*,fdouble*,const finteger*,finteger*);

extern void F77CALL (dlaed4) (const finteger*,const finteger*,const fdouble*,
      const fdouble*,fdouble*,const fdouble*,fdouble*,finteger*);

extern void F77CALL (dlaed5) (const finteger*,const fdouble*,const fdouble*,
      fdouble*,const fdouble*,fdouble*);

extern void F77CALL (dlaed6) (const finteger*,const flogical*,const fdouble*,
      const fdouble*,const fdouble*,const fdouble*,fdouble*,finteger*);

extern void F77CALL (dlaed7) (const finteger*,const finteger*,const finteger*,
      const finteger*,const finteger*,const finteger*,fdouble*,fdouble*,
      const finteger*,finteger*,const fdouble*,const finteger*,fdouble*,
      finteger*,const finteger*,const finteger*,const finteger*,
      const finteger*,const fdouble*,fdouble*,finteger*,finteger*);

extern void F77CALL (dlaed8) (const finteger*,finteger*,const finteger*,
      const finteger*,fdouble*,fdouble*,const finteger*,const finteger*,
      fdouble*,const finteger*,const fdouble*,fdouble*,fdouble*,
      const finteger*,fdouble*,finteger*,finteger*,finteger*,fdouble*,
      finteger*,finteger*,finteger*);

extern void F77CALL (dlaed9) (const finteger*,const finteger*,const finteger*,
      const finteger*,fdouble*,fdouble*,const finteger*,const fdouble*,
      const fdouble*,const fdouble*,fdouble*,const finteger*,finteger*);

extern void F77CALL (dlaeda) (const finteger*,const finteger*,const finteger*,
      const finteger*,const finteger*,const finteger*,const finteger*,
      const finteger*,const fdouble*,const fdouble*,const finteger*,
      fdouble*,fdouble*,finteger*);

extern void F77CALL (dlaein) (const flogical*,const flogical*,const finteger*,
      const fdouble*,const finteger*,const fdouble*,const fdouble*,
      fdouble*,fdouble*,fdouble*,const finteger*,fdouble*,const fdouble*,
      const fdouble*,const fdouble*,finteger*);

extern void F77CALL (dlaev2) (const fdouble*,const fdouble*,const fdouble*,
      fdouble*,fdouble*,fdouble*,fdouble*);

extern void F77CALL (dlaexc) (const flogical*,const finteger*,fdouble*,
      const finteger*,fdouble*,const finteger*,const finteger*,const finteger*,
      const finteger*,fdouble*,finteger*);

extern void F77CALL (dlag2) (const fdouble*,const finteger*,const fdouble*,
      const finteger*,const fdouble*,fdouble*,fdouble*,fdouble*,fdouble*,
      fdouble*);

extern void F77CALL (dlags2) (const flogical*,const fdouble*,const fdouble*,
      const fdouble*,const fdouble*,const fdouble*,const fdouble*,
      fdouble*,fdouble*,fdouble*,fdouble*,fdouble*,fdouble*);

extern void F77CALL (dlagtf) (const finteger*,fdouble*,const fdouble*,
      fdouble*,fdouble*,const fdouble*,fdouble*,finteger*,finteger*);

extern void F77CALL (dlagtm) (const char*,const finteger*,const finteger*,
      const fdouble*,const fdouble*,const fdouble*,const fdouble*,
      const fdouble*,const finteger*,const fdouble*,fdouble*,const finteger*);

extern void F77CALL (dlagts) (const finteger*,const finteger*,const fdouble*,
      const fdouble*,const fdouble*,const fdouble*,const finteger*,fdouble*,
      fdouble*,finteger*);

extern void F77CALL (dlahqr) (const flogical*,const flogical*,const finteger*,
      const finteger*,const finteger*,fdouble*,const finteger*,fdouble*,
      fdouble*,const finteger*,const finteger*,fdouble*,const finteger*,
      finteger*);

extern void F77CALL (dlahrd) (const finteger*,const finteger*,const finteger*,
      fdouble*,const finteger*,fdouble*,fdouble*,const finteger*,fdouble*,
      const finteger*);

extern void F77CALL (dlaic1) (const finteger*,const finteger*,const fdouble*,
      const fdouble*,const fdouble*,const fdouble*,fdouble*,fdouble*,fdouble*);

extern void F77CALL (dlaln2) (const flogical*,const finteger*,const finteger*,
      const fdouble*,const fdouble*,const fdouble*,const finteger*,
      const fdouble*,const fdouble*,const fdouble*,const finteger*,
      const fdouble*,const fdouble*,fdouble*,const finteger*,fdouble*,fdouble*,
      finteger*);

extern fdouble F77CALL (dlamch) (const char*);

extern void F77CALL (dlamrg) (const finteger*,const finteger*,const fdouble*,
      const finteger*,const finteger*,finteger*);

extern fdouble F77CALL (dlangb) (const char*,const finteger*,const finteger*,
      const finteger*,const fdouble*,const finteger*,fdouble*);

extern fdouble F77CALL (dlange) (const char*,const finteger*,const finteger*,
      const fdouble*,const finteger*,fdouble*);

extern fdouble F77CALL (dlangt) (const char*,const finteger*,const fdouble*,
      const fdouble*,const fdouble*);

extern fdouble F77CALL (dlanhs) (const char*,const finteger*,const fdouble*,
      const finteger*,fdouble*);

extern fdouble F77CALL (dlansb) (const char*,const char*,const finteger*,
      const finteger*,const fdouble*,const finteger*,fdouble*);

extern fdouble F77CALL (dlansp) (const char*,const char*,const finteger*,
      const fdouble*,fdouble*);

extern fdouble F77CALL (dlanst) (const char*,const finteger*,const fdouble*,
      const fdouble*);

extern fdouble F77CALL (dlansy) (const char*,const char*,const finteger*,
      const fdouble*,const finteger*,fdouble*);

extern fdouble F77CALL (dlantb) (const char*,const char*,const char*,
      const finteger*,const finteger*,const fdouble*,const finteger*,fdouble*);

extern fdouble F77CALL (dlantp) (const char*,const char*,const char*,
      const finteger*,const fdouble*,fdouble*);

extern fdouble F77CALL (dlantr) (const char*,const char*,const char*,
      const finteger*,const finteger*,const fdouble*,const finteger*,fdouble*);

extern void F77CALL (dlanv2) (fdouble*,fdouble*,fdouble*,fdouble*,fdouble*,
      fdouble*,fdouble*,fdouble*,fdouble*,fdouble*);

extern void F77CALL (dlapll) (const finteger*,fdouble*,const finteger*,
      fdouble*,const finteger*,fdouble*);

extern void F77CALL (dlapmt) (const flogical*,const finteger*,const finteger*,
      fdouble*,const finteger*,const finteger*);

extern fdouble F77CALL (dlapy2) (const fdouble*,const fdouble*);

extern fdouble F77CALL (dlapy3) (const fdouble*,const fdouble*,const fdouble*);

extern void F77CALL (dlaqgb) (const finteger*,const finteger*,const finteger*,
      const finteger*,fdouble*,const finteger*,fdouble*,fdouble*,fdouble*,
      fdouble*,const fdouble*,char*);

extern void F77CALL (dlaqge) (const finteger*,const finteger*,fdouble*,
      const finteger*,const fdouble*,const fdouble*,const fdouble*,
      const fdouble*,const fdouble*,char*);

extern void F77CALL (dlaqsb) (const char*,const finteger*,const finteger*,
      fdouble*,const finteger*,fdouble*,const fdouble*,const fdouble*,char*);

extern void F77CALL (dlaqsp) (const char*,const finteger*,fdouble*,
      const fdouble*,const fdouble*,const fdouble*,char*);

extern void F77CALL (dlaqsy) (const char*,const finteger*,fdouble*,
      const finteger*,const fdouble*,const fdouble*,const fdouble*,char*);

extern void F77CALL (dlaqtr) (const flogical*,const flogical*,const finteger*,
      const fdouble*,const finteger*,const fdouble*,const fdouble*,fdouble*,
      fdouble*,fdouble*,finteger*);

extern void F77CALL (dlar2v) (const finteger*,fdouble*,fdouble*,fdouble*,
      const finteger*,const fdouble*,const fdouble*,const finteger*);

extern void F77CALL (dlarf) (const char*,const finteger*,const finteger*,
      const fdouble*,const finteger*,const fdouble*,fdouble*,const finteger*,
      fdouble*);

extern void F77CALL (dlarfb) (const char*,const char*,const char*,const char*,
      const finteger*,const finteger*,const finteger*,const fdouble*,
      const finteger*,const fdouble*,const finteger*,fdouble*,const finteger*,
      fdouble*,const finteger*);

extern void F77CALL (dlarfg) (const finteger*,fdouble*,fdouble*,
      const finteger*,fdouble*);

extern void F77CALL (dlarft) (const char*,const char*,const finteger*,
      const finteger*,fdouble*,const finteger*,const fdouble*,fdouble*,
      const finteger*);

extern void F77CALL (dlarfx) (const char*,const finteger*,const finteger*,
      const fdouble*,const fdouble*,fdouble*,const finteger*,fdouble*);

extern void F77CALL (dlargv) (const finteger*,fdouble*,const finteger*,
      fdouble*,const finteger*,fdouble*,const finteger*);

extern void F77CALL (dlarnv) (const finteger*,finteger*,const finteger*,
      fdouble*);

extern void F77CALL (dlartg) (const fdouble*,const fdouble*,fdouble*,
      fdouble*,fdouble*);

extern void F77CALL (dlartv) (const finteger*,fdouble*,const finteger*,
      fdouble*,const finteger*,const fdouble*,const fdouble*,const finteger*);

extern void F77CALL (dlaruv) (finteger*,const finteger*,fdouble*);

extern void F77CALL (dlas2) (const fdouble*,const fdouble*,const fdouble*,
      fdouble*,fdouble*);

extern void F77CALL (dlascl) (const char*,const finteger*,const finteger*,
      const fdouble*,const fdouble*,const finteger*,const finteger*,fdouble*,
      const finteger*,finteger*);

extern void F77CALL (dlaset) (const char*,const finteger*,const finteger*,
      const fdouble*,const fdouble*,fdouble*,const finteger*);

extern void F77CALL (dlasq1) (const finteger*,fdouble*,fdouble*,fdouble*,
      finteger*);

extern void F77CALL (dlasq2) (const finteger*,fdouble*,fdouble*,fdouble*,
      fdouble*,const fdouble*,const fdouble*,const fdouble*,fdouble*,
      finteger*,finteger*);

extern void F77CALL (dlasq3) (finteger*,fdouble*,fdouble*,fdouble*,fdouble*,
      fdouble*,fdouble*,finteger*,finteger*,finteger*,const finteger*,
      const fdouble*,const fdouble*,const fdouble*);

extern void F77CALL (dlasq4) (const finteger*,const fdouble*,const fdouble*,
      fdouble*,fdouble*);

extern void F77CALL (dlasr) (const char*,const char*,const char*,
      const finteger*,const finteger*,const fdouble*,const fdouble*,fdouble*,
      const finteger*);

extern void F77CALL (dlasrt) (const char*,const finteger*,fdouble*,finteger*);

extern void F77CALL (dlassq) (const finteger*,const fdouble*,const finteger*,
      fdouble*,fdouble*);

extern void F77CALL (dlasv2) (const fdouble*,const fdouble*,const fdouble*,
      fdouble*,fdouble*,fdouble*,fdouble*,fdouble*,fdouble*);

extern void F77CALL (dlaswp) (const finteger*,fdouble*,const finteger*,
      const finteger*,const finteger*,const finteger*,const finteger*);

extern void F77CALL (dlasy2) (const flogical*,const flogical*,const finteger*,
      const finteger*,const finteger*,const fdouble*,const finteger*,
      const fdouble*,const finteger*,const fdouble*,const finteger*,fdouble*,
      fdouble*,const finteger*,fdouble*,finteger*);

extern void F77CALL (dlasyf) (const char*,const finteger*,const finteger*,
      finteger*,fdouble*,const finteger*,finteger*,fdouble*,const finteger*,
      finteger*);

extern void F77CALL (dlatbs) (const char*,const char*,const char*,const char*,
      const finteger*,const finteger*,const fdouble*,const finteger*,fdouble*,
      fdouble*,fdouble*,finteger*);

extern void F77CALL (dlatps) (const char*,const char*,const char*,const char*,
      const finteger*,const fdouble*,fdouble*,fdouble*,fdouble*,finteger*);

extern void F77CALL (dlatrd) (const char*,const finteger*,const finteger*,
      fdouble*,const finteger*,fdouble*,fdouble*,fdouble*,const finteger*);

extern void F77CALL (dlatrs) (const char*,const char*,const char*,const char*,
      const finteger*,const fdouble*,const finteger*,fdouble*,fdouble*,
      fdouble*,finteger*);

extern void F77CALL (dlatzm) (const char*,const finteger*,const finteger*,
      const fdouble*,const finteger*,const fdouble*,fdouble*,fdouble*,
      const finteger*,fdouble*);

extern void F77CALL (dlauu2) (const char*,const finteger*,fdouble*,
      const finteger*,finteger*);

extern void F77CALL (dlauum) (const char*,const finteger*,fdouble*,
      const finteger*,finteger*);

extern void F77CALL (dopgtr) (const char*,const finteger*,const fdouble*,
      const fdouble*,fdouble*,const finteger*,fdouble*,finteger*);

extern void F77CALL (dopmtr) (const char*,const char*,const char*,
      const finteger*,const finteger*,const fdouble*,const fdouble*,fdouble*,
      const finteger*,fdouble*,finteger*);

extern void F77CALL (dorg2l) (const finteger*,const finteger*,const finteger*,
      fdouble*,const finteger*,const fdouble*,fdouble*,finteger*);

extern void F77CALL (dorg2r) (const finteger*,const finteger*,const finteger*,
      fdouble*,const finteger*,const fdouble*,fdouble*,finteger*);

extern void F77CALL (dorgbr) (const char*,const finteger*,const finteger*,
      const finteger*,fdouble*,const finteger*,const fdouble*,fdouble*,
      const finteger*,finteger*);

extern void F77CALL (dorghr) (const finteger*,const finteger*,const finteger*,
      fdouble*,const finteger*,const fdouble*,fdouble*,const finteger*,
      finteger*);

extern void F77CALL (dorgl2) (const finteger*,const finteger*,const finteger*,
      fdouble*,const finteger*,const fdouble*,fdouble*,finteger*);

extern void F77CALL (dorglq) (const finteger*,const finteger*,const finteger*,
      fdouble*,const finteger*,const fdouble*,fdouble*,const finteger*,
      finteger*);

extern void F77CALL (dorgql) (const finteger*,const finteger*,const finteger*,
      fdouble*,const finteger*,const fdouble*,fdouble*,const finteger*,
      finteger*);

extern void F77CALL (dorgqr) (const finteger*,const finteger*,const finteger*,
      fdouble*,const finteger*,const fdouble*,fdouble*,const finteger*,
      finteger*);

extern void F77CALL (dorgr2) (const finteger*,const finteger*,const finteger*,
      fdouble*,const finteger*,const fdouble*,fdouble*,finteger*);

extern void F77CALL (dorgrq) (const finteger*,const finteger*,const finteger*,
      fdouble*,const finteger*,const fdouble*,fdouble*,const finteger*,
      finteger*);

extern void F77CALL (dorgtr) (const char*,const finteger*,fdouble*,
      const finteger*,const fdouble*,fdouble*,const finteger*,finteger*);

extern void F77CALL (dorm2l) (const char*,const char*,const finteger*,
      const finteger*,const finteger*,const fdouble*,const finteger*,
      const fdouble*,fdouble*,const finteger*,fdouble*,finteger*);

extern void F77CALL (dorm2r) (const char*,const char*,const finteger*,
      const finteger*,const finteger*,const fdouble*,const finteger*,
      const fdouble*,fdouble*,const finteger*,fdouble*,finteger*);

extern void F77CALL (dormbr) (const char*,const char*,const char*,
      const finteger*,const finteger*,const finteger*,const fdouble*,
      const finteger*,const fdouble*,fdouble*,const finteger*,fdouble*,
      const finteger*,finteger*);

extern void F77CALL (dormhr) (const char*,const char*,const finteger*,
      const finteger*,const finteger*,const finteger*,const fdouble*,
      const finteger*,const fdouble*,fdouble*,const finteger*,fdouble*,
      const finteger*,finteger*);

extern void F77CALL (dorml2) (const char*,const char*,const finteger*,
      const finteger*,const finteger*,const fdouble*,const finteger*,
      const fdouble*,fdouble*,const finteger*,fdouble*,finteger*);

extern void F77CALL (dormlq) (const char*,const char*,const finteger*,
      const finteger*,const finteger*,const fdouble*,const finteger*,
      const fdouble*,fdouble*,const finteger*,fdouble*,const finteger*,
      finteger*);

extern void F77CALL (dormql) (const char*,const char*,const finteger*,
      const finteger*,const finteger*,const fdouble*,const finteger*,
      const fdouble*,fdouble*,const finteger*,fdouble*,const finteger*,
      finteger*);

extern void F77CALL (dormqr) (const char*,const char*,const finteger*,
      const finteger*,const finteger*,const fdouble*,const finteger*,
      const fdouble*,fdouble*,const finteger*,fdouble*,const finteger*,
      finteger*);

extern void F77CALL (dormr2) (const char*,const char*,const finteger*,
      const finteger*,const finteger*,const fdouble*,const finteger*,
      const fdouble*,fdouble*,const finteger*,fdouble*,finteger*);

extern void F77CALL (dormrq) (const char*,const char*,const finteger*,
      const finteger*,const finteger*,const fdouble*,const finteger*,
      const fdouble*,fdouble*,const finteger*,fdouble*,const finteger*,
      finteger*);

extern void F77CALL (dormtr) (const char*,const char*,const char*,
      const finteger*,const finteger*,const fdouble*,const finteger*,
      const fdouble*,fdouble*,const finteger*,fdouble*,const finteger*,
      finteger*);

extern void F77CALL (dpbcon) (const char*,const finteger*,const finteger*,
      const fdouble*,const finteger*,const fdouble*,fdouble*,fdouble*,
      finteger*,finteger*);

extern void F77CALL (dpbequ) (const char*,const finteger*,const finteger*,
      const fdouble*,const finteger*,fdouble*,fdouble*,fdouble*,finteger*);

extern void F77CALL (dpbrfs) (const char*,const finteger*,const finteger*,
      const finteger*,const fdouble*,const finteger*,const fdouble*,
      const finteger*,const fdouble*,const finteger*,fdouble*,const finteger*,
      fdouble*,fdouble*,fdouble*,finteger*,finteger*
			      );

extern void F77CALL (dpbstf) (const char*,const finteger*,const finteger*,
      fdouble*,const finteger*,finteger*);

extern void F77CALL (dpbsv) (const char*,const finteger*,const finteger*,
      const finteger*,fdouble*,const finteger*,fdouble*,const finteger*,
      finteger*);

extern void F77CALL (dpbsvx) (const char*,const char*,const finteger*,
      const finteger*,const finteger*,fdouble*,const finteger*,fdouble*,
      const finteger*,char*,fdouble*,fdouble*,const finteger*,fdouble*,
      const finteger*,fdouble*,fdouble*,fdouble*,fdouble*,finteger*,finteger*);

extern void F77CALL (dpbtf2) (const char*,const finteger*,const finteger*,
      fdouble*,const finteger*,finteger*);

extern void F77CALL (dpbtrf) (const char*,const finteger*,const finteger*,
      fdouble*,const finteger*,finteger*);

extern void F77CALL (dpbtrs) (const char*,const finteger*,const finteger*,
      const finteger*,const fdouble*,const finteger*,fdouble*,const finteger*,
      finteger*);

extern void F77CALL (dpocon) (const char*,const finteger*,const fdouble*,
      const finteger*,const fdouble*,fdouble*,fdouble*,finteger*,finteger*);

extern void F77CALL (dpoequ) (const finteger*,const fdouble*,const finteger*,
      fdouble*,fdouble*,fdouble*,finteger*);

extern void F77CALL (dporfs) (const char*,const finteger*,const finteger*,
      const fdouble*,const finteger*,const fdouble*,const finteger*,
      const fdouble*,const finteger*,fdouble*,const finteger*,fdouble*,
      fdouble*,fdouble*,finteger*,finteger*);

extern void F77CALL (dposv) (const char*,const finteger*,const finteger*,
      fdouble*,const finteger*,fdouble*,const finteger*,finteger*);

extern void F77CALL (dposvx) (const char*,const char*,const finteger*,
      const finteger*,fdouble*,const finteger*,fdouble*,const finteger*,
      char*,fdouble*,fdouble*,const finteger*,fdouble*,const finteger*,
      fdouble*,fdouble*,fdouble*,fdouble*,finteger*,finteger*);

extern void F77CALL (dpotf2) (const char*,const finteger*,fdouble*,
      const finteger*,finteger*);

extern void F77CALL (dpotrf) (const char*,const finteger*,fdouble*,
      const finteger*,finteger*);

extern void F77CALL (dpotri) (const char*,const finteger*,fdouble*,
      const finteger*,finteger*);

extern void F77CALL (dpotrs) (const char*,const finteger*,const finteger*,
      const fdouble*,const finteger*,fdouble*,const finteger*,finteger*);

extern void F77CALL (dppcon) (const char*,const finteger*,const fdouble*,
      const fdouble*,fdouble*,fdouble*,finteger*,finteger*);

extern void F77CALL (dppequ) (const char*,const finteger*,const fdouble*,
      fdouble*,fdouble*,fdouble*,finteger*);

extern void F77CALL (dpprfs) (const char*,const finteger*,const finteger*,
      const fdouble*,const fdouble*,const fdouble*,const finteger*,fdouble*,
      const finteger*,fdouble*,fdouble*,fdouble*,finteger*,finteger*);

extern void F77CALL (dppsv) (const char*,const finteger*,const finteger*,
      fdouble*,fdouble*,const finteger*,finteger*);

extern void F77CALL (dppsvx) (const char*,const char*,const finteger*,
      const finteger*,fdouble*,fdouble*,char*,fdouble*,fdouble*,
      const finteger*,fdouble*,const finteger*,fdouble*,fdouble*,fdouble*,
      fdouble*,finteger*,finteger*);

extern void F77CALL (dpptrf) (const char*,const finteger*,fdouble*,finteger*);

extern void F77CALL (dpptri) (const char*,const finteger*,fdouble*,finteger*);

extern void F77CALL (dpptrs) (const char*,const finteger*,const finteger*,
      const fdouble*,fdouble*,const finteger*,finteger*);

extern void F77CALL (dptcon) (const finteger*,const fdouble*,const fdouble*,
      const fdouble*,fdouble*,fdouble*,finteger*);

extern void F77CALL (dpteqr) (const char*,const finteger*,fdouble*,
      fdouble*,fdouble*,const finteger*,fdouble*,finteger*);

extern void F77CALL (dptrfs) (const finteger*,const finteger*,const fdouble*,
      const fdouble*,const fdouble*,const fdouble*,const fdouble*,
      const finteger*,fdouble*,const finteger*,fdouble*,fdouble*,fdouble*,
      finteger*);

extern void F77CALL (dptsv) (const finteger*,const finteger*,fdouble*,
      fdouble*,fdouble*,const finteger*,finteger*);

extern void F77CALL (dptsvx) (const char*,const finteger*,const finteger*,
      const fdouble*,const fdouble*,fdouble*,fdouble*,const fdouble*,
      const finteger*,fdouble*,const finteger*,fdouble*,fdouble*,fdouble*,
      fdouble*,finteger*);

extern void F77CALL (dpttrf) (const finteger*,fdouble*,fdouble*,finteger*);

extern void F77CALL (dpttrs) (const finteger*,const finteger*,const fdouble*,
      const fdouble*,fdouble*,const finteger*,finteger*);

extern void F77CALL (drscl) (const finteger*,const fdouble*,fdouble*,
      const finteger*);

extern void F77CALL (dsbev) (const char*,const char*,const finteger*,
      const finteger*,fdouble*,const finteger*,fdouble*,fdouble*,
      const finteger*,fdouble*,finteger*);

extern void F77CALL (dsbevd) (const char*,const char*,const finteger*,
      const finteger*,fdouble*,const finteger*,fdouble*,fdouble*,
      const finteger*,fdouble*,const finteger*,finteger*,const finteger*,
      finteger*);

extern void F77CALL (dsbevx) (const char*,const char*,const char*,
      const finteger*,const finteger*,fdouble*,const finteger*,fdouble*,
      const finteger*,const fdouble*,const fdouble*,const finteger*,
      const finteger*,const fdouble*,finteger*,fdouble*,fdouble*,
      const finteger*,fdouble*,finteger*,finteger*,finteger*);

extern void F77CALL (dsbgst) (const char*,const char*,const finteger*,
      const finteger*,const finteger*,fdouble*,const finteger*,const fdouble*,
      const finteger*,fdouble*,const finteger*,fdouble*,finteger*);

extern void F77CALL (dsbgv) (const char*,const char*,const finteger*,
      const finteger*,const finteger*,fdouble*,const finteger*,fdouble*,
      const finteger*,fdouble*,fdouble*,const finteger*,fdouble*,finteger*);

extern void F77CALL (dsbtrd) (const char*,const char*,const finteger*,
      const finteger*,fdouble*,const finteger*,fdouble*,fdouble*,fdouble*,
      const finteger*,fdouble*,finteger*);


extern fdouble F77CALL (dsecnd) (void);

extern void F77CALL (dspcon) (const char*,const finteger*,const fdouble*,
      const finteger*,const fdouble*,fdouble*,fdouble*,finteger*,finteger*);

extern void F77CALL (dspev) (const char*,const char*,const finteger*,fdouble*,
      fdouble*,fdouble*,const finteger*,fdouble*,finteger*);

extern void F77CALL (dspevd) (const char*,const char*,const finteger*,fdouble*,
      fdouble*,fdouble*,const finteger*,fdouble*,const finteger*,finteger*,
      const finteger*,finteger*);

extern void F77CALL (dspevx) (const char*,const char*,const char*,
      const finteger*,fdouble*,const fdouble*,const fdouble*,const finteger*,
      const finteger*,const fdouble*,finteger*,fdouble*,fdouble*,
      const finteger*,fdouble*,finteger*,finteger*,finteger*);

extern void F77CALL (dspgst) (const finteger*,const char*,const finteger*,
      fdouble*,const fdouble*,finteger*);

extern void F77CALL (dspgv) (const finteger*,const char*,const char*,
      const finteger*,fdouble*,fdouble*,fdouble*,fdouble*,const finteger*,
      fdouble*,finteger*);

extern void F77CALL (dsprfs) (const char*,const finteger*,const finteger*,
      const fdouble*,const fdouble*,const finteger*,const fdouble*,
      const finteger*,fdouble*,const finteger*,fdouble*,fdouble*,fdouble*,
      finteger*,finteger*);

extern void F77CALL (dspsv) (const char*,const finteger*,const finteger*,
      fdouble*,finteger*,fdouble*,const finteger*,finteger*);

extern void F77CALL (dspsvx) (const char*,const char*,const finteger*,
      const finteger*,const fdouble*,fdouble*,finteger*,const fdouble*,
      const finteger*,fdouble*,const finteger*,fdouble*,fdouble*,fdouble*,
      fdouble*,finteger*,finteger*);

extern void F77CALL (dsptrd) (const char*,const finteger*,fdouble*,
      fdouble*,fdouble*,fdouble*,finteger*);

extern void F77CALL (dsptrf) (const char*,const finteger*,fdouble*,finteger*,
      finteger*);

extern void F77CALL (dsptri) (const char*,const finteger*,fdouble*,
      const finteger*,fdouble*,finteger*);

extern void F77CALL (dsptrs) (const char*,const finteger*,const finteger*,
      const fdouble*,const finteger*,fdouble*,const finteger*,finteger*
			      );

extern void F77CALL (dstebz) (const char*,const char*,const finteger*,
      const fdouble*,const fdouble*,const finteger*,const finteger*,
      const fdouble*,const fdouble*,const fdouble*,finteger*,finteger*,
      fdouble*,finteger*,finteger*,fdouble*,finteger*,finteger*);

extern void F77CALL (dstedc) (const char*,const finteger*,fdouble*,
      fdouble*,fdouble*,const finteger*,fdouble*,const finteger*,
      finteger*,const finteger*,finteger*);

extern void F77CALL (dstein) (const finteger*,const fdouble*,const fdouble*,
      const finteger*,const fdouble*,const finteger*,const finteger*,
      fdouble*,const finteger*,fdouble*,finteger*,finteger*,finteger*);

extern void F77CALL (dsteqr) (const char*,const finteger*,fdouble*,
      fdouble*,fdouble*,const finteger*,fdouble*,finteger*);

extern void F77CALL (dsterf) (const finteger*,fdouble*,fdouble*,finteger*);

extern void F77CALL (dstev) (const char*,const finteger*,fdouble*,fdouble*,
      fdouble*,const finteger*,fdouble*,finteger*);

extern void F77CALL (dstevd) (const char*,const finteger*,fdouble*,fdouble*,
      fdouble*,const finteger*,fdouble*,const finteger*,finteger*,
      const finteger*,finteger*);

extern void F77CALL (dstevx) (const char*,const char*,const finteger*,fdouble*,
      fdouble*,const fdouble*,const fdouble*,const finteger*,const finteger*,
      const fdouble*,finteger*,fdouble*,fdouble*,const finteger*,fdouble*,
      finteger*,finteger*,finteger*);

extern void F77CALL (dsycon) (const char*,const finteger*,const fdouble*,
      const finteger*,const finteger*,const fdouble*,fdouble*,fdouble*,
      finteger*,finteger*);

extern void F77CALL (dsyev) (const char*,const char*,const finteger*,fdouble*,
      const finteger*,fdouble*,fdouble*,const finteger*,finteger*);

extern void F77CALL (dsyevd) (const char*,const char*,const finteger*,fdouble*,
      const finteger*,fdouble*,fdouble*,const finteger*,finteger*,
      const finteger*,finteger*);

extern void F77CALL (dsyevx) (const char*,const char*,const char*,
      const finteger*,fdouble*,const finteger*,const fdouble*,const fdouble*,
      const finteger*,const finteger*,const fdouble*,finteger*,fdouble*,
      fdouble*,const finteger*,fdouble*,const finteger*,finteger*,finteger*,
      finteger*);

extern void F77CALL (dsygs2) (const finteger*,const char*,const finteger*,
      fdouble*,const finteger*,const fdouble*,const finteger*,finteger*);

extern void F77CALL (dsygst) (const finteger*,const char*,const finteger*,
      fdouble*,const finteger*,const fdouble*,const finteger*,finteger*);

extern void F77CALL (dsygv) (const finteger*,const char*,const char*,
      const finteger*,fdouble*,const finteger*,fdouble*,const finteger*,
      fdouble*,fdouble*,const finteger*,finteger*);

extern void F77CALL (dsyrfs) (const char*,const finteger*,const finteger*,
      const fdouble*,const finteger*,const fdouble*,const finteger*,
      const finteger*,const fdouble*,const finteger*,fdouble*,const finteger*,
      fdouble*,fdouble*,fdouble*,finteger*,finteger*);

extern void F77CALL (dsysv) (const char*,const finteger*,const finteger*,
      fdouble*,const finteger*,finteger*,fdouble*,const finteger*,fdouble*,
      const finteger*,finteger*);

extern void F77CALL (dsysvx) (const char*,const char*,const finteger*,
      const finteger*,const fdouble*,const finteger*,fdouble*,const finteger*,
      finteger*,const fdouble*,const finteger*,fdouble*,const finteger*,
      fdouble*,fdouble*,fdouble*,fdouble*,const finteger*,finteger*,finteger*);

extern void F77CALL (dsytd2) (const char*,const finteger*,fdouble*,
      const finteger*,fdouble*,fdouble*,fdouble*,finteger*);

extern void F77CALL (dsytf2) (const char*,const finteger*,fdouble*,
      const finteger*,finteger*,finteger*);

extern void F77CALL (dsytrd) (const char*,const finteger*,fdouble*,
      const finteger*,fdouble*,fdouble*,fdouble*,fdouble*,const finteger*,
      finteger*);

extern void F77CALL (dsytrf) (const char*,const finteger*,fdouble*,
      const finteger*,finteger*,fdouble*,const finteger*,finteger*);

extern void F77CALL (dsytri) (const char*,const finteger*,fdouble*,
      const finteger*,const finteger*,fdouble*,finteger*);

extern void F77CALL (dsytrs) (const char*,const finteger*,const finteger*,
      const fdouble*,const finteger*,const finteger*,fdouble*,const finteger*,
      finteger*);

extern void F77CALL (dtbcon) (const char*,const char*,const char*,
      const finteger*,const finteger*,const fdouble*,const finteger*,fdouble*,
      fdouble*,finteger*,finteger*);

extern void F77CALL (dtbrfs) (const char*,const char*,const char*,
      const finteger*,const finteger*,const finteger*,const fdouble*,
      const finteger*,const fdouble*,const finteger*,const fdouble*,
      const finteger*,fdouble*,fdouble*,fdouble*,finteger*,finteger*);

extern void F77CALL (dtbtrs) (const char*,const char*,const char*,
      const finteger*,const finteger*,const finteger*,const fdouble*,
      const finteger*,fdouble*,const finteger*,finteger*);

extern void F77CALL (dtgevc) (const char*,const char*,const flogical*,
      const finteger*,const fdouble*,const finteger*,const fdouble*,
      const finteger*,fdouble*,const finteger*,fdouble*,const finteger*,
      const finteger*,finteger*,fdouble*,finteger*);

extern void F77CALL (dtgsja) (const char*,const char*,const char*,
      const finteger*,const finteger*,const finteger*,const finteger*,
      const finteger*,fdouble*,const finteger*,fdouble*,const finteger*,
      const fdouble*,const fdouble*,fdouble*,fdouble*,fdouble*,const finteger*,
      fdouble*,const finteger*,fdouble*,const finteger*,fdouble*,finteger*,
      finteger*);

extern void F77CALL (dtpcon) (const char*,const char*,const char*,
      const finteger*,const fdouble*,fdouble*,fdouble*,finteger*,finteger*);

extern void F77CALL (dtprfs) (const char*,const char*,const char*,
      const finteger*,const finteger*,const fdouble*,const fdouble*,
      const finteger*,const fdouble*,const finteger*,fdouble*,fdouble*,
      fdouble*,finteger*,finteger*);

extern void F77CALL (dtptri) (const char*,const char*,const finteger*,fdouble*,
      finteger*);

extern void F77CALL (dtptrs) (const char*,const char*,const char*,
      const finteger*,const finteger*,const fdouble*,fdouble*,const finteger*,
      finteger*);

extern void F77CALL (dtrcon) (const char*,const char*,const char*,
      const finteger*,const fdouble*,const finteger*,fdouble*,fdouble*,
      finteger*,finteger*);

extern void F77CALL (dtrevc) (const char*,const char*,flogical*,
      const finteger*,const fdouble*,const finteger*,fdouble*,const finteger*,
      fdouble*,const finteger*,const finteger*,finteger*,fdouble*,finteger*);

extern void F77CALL (dtrexc) (const char*,const finteger*,fdouble*,
      const finteger*,fdouble*,const finteger*,finteger*,finteger*,
      fdouble*,finteger*);

extern void F77CALL (dtrrfs) (const char*,const char*,const char*,
      const finteger*,const finteger*,const fdouble*,const finteger*,
      const fdouble*,const finteger*,const fdouble*,const finteger*,
      fdouble*,fdouble*,fdouble*,finteger*,finteger*);

extern void F77CALL (dtrsen) (const char*,const char*,const flogical*,
      const finteger*,fdouble*,const finteger*,fdouble*,const finteger*,
      fdouble*,fdouble*,finteger*,fdouble*,fdouble*,fdouble*,const finteger*,
      finteger*,const finteger*,finteger*);

extern void F77CALL (dtrsna) (const char*,const char*,const flogical*,
      const finteger*,const fdouble*,const finteger*,const fdouble*,
      const finteger*,const fdouble*,const finteger*,fdouble*,fdouble*,
      const finteger*,finteger*,fdouble*,const finteger*,finteger*,finteger*);

extern void F77CALL (dtrsyl) (const char*,const char*,const finteger*,
      const finteger*,const finteger*,const fdouble*,const finteger*,
      const fdouble*,const finteger*,fdouble*,const finteger*,fdouble*,
      finteger*);

extern void F77CALL (dtrti2) (const char*,const char*,const finteger*,fdouble*,
      const finteger*,finteger*);

extern void F77CALL (dtrtri) (const char*,const char*,const finteger*,fdouble*,
      const finteger*,finteger*);

extern void F77CALL (dtrtrs) (const char*,const char*,const char*,
      const finteger*,const finteger*,const fdouble*,const finteger*,fdouble*,
      const finteger*,finteger*);

extern void F77CALL (dtzrqf) (const finteger*,const finteger*,fdouble*,
      const finteger*,fdouble*,finteger*);

extern fdouble F77CALL (dzsum1) (const finteger*,const fdoublecomplex*,
      const finteger*);

finteger F77CALL (icmax1) (const finteger*,const fsinglecomplex*,
      const finteger*);

#ifdef USE_F2C
finteger F77CALL (ilaenv) (const finteger*,const char*,const char*,
      const finteger*,const finteger*,const finteger*,finteger*,ftnlen name_,
      ftnlen opts_);
#else
/* finteger F77CALL (ilaenv) (const finteger*,const char*,const char*, */
/*       const finteger*,const finteger*,const finteger*,finteger*); */
#endif

extern finteger F77CALL (izmax1) (const finteger*,const fdoublecomplex*,
      const finteger*);

extern flogical F77CALL (lsame) (const char*,const char*);

extern flogical F77CALL (lsamen) (const finteger*,const char*,const char*);




















extern void F77CALL (sbdsqr) (const char*,const finteger*,const finteger*,
      const finteger*,const finteger*,fsingle*,fsingle*,fsingle*,
      const finteger*,fsingle*,const finteger*,fsingle*,const finteger*,
      fsingle*,finteger*);

extern void F77CALL (sdisna) (const char*,const finteger*,const finteger*,
      const fsingle*,fsingle*,finteger*);

extern void F77CALL (sgbbrd) (const char*,const finteger*,const finteger*,
      const finteger*,const finteger*,const finteger*,fsingle*,const finteger*,
      fsingle*,fsingle*,fsingle*,const finteger*,fsingle*,const finteger*,
      fsingle*,const finteger*,fsingle*,finteger*);

extern void F77CALL (sgbcon) (const char*,const finteger*,const finteger*,
      const finteger*,const fsingle*,const finteger*,const finteger*,
      const fsingle*,fsingle*,fsingle*,finteger*,finteger*);

extern void F77CALL (sgbequ) (const finteger*,const finteger*,const finteger*,
      const finteger*,const fsingle*,const finteger*,fsingle*,fsingle*,
      fsingle*,fsingle*,fsingle*,finteger*);

extern void F77CALL (sgbrfs) (const char*,const finteger*,const
      finteger*,const finteger*,const finteger*,const fsingle*,const
      finteger*,const fsingle*,const finteger*,const finteger*,const
      fsingle*,const finteger*,fsingle*,const finteger*,fsingle*,fsingle*,
      fsingle*,finteger*,finteger*);

extern void F77CALL (sgbsv) (const finteger*,const finteger*,const finteger*,
      const finteger*,fsingle*,const finteger*,finteger*,fsingle*,
      const finteger*,finteger*);

extern void F77CALL (sgbsvx) (const char*,const char*,const finteger*,
      const finteger*,const finteger*,const finteger*,fsingle*,
      const finteger*,fsingle*,const finteger*,finteger*,char*,fsingle*,
      fsingle*,fsingle*,const finteger*,fsingle*,const finteger*,fsingle*,
      fsingle*,fsingle*,fsingle*,finteger*,finteger*);

extern void F77CALL (sgbtf2) (const finteger*,const finteger*,const finteger*,
      const finteger*,fsingle*,const finteger*,finteger*,finteger*);

extern void F77CALL (sgbtrf) (const finteger*,const finteger*,const finteger*,
      const finteger*,fsingle*,const finteger*,finteger*,finteger*);

extern void F77CALL (sgbtrs) (const char*,const finteger*,const finteger*,
      const finteger*,const finteger*,const fsingle*,const finteger*,
      const finteger*,fsingle*,const finteger*,finteger*);

extern void F77CALL (sgebak) (const char*,const char*,const finteger*,
      const finteger*,const finteger*,const fsingle*,const finteger*,fsingle*,
      const finteger*,finteger*);

extern void F77CALL (sgebal) (const char*,const finteger*,fsingle*,
      const finteger*,finteger*,finteger*,fsingle*,finteger*);

extern void F77CALL (sgebd2) (const finteger*,const finteger*,fsingle*,
      const finteger*,fsingle*,fsingle*,fsingle*,fsingle*,fsingle*,finteger*);

extern void F77CALL (sgebrd) (const finteger*,const finteger*,fsingle*,
      const finteger*,fsingle*,fsingle*,fsingle*,fsingle*,fsingle*,
      const finteger*,finteger*);

extern void F77CALL (sgecon) (const char*,const finteger*,const fsingle*,
      const finteger*,const fsingle*,fsingle*,fsingle*,finteger*,finteger*);

extern void F77CALL (sgeequ) (const finteger*,const finteger*,const fsingle*,
      const finteger*,fsingle*,fsingle*,fsingle*,fsingle*,fsingle*,finteger*);

extern void F77CALL (sgees) (const char*,const char*,fdselectfunction,
      const finteger*,fsingle*,const finteger*,finteger*,fsingle*,fsingle*,
      fsingle*,const finteger*,fsingle*,const finteger*,flogical*,finteger*);

extern void F77CALL (sgeesx) (const char*,const char*,fdselectfunction,
      const char*,const finteger*,fsingle*,const finteger*,finteger*,fsingle*,
      fsingle*,fsingle*,const finteger*,fsingle*,fsingle*,fsingle*,
      const finteger*,finteger*,const finteger*,flogical*,finteger*);

extern void F77CALL (sgeev) (const char*,const char*,const finteger*,fsingle*,
      const finteger*,fsingle*,fsingle*,fsingle*,const finteger*,fsingle*,
      const finteger*,fsingle*,const finteger*,finteger*);

extern void F77CALL (sgeevx) (const char*,const char*,const char*,const char*,
      const finteger*,fsingle*,const finteger*,fsingle*,fsingle*,fsingle*,
      const finteger*,fsingle*,const finteger*,finteger*,finteger*,fsingle*,
      fsingle*,fsingle*,fsingle*,fsingle*,const finteger*,finteger*,finteger*);

extern void F77CALL (sgegs) (const char*,const char*,const finteger*,fsingle*,
      const finteger*,fsingle*,const finteger*,fsingle*,fsingle*,fsingle*,
      fsingle*,const finteger*,fsingle*,const finteger*,fsingle*,
      const finteger*,finteger*);

extern void F77CALL (sgegv) (const char*,const char*,const finteger*,fsingle*,
      const finteger*,fsingle*,const finteger*,fsingle*,fsingle*,fsingle*,
      fsingle*,const finteger*,fsingle*,const finteger*,fsingle*,
      const finteger*,finteger*);

extern void F77CALL (sgehd2) (const finteger*,const finteger*,const finteger*,
      fsingle*,const finteger*,fsingle*,fsingle*,finteger*);

extern void F77CALL (sgehrd) (const finteger*,const finteger*,const finteger*,
      fsingle*,const finteger*,fsingle*,fsingle*,const finteger*,finteger*);

extern void F77CALL (sgelq2) (const finteger*,const finteger*,fsingle*,
      const finteger*,fsingle*,fsingle*,finteger*);

extern void F77CALL (sgelqf) (const finteger*,const finteger*,fsingle*,
      const finteger*,fsingle*,fsingle*,const finteger*,finteger*);

extern void F77CALL (sgels) (const char*,const finteger*,const finteger*,
      const finteger*,fsingle*,const finteger*,fsingle*,const finteger*,
      fsingle*,const finteger*,finteger*);

extern void F77CALL (sgelss) (const finteger*,const finteger*,const finteger*,
      fsingle*,const finteger*,fsingle*,const finteger*,fsingle*,
      const fsingle*,finteger*,fsingle*,const finteger*,finteger*);

extern void F77CALL (sgelsx) (const finteger*,const finteger*,const finteger*,
      fsingle*,const finteger*,fsingle*,const finteger*,finteger*,
      const fsingle*,finteger*,fsingle*,finteger*);

extern void F77CALL (sgeql2) (const finteger*,const finteger*,fsingle*,
      const finteger*,fsingle*,fsingle*,finteger*);

extern void F77CALL (sgeqlf) (const finteger*,const finteger*,fsingle*,
      const finteger*,fsingle*,fsingle*,const finteger*,finteger*);

extern void F77CALL (sgeqpf) (const finteger*,const finteger*,fsingle*,
      const finteger*,finteger*,fsingle*,fsingle*,finteger*);

extern void F77CALL (sgeqr2) (const finteger*,const finteger*,fsingle*,
      const finteger*,fsingle*,fsingle*,finteger*);

extern void F77CALL (sgeqrf) (const finteger*,const finteger*,fsingle*,
      const finteger*,fsingle*,fsingle*,const finteger*,finteger*);

extern void F77CALL (sgerfs) (const char*,const finteger*,const finteger*,
      const fsingle*,const finteger*,const fsingle*,const finteger*,
      const finteger*,const fsingle*,const finteger*,fsingle*,const finteger*,
      fsingle*,fsingle*,fsingle*,finteger*,finteger*);

extern void F77CALL (sgerq2) (const finteger*,const finteger*,fsingle*,
      const finteger*,fsingle*,fsingle*,finteger*);

extern void F77CALL (sgerqf) (const finteger*,const finteger*,fsingle*,
      const finteger*,fsingle*,fsingle*,const finteger*,finteger*);

extern void F77CALL (sgesv) (const finteger*,const finteger*,fsingle*,
      const finteger*,finteger*,fsingle*,const finteger*,finteger*);

extern void F77CALL (sgesvd) (const char*,const char*,const finteger*,
      const finteger*,fsingle*,const finteger*,fsingle*,fsingle*,
      const finteger*,fsingle*,const finteger*,fsingle*,const finteger*,
      finteger*);

extern void F77CALL (sgesvx) (const char*,const char*,const finteger*,
      const finteger*,fsingle*,const finteger*,fsingle*,const finteger*,
      finteger*,char*,fsingle*,fsingle*,fsingle*,const finteger*,fsingle*,
      const finteger*,fsingle*,fsingle*,fsingle*,fsingle*,finteger*,finteger*);

extern void F77CALL (sgetf2) (const finteger*,const finteger*,fsingle*,
      const finteger*,finteger*,finteger*);

extern void F77CALL (sgetrf) (const finteger*,const finteger*,fsingle*,
      const finteger*,finteger*,finteger*);

extern void F77CALL (sgetri) (const finteger*,fsingle*,const finteger*,
      const finteger*,fsingle*,const finteger*,finteger*);

extern void F77CALL (sgetrs) (const char*,const finteger*,const finteger*,
      const fsingle*,const finteger*,const finteger*,fsingle*,const finteger*,
      finteger*);

extern void F77CALL (sggbak) (const char*,const char*,const finteger*,
      const finteger*,const finteger*,const fsingle*,const fsingle*,
      const finteger*,fsingle*,const finteger*,finteger*);

extern void F77CALL (sggbal) (const char*,const finteger*,fsingle*,
      const finteger*,fsingle*,const finteger*,finteger*,finteger*,fsingle*,
      fsingle*,fsingle*,finteger*);

extern void F77CALL (sggglm) (const finteger*,const finteger*,const finteger*,
      fsingle*,const finteger*,fsingle*,const finteger*,fsingle*,fsingle*,
      fsingle*,fsingle*,const finteger*,finteger*);

extern void F77CALL (sgghrd) (const char*,const char*,const finteger*,
      const finteger*,const finteger*,fsingle*,const finteger*,fsingle*,
      const finteger*,fsingle*,const finteger*,fsingle*,const finteger*,
      finteger*);

extern void F77CALL (sgglse) (const finteger*,const finteger*,const finteger*,
      fsingle*,const finteger*,fsingle*,const finteger*,fsingle*,fsingle*,
      fsingle*,fsingle*,const finteger*,finteger*);

extern void F77CALL (sggqrf) (const finteger*,const finteger*,const finteger*,
      fsingle*,const finteger*,fsingle*,fsingle*,const finteger*,fsingle*,
      fsingle*,const finteger*,finteger*);

extern void F77CALL (sggrqf) (const finteger*,const finteger*,const finteger*,
      fsingle*,const finteger*,fsingle*,fsingle*,const finteger*,fsingle*,
      fsingle*,const finteger*,finteger*);

extern void F77CALL (sggsvd) (const char*,const char*,const char*,
      const finteger*,const finteger*,const finteger*,finteger*,finteger*,
      fsingle*,const finteger*,fsingle*,const finteger*,fsingle*,fsingle*,
      fsingle*,const finteger*,fsingle*,const finteger*,fsingle*,
      const finteger*,fsingle*,finteger*,finteger*);

extern void F77CALL (sggsvp) (const char*,const char*,const char*,
      const finteger*,const finteger*,const finteger*,fsingle*,const finteger*,
      fsingle*,const finteger*,const fsingle*,const fsingle*,finteger*,
      finteger*,fsingle*,const finteger*,fsingle*,const finteger*,fsingle*,
      const finteger*,finteger*,fsingle*,fsingle*,finteger*);

extern void F77CALL (sgtcon) (const char*,const finteger*,const fsingle*,
      const fsingle*,const fsingle*,const fsingle*,const finteger*,
      const fsingle*,fsingle*,fsingle*,finteger*,finteger*);

extern void F77CALL (sgtrfs) (const char*,const finteger*,const finteger*,
      const fsingle*,const fsingle*,const fsingle*,const fsingle*,
      const fsingle*,const fsingle*,const fsingle*,const finteger*,
      const fsingle*,const finteger*,fsingle*,const finteger*,fsingle*,
      fsingle*,fsingle*,finteger*,finteger*);

extern void F77CALL (sgtsv) (const finteger*,const finteger*,fsingle*,
      fsingle*,fsingle*,fsingle*,const finteger*,finteger*);

extern void F77CALL (sgtsvx) (const char*,const char*,const finteger*,
      const finteger*,const fsingle*,const fsingle*,const fsingle*,fsingle*,
      fsingle*,fsingle*,fsingle*,finteger*,const fsingle*,const finteger*,
      fsingle*,const finteger*,fsingle*,fsingle*,fsingle*,fsingle*,finteger*,
      finteger*);

extern void F77CALL (sgttrf) (const finteger*,fsingle*,fsingle*,fsingle*,
      fsingle*,finteger*,finteger*);

extern void F77CALL (sgttrs) (const char*,const finteger*,const finteger*,
      const fsingle*,const fsingle*,const fsingle*,const fsingle*,
      const finteger*,fsingle*,const finteger*,finteger*);

extern void F77CALL (shgeqz) (const char*,const char*,const char*,
      const finteger*,const finteger*,const finteger*,fsingle*,
      const finteger*,fsingle*,const finteger*,fsingle*,fsingle*,fsingle*,
      fsingle*,const finteger*,fsingle*,const finteger*,fsingle*,
      const finteger*,finteger*);

extern void F77CALL (shsein) (const char*,const char*,const char*,flogical*,
      const finteger*,const fsingle*,const finteger*,fsingle*,const fsingle*,
      fsingle*,const finteger*,fsingle*,const finteger*,const finteger*,
      finteger*,fsingle*,finteger*,finteger*,finteger*);

extern void F77CALL (shseqr) (const char*,const char*,const finteger*,
      const finteger*,const finteger*,fsingle*,const finteger*,fsingle*,
      fsingle*,fsingle*,const finteger*,fsingle*,const finteger*,finteger*);

extern void F77CALL (slabad) (fsingle*,fsingle*);

extern void F77CALL (slabrd) (const finteger*,const finteger*,const finteger*,
      fsingle*,const finteger*,fsingle*,fsingle*,fsingle*,fsingle*,fsingle*,
      const finteger*,fsingle*,finteger*);

extern void F77CALL (slacon) (const finteger*,fsingle*,fsingle*,finteger*,
      fsingle*,finteger*);

extern void F77CALL (slacpy) (const char*,const finteger*,const finteger*,
      const fsingle*,const finteger*,fsingle*,const finteger*);

extern void F77CALL (sladiv) (const fsingle*,const fsingle*,const fsingle*,
      const fsingle*,fsingle*,fsingle*);

extern void F77CALL (slae2) (const fsingle*,const fsingle*,const fsingle*,
      fsingle*,fsingle*);

extern void F77CALL (slaebz) (const finteger*,const finteger*,const finteger*,
      const finteger*,const finteger*,const finteger*,const fsingle*,
      const fsingle*,const fsingle*,const fsingle*,const fsingle*,
      const fsingle*,finteger*,fsingle*,fsingle*,finteger*,finteger*,fsingle*,
      finteger*,finteger*);

extern void F77CALL (slaed0) (const finteger*,const finteger*,const finteger*,
      fsingle*,const fsingle*,fsingle*,const finteger*,fsingle*,
      const finteger*,fsingle*,finteger*,finteger*);

extern void F77CALL (slaed1) (const finteger*,fsingle*,fsingle*,
      const finteger*,finteger*,const fsingle*,const finteger*,fsingle*,
      finteger*,finteger*);

extern void F77CALL (slaed2) (finteger*,const finteger*,fsingle*,fsingle*,
      const finteger*,finteger*,fsingle*,const finteger*,const fsingle*,
      fsingle*,fsingle*,const finteger*,finteger*,fsingle*,finteger*,finteger*,
      finteger*,finteger*);

extern void F77CALL (slaed3) (const finteger*,const finteger*,const finteger*,
      const finteger*,fsingle*,fsingle*,const finteger*,const fsingle*,
      const finteger*,fsingle*,const fsingle*,const finteger*,const finteger*,
      const finteger*,fsingle*,fsingle*,const finteger*,finteger*);

extern void F77CALL (slaed4) (const finteger*,const finteger*,const fsingle*,
      const fsingle*,fsingle*,const fsingle*,fsingle*,finteger*);

extern void F77CALL (slaed5) (const finteger*,const fsingle*,const fsingle*,
      fsingle*,const fsingle*,fsingle*);

extern void F77CALL (slaed6) (const finteger*,const flogical*,const fsingle*,
      const fsingle*,const fsingle*,const fsingle*,fsingle*,finteger*);

extern void F77CALL (slaed7) (const finteger*,const finteger*,const finteger*,
      const finteger*,const finteger*,const finteger*,fsingle*,fsingle*,
      const finteger*,finteger*,const fsingle*,const finteger*,fsingle*,
      finteger*,const finteger*,const finteger*,const finteger*,
      const finteger*,const fsingle*,fsingle*,finteger*,finteger*);

extern void F77CALL (slaed8) (const finteger*,finteger*,const finteger*,
      const finteger*,fsingle*,fsingle*,const finteger*,const finteger*,
      fsingle*,const finteger*,const fsingle*,fsingle*,fsingle*,
      const finteger*,fsingle*,finteger*,finteger*,finteger*,fsingle*,
      finteger*,finteger*,finteger*);

extern void F77CALL (slaed9) (const finteger*,const finteger*,const finteger*,
      const finteger*,fsingle*,fsingle*,const finteger*,const fsingle*,
      const fsingle*,const fsingle*,fsingle*,const finteger*,finteger*);

extern void F77CALL (slaeda) (const finteger*,const finteger*,const finteger*,
      const finteger*,const finteger*,const finteger*,const finteger*,
      const finteger*,const fsingle*,const fsingle*,const finteger*,
      fsingle*,fsingle*,finteger*);

extern void F77CALL (slaein) (const flogical*,const flogical*,const finteger*,
      const fsingle*,const finteger*,const fsingle*,const fsingle*,
      fsingle*,fsingle*,fsingle*,const finteger*,fsingle*,const fsingle*,
      const fsingle*,const fsingle*,finteger*);

extern void F77CALL (slaev2) (const fsingle*,const fsingle*,const fsingle*,
      fsingle*,fsingle*,fsingle*,fsingle*);

extern void F77CALL (slaexc) (const flogical*,const finteger*,fsingle*,
      const finteger*,fsingle*,const finteger*,const finteger*,const finteger*,
      const finteger*,fsingle*,finteger*);

extern void F77CALL (slag2) (const fsingle*,const finteger*,const fsingle*,
      const finteger*,const fsingle*,fsingle*,fsingle*,fsingle*,fsingle*,
      fsingle*);

extern void F77CALL (slags2) (const flogical*,const fsingle*,const fsingle*,
      const fsingle*,const fsingle*,const fsingle*,const fsingle*,
      fsingle*,fsingle*,fsingle*,fsingle*,fsingle*,fsingle*);

extern void F77CALL (slagtf) (const finteger*,fsingle*,const fsingle*,
      fsingle*,fsingle*,const fsingle*,fsingle*,finteger*,finteger*);

extern void F77CALL (slagtm) (const char*,const finteger*,const finteger*,
      const fsingle*,const fsingle*,const fsingle*,const fsingle*,
      const fsingle*,const finteger*,const fsingle*,fsingle*,const finteger*);

extern void F77CALL (slagts) (const finteger*,const finteger*,const fsingle*,
      const fsingle*,const fsingle*,const fsingle*,const finteger*,fsingle*,
      fsingle*,finteger*);

extern void F77CALL (slahqr) (const flogical*,const flogical*,const finteger*,
      const finteger*,const finteger*,fsingle*,const finteger*,fsingle*,
      fsingle*,const finteger*,const finteger*,fsingle*,const finteger*,
      finteger*);

extern void F77CALL (slahrd) (const finteger*,const finteger*,const finteger*,
      fsingle*,const finteger*,fsingle*,fsingle*,const finteger*,fsingle*,
      const finteger*);

extern void F77CALL (slaic1) (const finteger*,const finteger*,const fsingle*,
      const fsingle*,const fsingle*,const fsingle*,fsingle*,fsingle*,fsingle*);

extern void F77CALL (slaln2) (const flogical*,const finteger*,const finteger*,
      const fsingle*,const fsingle*,const fsingle*,const finteger*,
      const fsingle*,const fsingle*,const fsingle*,const finteger*,
      const fsingle*,const fsingle*,fsingle*,const finteger*,fsingle*,fsingle*,
      finteger*);

#ifdef USE_F2C
extern fdouble F77CALL (slamch) (const char*);
#else
extern fsingle F77CALL (slamch) (const char*);
#endif

extern void F77CALL (slamrg) (const finteger*,const finteger*,const fsingle*,
      const finteger*,const finteger*,finteger*);

#ifdef USE_F2C
extern fdouble F77CALL (slangb) (const char*,const finteger*,const finteger*,
      const finteger*,const fsingle*,const finteger*,fsingle*);

extern fdouble F77CALL (slange) (const char*,const finteger*,const finteger*,
      const fsingle*,const finteger*,fsingle*);

extern fdouble F77CALL (slangt) (const char*,const finteger*,const fsingle*,
      const fsingle*,const fsingle*);

extern fdouble F77CALL (slanhs) (const char*,const finteger*,const fsingle*,
      const finteger*,fsingle*);

extern fdouble F77CALL (slansb) (const char*,const char*,const finteger*,
      const finteger*,const fsingle*,const finteger*,fsingle*);

extern fdouble F77CALL (slansp) (const char*,const char*,const finteger*,
      const fsingle*,fsingle*);

extern fdouble F77CALL (slanst) (const char*,const finteger*,const fsingle*,
      const fsingle*);

extern fdouble F77CALL (slansy) (const char*,const char*,const finteger*,
      const fsingle*,const finteger*,fsingle*);

extern fdouble F77CALL (slantb) (const char*,const char*,const char*,
      const finteger*,const finteger*,const fsingle*,const finteger*,fsingle*);

extern fdouble F77CALL (slantp) (const char*,const char*,const char*,
      const finteger*,const fsingle*,fsingle*);

extern fdouble F77CALL (slantr) (const char*,const char*,const char*,
      const finteger*,const finteger*,const fsingle*,const finteger*,fsingle*);
#else
extern fsingle F77CALL (slangb) (const char*,const finteger*,const finteger*,
      const finteger*,const fsingle*,const finteger*,fsingle*);

extern fsingle F77CALL (slange) (const char*,const finteger*,const finteger*,
      const fsingle*,const finteger*,fsingle*);

extern fsingle F77CALL (slangt) (const char*,const finteger*,const fsingle*,
      const fsingle*,const fsingle*);

extern fsingle F77CALL (slanhs) (const char*,const finteger*,const fsingle*,
      const finteger*,fsingle*);

extern fsingle F77CALL (slansb) (const char*,const char*,const finteger*,
      const finteger*,const fsingle*,const finteger*,fsingle*);

extern fsingle F77CALL (slansp) (const char*,const char*,const finteger*,
      const fsingle*,fsingle*);

extern fsingle F77CALL (slanst) (const char*,const finteger*,const fsingle*,
      const fsingle*);

extern fsingle F77CALL (slansy) (const char*,const char*,const finteger*,
      const fsingle*,const finteger*,fsingle*);

extern fsingle F77CALL (slantb) (const char*,const char*,const char*,
      const finteger*,const finteger*,const fsingle*,const finteger*,fsingle*);

extern fsingle F77CALL (slantp) (const char*,const char*,const char*,
      const finteger*,const fsingle*,fsingle*);

extern fsingle F77CALL (slantr) (const char*,const char*,const char*,
      const finteger*,const finteger*,const fsingle*,const finteger*,fsingle*);
#endif

extern void F77CALL (slanv2) (fsingle*,fsingle*,fsingle*,fsingle*,fsingle*,
      fsingle*,fsingle*,fsingle*,fsingle*,fsingle*);

extern void F77CALL (slapll) (const finteger*,fsingle*,const finteger*,
      fsingle*,const finteger*,fsingle*);

extern void F77CALL (slapmt) (const flogical*,const finteger*,const finteger*,
      fsingle*,const finteger*,const finteger*);

#ifdef USE_F2C
extern fdouble F77CALL (slapy2) (const fsingle*,const fsingle*);

extern fdouble F77CALL (slapy3) (const fsingle*,const fsingle*,const fsingle*);
#else
extern fsingle F77CALL (slapy2) (const fsingle*,const fsingle*);

extern fsingle F77CALL (slapy3) (const fsingle*,const fsingle*,const fsingle*);
#endif

extern void F77CALL (slaqgb) (const finteger*,const finteger*,const finteger*,
      const finteger*,fsingle*,const finteger*,fsingle*,fsingle*,fsingle*,
      fsingle*,const fsingle*,char*);

extern void F77CALL (slaqge) (const finteger*,const finteger*,fsingle*,
      const finteger*,const fsingle*,const fsingle*,const fsingle*,
      const fsingle*,const fsingle*,char*);

extern void F77CALL (slaqsb) (const char*,const finteger*,const finteger*,
      fsingle*,const finteger*,fsingle*,const fsingle*,const fsingle*,char*);

extern void F77CALL (slaqsp) (const char*,const finteger*,fsingle*,
      const fsingle*,const fsingle*,const fsingle*,char*);

extern void F77CALL (slaqsy) (const char*,const finteger*,fsingle*,
      const finteger*,const fsingle*,const fsingle*,const fsingle*,char*);

extern void F77CALL (slaqtr) (const flogical*,const flogical*,const finteger*,
      const fsingle*,const finteger*,const fsingle*,const fsingle*,fsingle*,
      fsingle*,fsingle*,finteger*);

extern void F77CALL (slar2v) (const finteger*,fsingle*,fsingle*,fsingle*,
      const finteger*,const fsingle*,const fsingle*,const finteger*);

extern void F77CALL (slarf) (const char*,const finteger*,const finteger*,
      const fsingle*,const finteger*,const fsingle*,fsingle*,const finteger*,
      fsingle*);

extern void F77CALL (slarfb) (const char*,const char*,const char*,const char*,
      const finteger*,const finteger*,const finteger*,const fsingle*,
      const finteger*,const fsingle*,const finteger*,fsingle*,const finteger*,
      fsingle*,const finteger*);

extern void F77CALL (slarfg) (const finteger*,fsingle*,fsingle*,
      const finteger*,fsingle*);

extern void F77CALL (slarft) (const char*,const char*,const finteger*,
      const finteger*,fsingle*,const finteger*,const fsingle*,fsingle*,
      const finteger*);

extern void F77CALL (slarfx) (const char*,const finteger*,const finteger*,
      const fsingle*,const fsingle*,fsingle*,const finteger*,fsingle*);

extern void F77CALL (slargv) (const finteger*,fsingle*,const finteger*,
      fsingle*,const finteger*,fsingle*,const finteger*);

extern void F77CALL (slarnv) (const finteger*,finteger*,const finteger*,
      fsingle*);

extern void F77CALL (slartg) (const fsingle*,const fsingle*,fsingle*,
      fsingle*,fsingle*);

extern void F77CALL (slartv) (const finteger*,fsingle*,const finteger*,
      fsingle*,const finteger*,const fsingle*,const fsingle*,const finteger*);

extern void F77CALL (slaruv) (finteger*,const finteger*,fsingle*);

extern void F77CALL (slas2) (const fsingle*,const fsingle*,const fsingle*,
      fsingle*,fsingle*);

extern void F77CALL (slascl) (const char*,const finteger*,const finteger*,
      const fsingle*,const fsingle*,const finteger*,const finteger*,fsingle*,
      const finteger*,finteger*);

extern void F77CALL (slaset) (const char*,const finteger*,const finteger*,
      const fsingle*,const fsingle*,fsingle*,const finteger*);

extern void F77CALL (slasq1) (const finteger*,fsingle*,fsingle*,fsingle*,
      finteger*);

extern void F77CALL (slasq2) (const finteger*,fsingle*,fsingle*,fsingle*,
      fsingle*,const fsingle*,const fsingle*,const fsingle*,fsingle*,
      finteger*,finteger*);

extern void F77CALL (slasq3) (finteger*,fsingle*,fsingle*,fsingle*,fsingle*,
      fsingle*,fsingle*,finteger*,finteger*,finteger*,const finteger*,
      const fsingle*,const fsingle*,const fsingle*);

extern void F77CALL (slasq4) (const finteger*,const fsingle*,const fsingle*,
      fsingle*,fsingle*);

extern void F77CALL (slasr) (const char*,const char*,const char*,
      const finteger*,const finteger*,const fsingle*,const fsingle*,fsingle*,
      const finteger*);

extern void F77CALL (slasrt) (const char*,const finteger*,fsingle*,finteger*);

extern void F77CALL (slassq) (const finteger*,const fsingle*,const finteger*,
      fsingle*,fsingle*);

extern void F77CALL (slasv2) (const fsingle*,const fsingle*,const fsingle*,
      fsingle*,fsingle*,fsingle*,fsingle*,fsingle*,fsingle*);

extern void F77CALL (slaswp) (const finteger*,fsingle*,const finteger*,
      const finteger*,const finteger*,const finteger*,const finteger*);

extern void F77CALL (slasy2) (const flogical*,const flogical*,const finteger*,
      const finteger*,const finteger*,const fsingle*,const finteger*,
      const fsingle*,const finteger*,const fsingle*,const finteger*,fsingle*,
      fsingle*,const finteger*,fsingle*,finteger*);

extern void F77CALL (slasyf) (const char*,const finteger*,const finteger*,
      finteger*,fsingle*,const finteger*,finteger*,fsingle*,const finteger*,
      finteger*);

extern void F77CALL (slatbs) (const char*,const char*,const char*,const char*,
      const finteger*,const finteger*,const fsingle*,const finteger*,fsingle*,
      fsingle*,fsingle*,finteger*);

extern void F77CALL (slatps) (const char*,const char*,const char*,const char*,
      const finteger*,const fsingle*,fsingle*,fsingle*,fsingle*,finteger*);

extern void F77CALL (slatrd) (const char*,const finteger*,const finteger*,
      fsingle*,const finteger*,fsingle*,fsingle*,fsingle*,const finteger*);

extern void F77CALL (slatrs) (const char*,const char*,const char*,const char*,
      const finteger*,const fsingle*,const finteger*,fsingle*,fsingle*,
      fsingle*,finteger*);

extern void F77CALL (slatzm) (const char*,const finteger*,const finteger*,
      const fsingle*,const finteger*,const fsingle*,fsingle*,fsingle*,
      const finteger*,fsingle*);

extern void F77CALL (slauu2) (const char*,const finteger*,fsingle*,
      const finteger*,finteger*);

extern void F77CALL (slauum) (const char*,const finteger*,fsingle*,
      const finteger*,finteger*);

extern void F77CALL (sopgtr) (const char*,const finteger*,const fsingle*,
      const fsingle*,fsingle*,const finteger*,fsingle*,finteger*);

extern void F77CALL (sopmtr) (const char*,const char*,const char*,
      const finteger*,const finteger*,const fsingle*,const fsingle*,fsingle*,
      const finteger*,fsingle*,finteger*);

extern void F77CALL (sorg2l) (const finteger*,const finteger*,const finteger*,
      fsingle*,const finteger*,const fsingle*,fsingle*,finteger*);

extern void F77CALL (sorg2r) (const finteger*,const finteger*,const finteger*,
      fsingle*,const finteger*,const fsingle*,fsingle*,finteger*);

extern void F77CALL (sorgbr) (const char*,const finteger*,const finteger*,
      const finteger*,fsingle*,const finteger*,const fsingle*,fsingle*,
      const finteger*,finteger*);

extern void F77CALL (sorghr) (const finteger*,const finteger*,const finteger*,
      fsingle*,const finteger*,const fsingle*,fsingle*,const finteger*,
      finteger*);

extern void F77CALL (sorgl2) (const finteger*,const finteger*,const finteger*,
      fsingle*,const finteger*,const fsingle*,fsingle*,finteger*);

extern void F77CALL (sorglq) (const finteger*,const finteger*,const finteger*,
      fsingle*,const finteger*,const fsingle*,fsingle*,const finteger*,
      finteger*);

extern void F77CALL (sorgql) (const finteger*,const finteger*,const finteger*,
      fsingle*,const finteger*,const fsingle*,fsingle*,const finteger*,
      finteger*);

extern void F77CALL (sorgqr) (const finteger*,const finteger*,const finteger*,
      fsingle*,const finteger*,const fsingle*,fsingle*,const finteger*,
      finteger*);

extern void F77CALL (sorgr2) (const finteger*,const finteger*,const finteger*,
      fsingle*,const finteger*,const fsingle*,fsingle*,finteger*);

extern void F77CALL (sorgrq) (const finteger*,const finteger*,const finteger*,
      fsingle*,const finteger*,const fsingle*,fsingle*,const finteger*,
      finteger*);

extern void F77CALL (sorgtr) (const char*,const finteger*,fsingle*,
      const finteger*,const fsingle*,fsingle*,const finteger*,finteger*);

extern void F77CALL (sorm2l) (const char*,const char*,const finteger*,
      const finteger*,const finteger*,const fsingle*,const finteger*,
      const fsingle*,fsingle*,const finteger*,fsingle*,finteger*);

extern void F77CALL (sorm2r) (const char*,const char*,const finteger*,
      const finteger*,const finteger*,const fsingle*,const finteger*,
      const fsingle*,fsingle*,const finteger*,fsingle*,finteger*);

extern void F77CALL (sormbr) (const char*,const char*,const char*,
      const finteger*,const finteger*,const finteger*,const fsingle*,
      const finteger*,const fsingle*,fsingle*,const finteger*,fsingle*,
      const finteger*,finteger*);

extern void F77CALL (sormhr) (const char*,const char*,const finteger*,
      const finteger*,const finteger*,const finteger*,const fsingle*,
      const finteger*,const fsingle*,fsingle*,const finteger*,fsingle*,
      const finteger*,finteger*);

extern void F77CALL (sorml2) (const char*,const char*,const finteger*,
      const finteger*,const finteger*,const fsingle*,const finteger*,
      const fsingle*,fsingle*,const finteger*,fsingle*,finteger*);

extern void F77CALL (sormlq) (const char*,const char*,const finteger*,
      const finteger*,const finteger*,const fsingle*,const finteger*,
      const fsingle*,fsingle*,const finteger*,fsingle*,const finteger*,
      finteger*);

extern void F77CALL (sormql) (const char*,const char*,const finteger*,
      const finteger*,const finteger*,const fsingle*,const finteger*,
      const fsingle*,fsingle*,const finteger*,fsingle*,const finteger*,
      finteger*);

extern void F77CALL (sormqr) (const char*,const char*,const finteger*,
      const finteger*,const finteger*,const fsingle*,const finteger*,
      const fsingle*,fsingle*,const finteger*,fsingle*,const finteger*,
      finteger*);

extern void F77CALL (sormr2) (const char*,const char*,const finteger*,
      const finteger*,const finteger*,const fsingle*,const finteger*,
      const fsingle*,fsingle*,const finteger*,fsingle*,finteger*);

extern void F77CALL (sormrq) (const char*,const char*,const finteger*,
      const finteger*,const finteger*,const fsingle*,const finteger*,
      const fsingle*,fsingle*,const finteger*,fsingle*,const finteger*,
      finteger*);

extern void F77CALL (sormtr) (const char*,const char*,const char*,
      const finteger*,const finteger*,const fsingle*,const finteger*,
      const fsingle*,fsingle*,const finteger*,fsingle*,const finteger*,
      finteger*);

extern void F77CALL (spbcon) (const char*,const finteger*,const finteger*,
      const fsingle*,const finteger*,const fsingle*,fsingle*,fsingle*,
      finteger*,finteger*);

extern void F77CALL (spbequ) (const char*,const finteger*,const finteger*,
      const fsingle*,const finteger*,fsingle*,fsingle*,fsingle*,finteger*);

extern void F77CALL (spbrfs) (const char*,const finteger*,const finteger*,
      const finteger*,const fsingle*,const finteger*,const fsingle*,
      const finteger*,const fsingle*,const finteger*,fsingle*,const finteger*,
      fsingle*,fsingle*,fsingle*,finteger*,finteger*
			      );

extern void F77CALL (spbstf) (const char*,const finteger*,const finteger*,
      fsingle*,const finteger*,finteger*);

extern void F77CALL (spbsv) (const char*,const finteger*,const finteger*,
      const finteger*,fsingle*,const finteger*,fsingle*,const finteger*,
      finteger*);

extern void F77CALL (spbsvx) (const char*,const char*,const finteger*,
      const finteger*,const finteger*,fsingle*,const finteger*,fsingle*,
      const finteger*,char*,fsingle*,fsingle*,const finteger*,fsingle*,
      const finteger*,fsingle*,fsingle*,fsingle*,fsingle*,finteger*,finteger*);

extern void F77CALL (spbtf2) (const char*,const finteger*,const finteger*,
      fsingle*,const finteger*,finteger*);

extern void F77CALL (spbtrf) (const char*,const finteger*,const finteger*,
      fsingle*,const finteger*,finteger*);

extern void F77CALL (spbtrs) (const char*,const finteger*,const finteger*,
      const finteger*,const fsingle*,const finteger*,fsingle*,const finteger*,
      finteger*);

extern void F77CALL (spocon) (const char*,const finteger*,const fsingle*,
      const finteger*,const fsingle*,fsingle*,fsingle*,finteger*,finteger*);

extern void F77CALL (spoequ) (const finteger*,const fsingle*,const finteger*,
      fsingle*,fsingle*,fsingle*,finteger*);

extern void F77CALL (sporfs) (const char*,const finteger*,const finteger*,
      const fsingle*,const finteger*,const fsingle*,const finteger*,
      const fsingle*,const finteger*,fsingle*,const finteger*,fsingle*,
      fsingle*,fsingle*,finteger*,finteger*);

extern void F77CALL (sposv) (const char*,const finteger*,const finteger*,
      fsingle*,const finteger*,fsingle*,const finteger*,finteger*);

extern void F77CALL (sposvx) (const char*,const char*,const finteger*,
      const finteger*,fsingle*,const finteger*,fsingle*,const finteger*,
      char*,fsingle*,fsingle*,const finteger*,fsingle*,const finteger*,
      fsingle*,fsingle*,fsingle*,fsingle*,finteger*,finteger*);

extern void F77CALL (spotf2) (const char*,const finteger*,fsingle*,
      const finteger*,finteger*);

extern void F77CALL (spotrf) (const char*,const finteger*,fsingle*,
      const finteger*,finteger*);

extern void F77CALL (spotri) (const char*,const finteger*,fsingle*,
      const finteger*,finteger*);

extern void F77CALL (spotrs) (const char*,const finteger*,const finteger*,
      const fsingle*,const finteger*,fsingle*,const finteger*,finteger*);

extern void F77CALL (sppcon) (const char*,const finteger*,const fsingle*,
      const fsingle*,fsingle*,fsingle*,finteger*,finteger*);

extern void F77CALL (sppequ) (const char*,const finteger*,const fsingle*,
      fsingle*,fsingle*,fsingle*,finteger*);

extern void F77CALL (spprfs) (const char*,const finteger*,const finteger*,
      const fsingle*,const fsingle*,const fsingle*,const finteger*,fsingle*,
      const finteger*,fsingle*,fsingle*,fsingle*,finteger*,finteger*);

extern void F77CALL (sppsv) (const char*,const finteger*,const finteger*,
      fsingle*,fsingle*,const finteger*,finteger*);

extern void F77CALL (sppsvx) (const char*,const char*,const finteger*,
      const finteger*,fsingle*,fsingle*,char*,fsingle*,fsingle*,
      const finteger*,fsingle*,const finteger*,fsingle*,fsingle*,fsingle*,
      fsingle*,finteger*,finteger*);

extern void F77CALL (spptrf) (const char*,const finteger*,fsingle*,finteger*);

extern void F77CALL (spptri) (const char*,const finteger*,fsingle*,finteger*);

extern void F77CALL (spptrs) (const char*,const finteger*,const finteger*,
      const fsingle*,fsingle*,const finteger*,finteger*);

extern void F77CALL (sptcon) (const finteger*,const fsingle*,const fsingle*,
      const fsingle*,fsingle*,fsingle*,finteger*);

extern void F77CALL (spteqr) (const char*,const finteger*,fsingle*,
      fsingle*,fsingle*,const finteger*,fsingle*,finteger*);

extern void F77CALL (sptrfs) (const finteger*,const finteger*,const fsingle*,
      const fsingle*,const fsingle*,const fsingle*,const fsingle*,
      const finteger*,fsingle*,const finteger*,fsingle*,fsingle*,fsingle*,
      finteger*);

extern void F77CALL (sptsv) (const finteger*,const finteger*,fsingle*,
      fsingle*,fsingle*,const finteger*,finteger*);

extern void F77CALL (sptsvx) (const char*,const finteger*,const finteger*,
      const fsingle*,const fsingle*,fsingle*,fsingle*,const fsingle*,
      const finteger*,fsingle*,const finteger*,fsingle*,fsingle*,fsingle*,
      fsingle*,finteger*);

extern void F77CALL (spttrf) (const finteger*,fsingle*,fsingle*,finteger*);

extern void F77CALL (spttrs) (const finteger*,const finteger*,const fsingle*,
      const fsingle*,fsingle*,const finteger*,finteger*);

extern void F77CALL (srscl) (const finteger*,const fsingle*,fsingle*,
      const finteger*);

extern void F77CALL (ssbev) (const char*,const char*,const finteger*,
      const finteger*,fsingle*,const finteger*,fsingle*,fsingle*,
      const finteger*,fsingle*,finteger*);

extern void F77CALL (ssbevd) (const char*,const char*,const finteger*,
      const finteger*,fsingle*,const finteger*,fsingle*,fsingle*,
      const finteger*,fsingle*,const finteger*,finteger*,const finteger*,
      finteger*);

extern void F77CALL (ssbevx) (const char*,const char*,const char*,
      const finteger*,const finteger*,fsingle*,const finteger*,fsingle*,
      const finteger*,const fsingle*,const fsingle*,const finteger*,
      const finteger*,const fsingle*,finteger*,fsingle*,fsingle*,
      const finteger*,fsingle*,finteger*,finteger*,finteger*);

extern void F77CALL (ssbgst) (const char*,const char*,const finteger*,
      const finteger*,const finteger*,fsingle*,const finteger*,const fsingle*,
      const finteger*,fsingle*,const finteger*,fsingle*,finteger*);

extern void F77CALL (ssbgv) (const char*,const char*,const finteger*,
      const finteger*,const finteger*,fsingle*,const finteger*,fsingle*,
      const finteger*,fsingle*,fsingle*,const finteger*,fsingle*,finteger*);

extern void F77CALL (ssbtrd) (const char*,const char*,const finteger*,
      const finteger*,fsingle*,const finteger*,fsingle*,fsingle*,fsingle*,
      const finteger*,fsingle*,finteger*);


#ifdef USE_F2C
extern fsingle F77CALL (ssecnd) (void);
#else
extern fsingle F77CALL (ssecnd) (void);
#endif

extern void F77CALL (sspcon) (const char*,const finteger*,const fsingle*,
      const finteger*,const fsingle*,fsingle*,fsingle*,finteger*,finteger*);

extern void F77CALL (sspev) (const char*,const char*,const finteger*,fsingle*,
      fsingle*,fsingle*,const finteger*,fsingle*,finteger*);

extern void F77CALL (sspevd) (const char*,const char*,const finteger*,fsingle*,
      fsingle*,fsingle*,const finteger*,fsingle*,const finteger*,finteger*,
      const finteger*,finteger*);

extern void F77CALL (sspevx) (const char*,const char*,const char*,
      const finteger*,fsingle*,const fsingle*,const fsingle*,const finteger*,
      const finteger*,const fsingle*,finteger*,fsingle*,fsingle*,
      const finteger*,fsingle*,finteger*,finteger*,finteger*);

extern void F77CALL (sspgst) (const finteger*,const char*,const finteger*,
      fsingle*,const fsingle*,finteger*);

extern void F77CALL (sspgv) (const finteger*,const char*,const char*,
      const finteger*,fsingle*,fsingle*,fsingle*,fsingle*,const finteger*,
      fsingle*,finteger*);

extern void F77CALL (ssprfs) (const char*,const finteger*,const finteger*,
      const fsingle*,const fsingle*,const finteger*,const fsingle*,
      const finteger*,fsingle*,const finteger*,fsingle*,fsingle*,fsingle*,
      finteger*,finteger*);

extern void F77CALL (sspsv) (const char*,const finteger*,const finteger*,
      fsingle*,finteger*,fsingle*,const finteger*,finteger*);

extern void F77CALL (sspsvx) (const char*,const char*,const finteger*,
      const finteger*,const fsingle*,fsingle*,finteger*,const fsingle*,
      const finteger*,fsingle*,const finteger*,fsingle*,fsingle*,fsingle*,
      fsingle*,finteger*,finteger*);

extern void F77CALL (ssptrd) (const char*,const finteger*,fsingle*,
      fsingle*,fsingle*,fsingle*,finteger*);

extern void F77CALL (ssptrf) (const char*,const finteger*,fsingle*,finteger*,
      finteger*);

extern void F77CALL (ssptri) (const char*,const finteger*,fsingle*,
      const finteger*,fsingle*,finteger*);

extern void F77CALL (ssptrs) (const char*,const finteger*,const finteger*,
      const fsingle*,const finteger*,fsingle*,const finteger*,finteger*
			      );

extern void F77CALL (sstebz) (const char*,const char*,const finteger*,
      const fsingle*,const fsingle*,const finteger*,const finteger*,
      const fsingle*,const fsingle*,const fsingle*,finteger*,finteger*,
      fsingle*,finteger*,finteger*,fsingle*,finteger*,finteger*);

extern void F77CALL (sstedc) (const char*,const finteger*,fsingle*,
      fsingle*,fsingle*,const finteger*,fsingle*,const finteger*,
      finteger*,const finteger*,finteger*);

extern void F77CALL (sstein) (const finteger*,const fsingle*,const fsingle*,
      const finteger*,const fsingle*,const finteger*,const finteger*,
      fsingle*,const finteger*,fsingle*,finteger*,finteger*,finteger*);

extern void F77CALL (ssteqr) (const char*,const finteger*,fsingle*,
      fsingle*,fsingle*,const finteger*,fsingle*,finteger*);

extern void F77CALL (ssterf) (const finteger*,fsingle*,fsingle*,finteger*);

extern void F77CALL (sstev) (const char*,const finteger*,fsingle*,fsingle*,
      fsingle*,const finteger*,fsingle*,finteger*);

extern void F77CALL (sstevd) (const char*,const finteger*,fsingle*,fsingle*,
      fsingle*,const finteger*,fsingle*,const finteger*,finteger*,
      const finteger*,finteger*);

extern void F77CALL (sstevx) (const char*,const char*,const finteger*,fsingle*,
      fsingle*,const fsingle*,const fsingle*,const finteger*,const finteger*,
      const fsingle*,finteger*,fsingle*,fsingle*,const finteger*,fsingle*,
      finteger*,finteger*,finteger*);

extern void F77CALL (ssycon) (const char*,const finteger*,const fsingle*,
      const finteger*,const finteger*,const fsingle*,fsingle*,fsingle*,
      finteger*,finteger*);

extern void F77CALL (ssyev) (const char*,const char*,const finteger*,fsingle*,
      const finteger*,fsingle*,fsingle*,const finteger*,finteger*);

extern void F77CALL (ssyevd) (const char*,const char*,const finteger*,fsingle*,
      const finteger*,fsingle*,fsingle*,const finteger*,finteger*,
      const finteger*,finteger*);

extern void F77CALL (ssyevx) (const char*,const char*,const char*,
      const finteger*,fsingle*,const finteger*,const fsingle*,const fsingle*,
      const finteger*,const finteger*,const fsingle*,finteger*,fsingle*,
      fsingle*,const finteger*,fsingle*,const finteger*,finteger*,finteger*,
      finteger*);

extern void F77CALL (ssygs2) (const finteger*,const char*,const finteger*,
      fsingle*,const finteger*,const fsingle*,const finteger*,finteger*);

extern void F77CALL (ssygst) (const finteger*,const char*,const finteger*,
      fsingle*,const finteger*,const fsingle*,const finteger*,finteger*);

extern void F77CALL (ssygv) (const finteger*,const char*,const char*,
      const finteger*,fsingle*,const finteger*,fsingle*,const finteger*,
      fsingle*,fsingle*,const finteger*,finteger*);

extern void F77CALL (ssyrfs) (const char*,const finteger*,const finteger*,
      const fsingle*,const finteger*,const fsingle*,const finteger*,
      const finteger*,const fsingle*,const finteger*,fsingle*,const finteger*,
      fsingle*,fsingle*,fsingle*,finteger*,finteger*);

extern void F77CALL (ssysv) (const char*,const finteger*,const finteger*,
      fsingle*,const finteger*,finteger*,fsingle*,const finteger*,fsingle*,
      const finteger*,finteger*);

extern void F77CALL (ssysvx) (const char*,const char*,const finteger*,
      const finteger*,const fsingle*,const finteger*,fsingle*,const finteger*,
      finteger*,const fsingle*,const finteger*,fsingle*,const finteger*,
      fsingle*,fsingle*,fsingle*,fsingle*,const finteger*,finteger*,finteger*);

extern void F77CALL (ssytd2) (const char*,const finteger*,fsingle*,
      const finteger*,fsingle*,fsingle*,fsingle*,finteger*);

extern void F77CALL (ssytf2) (const char*,const finteger*,fsingle*,
      const finteger*,finteger*,finteger*);

extern void F77CALL (ssytrd) (const char*,const finteger*,fsingle*,
      const finteger*,fsingle*,fsingle*,fsingle*,fsingle*,const finteger*,
      finteger*);

extern void F77CALL (ssytrf) (const char*,const finteger*,fsingle*,
      const finteger*,finteger*,fsingle*,const finteger*,finteger*);

extern void F77CALL (ssytri) (const char*,const finteger*,fsingle*,
      const finteger*,const finteger*,fsingle*,finteger*);

extern void F77CALL (ssytrs) (const char*,const finteger*,const finteger*,
      const fsingle*,const finteger*,const finteger*,fsingle*,const finteger*,
      finteger*);

extern void F77CALL (stbcon) (const char*,const char*,const char*,
      const finteger*,const finteger*,const fsingle*,const finteger*,fsingle*,
      fsingle*,finteger*,finteger*);

extern void F77CALL (stbrfs) (const char*,const char*,const char*,
      const finteger*,const finteger*,const finteger*,const fsingle*,
      const finteger*,const fsingle*,const finteger*,const fsingle*,
      const finteger*,fsingle*,fsingle*,fsingle*,finteger*,finteger*);

extern void F77CALL (stbtrs) (const char*,const char*,const char*,
      const finteger*,const finteger*,const finteger*,const fsingle*,
      const finteger*,fsingle*,const finteger*,finteger*);

extern void F77CALL (stgevc) (const char*,const char*,const flogical*,
      const finteger*,const fsingle*,const finteger*,const fsingle*,
      const finteger*,fsingle*,const finteger*,fsingle*,const finteger*,
      const finteger*,finteger*,fsingle*,finteger*);

extern void F77CALL (stgsja) (const char*,const char*,const char*,
      const finteger*,const finteger*,const finteger*,const finteger*,
      const finteger*,fsingle*,const finteger*,fsingle*,const finteger*,
      const fsingle*,const fsingle*,fsingle*,fsingle*,fsingle*,const finteger*,
      fsingle*,const finteger*,fsingle*,const finteger*,fsingle*,finteger*,
      finteger*);

extern void F77CALL (stpcon) (const char*,const char*,const char*,
      const finteger*,const fsingle*,fsingle*,fsingle*,finteger*,finteger*);

extern void F77CALL (stprfs) (const char*,const char*,const char*,
      const finteger*,const finteger*,const fsingle*,const fsingle*,
      const finteger*,const fsingle*,const finteger*,fsingle*,fsingle*,
      fsingle*,finteger*,finteger*);

extern void F77CALL (stptri) (const char*,const char*,const finteger*,fsingle*,
      finteger*);

extern void F77CALL (stptrs) (const char*,const char*,const char*,
      const finteger*,const finteger*,const fsingle*,fsingle*,const finteger*,
      finteger*);

extern void F77CALL (strcon) (const char*,const char*,const char*,
      const finteger*,const fsingle*,const finteger*,fsingle*,fsingle*,
      finteger*,finteger*);

extern void F77CALL (strevc) (const char*,const char*,flogical*,
      const finteger*,const fsingle*,const finteger*,fsingle*,const finteger*,
      fsingle*,const finteger*,const finteger*,finteger*,fsingle*,finteger*);

extern void F77CALL (strexc) (const char*,const finteger*,fsingle*,
      const finteger*,fsingle*,const finteger*,finteger*,finteger*,
      fsingle*,finteger*);

extern void F77CALL (strrfs) (const char*,const char*,const char*,
      const finteger*,const finteger*,const fsingle*,const finteger*,
      const fsingle*,const finteger*,const fsingle*,const finteger*,
      fsingle*,fsingle*,fsingle*,finteger*,finteger*);

extern void F77CALL (strsen) (const char*,const char*,const flogical*,
      const finteger*,fsingle*,const finteger*,fsingle*,const finteger*,
      fsingle*,fsingle*,finteger*,fsingle*,fsingle*,fsingle*,const finteger*,
      finteger*,const finteger*,finteger*);

extern void F77CALL (strsna) (const char*,const char*,const flogical*,
      const finteger*,const fsingle*,const finteger*,const fsingle*,
      const finteger*,const fsingle*,const finteger*,fsingle*,fsingle*,
      const finteger*,finteger*,fsingle*,const finteger*,finteger*,finteger*);

extern void F77CALL (strsyl) (const char*,const char*,const finteger*,
      const finteger*,const finteger*,const fsingle*,const finteger*,
      const fsingle*,const finteger*,fsingle*,const finteger*,fsingle*,
      finteger*);

extern void F77CALL (strti2) (const char*,const char*,const finteger*,fsingle*,
      const finteger*,finteger*);

extern void F77CALL (strtri) (const char*,const char*,const finteger*,fsingle*,
      const finteger*,finteger*);

extern void F77CALL (strtrs) (const char*,const char*,const char*,
      const finteger*,const finteger*,const fsingle*,const finteger*,fsingle*,
      const finteger*,finteger*);

extern void F77CALL (stzrqf) (const finteger*,const finteger*,fsingle*,
      const finteger*,fsingle*,finteger*);

#ifdef USE_F2C
extern fsingle F77CALL (scsum1) (const finteger*,const fsinglecomplex*,
      const finteger*);
#else
extern fsingle F77CALL (scsum1) (const finteger*,const fsinglecomplex*,
      const finteger*);
#endif

/* extern void F77CALL (xerbla) (const char*,const finteger*); */

extern void F77CALL (zbdsqr) (const char*,const finteger*,const finteger*,
      const finteger*,const finteger*,fdouble*,fdouble*,fdoublecomplex*,
      const finteger*,fdoublecomplex*,const finteger*,fdoublecomplex*,
      const finteger*,fdouble*,finteger*);

extern void F77CALL (zgbbrd) (const char*,const finteger*,const finteger*,
      const finteger*,const finteger*,const finteger*,fdoublecomplex*,
      const finteger*,fdouble*,fdouble*,fdoublecomplex*,const finteger*,
      fdoublecomplex*,const finteger*,fdoublecomplex*,const finteger*,
      fdoublecomplex*,fdouble*,finteger*);

extern void F77CALL (zgbcon) (const char*,const finteger*,const finteger*,
      const finteger*,const fdoublecomplex*,const finteger*,const finteger*,
      const fdouble*,fdouble*,fdoublecomplex*,fdouble*,finteger*);

extern void F77CALL (zgbequ) (const finteger*,const finteger*,const finteger*,
      const finteger*,const fdoublecomplex*,const finteger*,fdouble*,fdouble*,
      fdouble*,fdouble*,fdouble*,finteger*);

extern void F77CALL (zgbrfs) (const char*,const finteger*,const finteger*,
      const finteger*,const finteger*,const fdoublecomplex*,const finteger*,
      const fdoublecomplex*,const finteger*,const finteger*,
      const fdoublecomplex*,const finteger*,fdoublecomplex*,const finteger*,
      fdouble*,fdouble*,fdoublecomplex*,fdouble*,finteger*);

extern void F77CALL (zgbsv) (const finteger*,const finteger*,const finteger*,
      const finteger*,fdoublecomplex*,const finteger*,finteger*,
      fdoublecomplex*,const finteger*,finteger*);

extern void F77CALL (zgbsvx) (const char*,const char*,const finteger*,
      const finteger*,const finteger*,const finteger*,fdoublecomplex*,
      const finteger*,fdoublecomplex*,const finteger*,finteger*,char*,fdouble*,
      fdouble*,fdoublecomplex*,const finteger*,fdoublecomplex*,const finteger*,
      fdouble*,fdouble*,fdouble*,fdoublecomplex*,fdouble*,finteger*);

extern void F77CALL (zgbtf2) (const finteger*,const finteger*,const finteger*,
      const finteger*,fdoublecomplex*,const finteger*,finteger*,finteger*);

extern void F77CALL (zgbtrf) (const finteger*,const finteger*,const finteger*,
      const finteger*,fdoublecomplex*,const finteger*,finteger*,finteger*);

extern void F77CALL (zgbtrs) (const char*,const finteger*,const finteger*,
      const finteger*,const finteger*,const fdoublecomplex*,const finteger*,
      const finteger*,fdoublecomplex*,const finteger*,finteger*);

extern void F77CALL (zgebak) (const char*,const char*,const finteger*,
      const finteger*,const finteger*,const fdouble*,const finteger*,
      fdoublecomplex*,const finteger*,finteger*);

extern void F77CALL (zgebal) (const char*,const finteger*,fdoublecomplex*,
      const finteger*,finteger*,finteger*,fdouble*,finteger*);

extern void F77CALL (zgebd2) (const finteger*,const finteger*,
      fdoublecomplex*,const finteger*,fdouble*,fdouble*,fdoublecomplex*,
      fdoublecomplex*,fdoublecomplex*,finteger*);

extern void F77CALL (zgebrd) (const finteger*,const finteger*,fdoublecomplex*,
      const finteger*,fdouble*,fdouble*,fdoublecomplex*,fdoublecomplex*,
      fdoublecomplex*,const finteger*,finteger*);

extern void F77CALL (zgecon) (const char*,const finteger*,
      const fdoublecomplex*,const finteger*,const fdouble*,fdouble*,
      fdoublecomplex*,fdouble*,finteger*);

extern void F77CALL (zgeequ) (const finteger*,const finteger*,
      const fdoublecomplex*,const finteger*,fdouble*,fdouble*,fdouble*,
      fdouble*,fdouble*,finteger*);

extern void F77CALL (zgees) (const char*,const char*,fcselectfunction,
      const finteger*,fdoublecomplex*,const finteger*,finteger*,
      fdoublecomplex*,fdoublecomplex*,const finteger*,fdoublecomplex*,
      const finteger*,fdouble*,flogical*,finteger*);

extern void F77CALL (zgeesx) (const char*,const char*,fcselectfunction,
      const char*,const finteger*,fdoublecomplex*,const finteger*,finteger*,
      fdoublecomplex*,fdoublecomplex*,const finteger*,fdouble*,fdouble*,
      fdoublecomplex*,const finteger*,fdouble*,flogical*,finteger*);

extern void F77CALL (zgeev) (const char*,const char*,const finteger*,
      fdoublecomplex*,const finteger*,fdoublecomplex*,fdoublecomplex*,
      const finteger*,fdoublecomplex*,const finteger*,fdoublecomplex*,
      const finteger*,fdouble*,finteger*);

extern void F77CALL (zgeevx) (const char*,const char*,const char*,const char*,
      const finteger*,fdoublecomplex*,const finteger*,fdoublecomplex*,
      fdoublecomplex*,const finteger*,fdoublecomplex*,const finteger*,
      finteger*,finteger*,fdouble*,fdouble*,fdouble*,fdouble*,fdoublecomplex*,
      const finteger*,fdouble*,finteger*);

extern void F77CALL (zgegs) (const char*,const char*,const finteger*,
      fdoublecomplex*,const finteger*,fdoublecomplex*,const finteger*,
      fdoublecomplex*,fdoublecomplex*,fdoublecomplex*,const finteger*,
      fdoublecomplex*,const finteger*,fdoublecomplex*,const finteger*,
      fdouble*,finteger*);

extern void F77CALL (zgegv) (const char*,const char*,const finteger*,
      fdoublecomplex*,const finteger*,fdoublecomplex*,const finteger*,
      fdoublecomplex*,fdoublecomplex*,fdoublecomplex*,const finteger*,
      fdoublecomplex*,const finteger*,fdoublecomplex*,const finteger*,
      fdouble*,finteger*);

extern void F77CALL (zgehd2) (const finteger*,const finteger*,const finteger*,
      fdoublecomplex*,const finteger*,fdoublecomplex*,fdoublecomplex*,
      finteger*);

extern void F77CALL (zgehrd) (const finteger*,const finteger*,const finteger*,
      fdoublecomplex*,const finteger*,fdoublecomplex*,fdoublecomplex*,
      const finteger*,finteger*);

extern void F77CALL (zgelq2) (const finteger*,const finteger*,fdoublecomplex*,
      const finteger*,fdoublecomplex*,fdoublecomplex*,finteger*);

extern void F77CALL (zgelqf) (const finteger*,const finteger*,fdoublecomplex*,
      const finteger*,fdoublecomplex*,fdoublecomplex*,const finteger*,
      finteger*);

extern void F77CALL (zgels) (const char*,const finteger*,const finteger*,
      const finteger*,fdoublecomplex*,const finteger*,fdoublecomplex*,
      const finteger*,fdoublecomplex*,const finteger*,finteger*);

extern void F77CALL (zgelss) (const finteger*,const finteger*,const finteger*,
      fdoublecomplex*,const finteger*,fdoublecomplex*,const finteger*,
      fdouble*,const fdouble*,finteger*,fdoublecomplex*,const finteger*,
      fdouble*,finteger*);

extern void F77CALL (zgelsx) (const finteger*,const finteger*,const finteger*,
      fdoublecomplex*,const finteger*,fdoublecomplex*,const finteger*,
      finteger*,const fdouble*,finteger*,fdoublecomplex*,fdouble*,finteger*);

extern void F77CALL (zgeql2) (const finteger*,const finteger*,fdoublecomplex*,
      const finteger*,fdoublecomplex*,fdoublecomplex*,finteger*);

extern void F77CALL (zgeqlf) (const finteger*,const finteger*,fdoublecomplex*,
      const finteger*,fdoublecomplex*,fdoublecomplex*,const finteger*,
      finteger*);

extern void F77CALL (zgeqpf) (const finteger*,const finteger*,fdoublecomplex*,
      const finteger*,finteger*,fdoublecomplex*,fdoublecomplex*,fdouble*,
      finteger*);

extern void F77CALL (zgeqr2) (const finteger*,const finteger*,fdoublecomplex*,
      const finteger*,fdoublecomplex*,fdoublecomplex*,finteger*);

extern void F77CALL (zgeqrf) (const finteger*,const finteger*,fdoublecomplex*,
      const finteger*,fdoublecomplex*,fdoublecomplex*,const finteger*,
      finteger*);

extern void F77CALL (zgerfs) (const char*,const finteger*,const finteger*,
      const fdoublecomplex*,const finteger*,const fdoublecomplex*,
      const finteger*,const finteger*,const fdoublecomplex*,const finteger*,
      fdoublecomplex*,const finteger*,fdouble*,fdouble*,fdoublecomplex*,
      fdouble*,finteger*);

extern void F77CALL (zgerq2) (const finteger*,const finteger*,fdoublecomplex*,
      const finteger*,fdoublecomplex*,fdoublecomplex*,finteger*);

extern void F77CALL (zgerqf) (const finteger*,const finteger*,fdoublecomplex*,
      const finteger*,fdoublecomplex*,fdoublecomplex*,const finteger*,
      finteger*);

extern void F77CALL (zgesv) (const finteger*,const finteger*,fdoublecomplex*,
      const finteger*,finteger*,fdoublecomplex*,const finteger*,finteger*);

extern void F77CALL (zgesvd) (const char*,const char*,const finteger*,
      const finteger*,fdoublecomplex*,const finteger*,fdouble*,fdoublecomplex*,
      const finteger*,fdoublecomplex*,const finteger*,fdoublecomplex*,
      const finteger*,fdouble*,finteger*);

extern void F77CALL (zgesvx) (const char*,const char*,const finteger*,
      const finteger*,fdoublecomplex*,const finteger*,fdoublecomplex*,
      const finteger*,finteger*,char*,fdouble*,fdouble*,fdoublecomplex*,
      const finteger*,fdoublecomplex*,const finteger*,fdouble*,fdouble*,
      fdouble*,fdoublecomplex*,fdouble*,finteger*);

extern void F77CALL (zgetf2) (const finteger*,const finteger*,fdoublecomplex*,
      const finteger*,finteger*,finteger*);

extern void F77CALL (zgetrf) (const finteger*,const finteger*,fdoublecomplex*,
      const finteger*,finteger*,finteger*);

extern void F77CALL (zgetri) (const finteger*,fdoublecomplex*,const finteger*,
      const finteger*,fdoublecomplex*,const finteger*,finteger*);

extern void F77CALL (zgetrs) (const char*,const finteger*,const finteger*,
      const fdoublecomplex*,const finteger*,const finteger*,fdoublecomplex*,
      const finteger*,finteger*);

extern void F77CALL (zggbak) (const char*,const char*,const finteger*,
      const finteger*,const finteger*,const fdouble*,const fdouble*,
      const finteger*,fdoublecomplex*,const finteger*,finteger*);

extern void F77CALL (zggbal) (const char*,const finteger*,fdoublecomplex*,
      const finteger*,fdoublecomplex*,const finteger*,finteger*,finteger*,
      fdouble*,fdouble*,fdouble*,finteger*);

extern void F77CALL (zggglm) (const finteger*,const finteger*,const finteger*, 
      fdoublecomplex*,const finteger*,fdoublecomplex*,const finteger*,
      fdoublecomplex*,fdoublecomplex*,fdoublecomplex*,fdoublecomplex*,
      const finteger*,finteger*);

extern void F77CALL (zgghrd) (const char*,const char*,const finteger*,
      const finteger*,const finteger*,fdoublecomplex*,const finteger*,
      fdoublecomplex*,const finteger*,fdoublecomplex*,const finteger*,
      fdoublecomplex*,const finteger*,finteger*);

extern void F77CALL (zgglse) (const finteger*,const finteger*,const finteger*, 
      fdoublecomplex*,const finteger*,fdoublecomplex*,const finteger*,
      fdoublecomplex*,fdoublecomplex*,fdoublecomplex*,fdoublecomplex*,
      const finteger*,finteger*);

extern void F77CALL (zggqrf) (const finteger*,const finteger*,const finteger*,
      fdoublecomplex*,const finteger*,fdoublecomplex*,fdoublecomplex*,
      const finteger*,fdoublecomplex*,fdoublecomplex*,const finteger*,
      finteger*);

extern void F77CALL (zggrqf) (const finteger*,const finteger*,const finteger*, 
      fdoublecomplex*,const finteger*,fdoublecomplex*,fdoublecomplex*,
      const finteger*,fdoublecomplex*,fdoublecomplex*,const finteger*,
      finteger*);

extern void F77CALL (zggsvd) (const char*,const char*,const char*,
      const finteger*,const finteger*,const finteger*,finteger*,finteger*,
      fdoublecomplex*,const finteger*,fdoublecomplex*,const finteger*,
      fdouble*,fdouble*,fdoublecomplex*,const finteger*,fdoublecomplex*,
      const finteger*,fdoublecomplex*,const finteger*,fdoublecomplex*,fdouble*,
      finteger*,finteger*);

extern void F77CALL (zggsvp) (const char*,const char*,const char*,
      const finteger*,const finteger*,const finteger*,fdoublecomplex*,
      const finteger*,fdoublecomplex*,const finteger*,const fdouble*,
      const fdouble*,finteger*,finteger*,fdoublecomplex*,const finteger*,
      fdoublecomplex*,const finteger*,fdoublecomplex*,const finteger*,
      finteger*,fdouble*,fdoublecomplex*,fdoublecomplex*,finteger*);

extern void F77CALL (zgtcon) (const char*,const finteger*,
      const fdoublecomplex*,const fdoublecomplex*,const fdoublecomplex*,
      const fdoublecomplex*,const finteger*,const fdouble*,fdouble*,
      fdoublecomplex*,finteger*);

extern void F77CALL (zgtrfs) (const char*,const finteger*,const finteger*,
      const fdoublecomplex*,const fdoublecomplex*,const fdoublecomplex*,
      const fdoublecomplex*,const fdoublecomplex*,const fdoublecomplex*,
      const fdoublecomplex*,const finteger*,const fdoublecomplex*,
      const finteger*,fdoublecomplex*,const finteger*,fdouble*,fdouble*,
      fdoublecomplex*,fdouble*,finteger*);

extern void F77CALL (zgtsv) (const finteger*,const finteger*,fdoublecomplex*,
      fdoublecomplex*,fdoublecomplex*,fdoublecomplex*,const finteger*,
      finteger*);

extern void F77CALL (zgtsvx) (const char*,const char*,const finteger*,
      const finteger*,const fdoublecomplex*,const fdoublecomplex*,
      const fdoublecomplex*,fdoublecomplex*,fdoublecomplex*,fdoublecomplex*,
      fdoublecomplex*,finteger*,const fdoublecomplex*,const finteger*,
      fdoublecomplex*,const finteger*,fdouble*,fdouble*,fdouble*,
      fdoublecomplex*,fdouble*,finteger*);

extern void F77CALL (zgttrf) (const finteger*,fdoublecomplex*,fdoublecomplex*,
      fdoublecomplex*,fdoublecomplex*,finteger*,finteger*);

extern void F77CALL (zgttrs) (const char*,const finteger*,const finteger*,
      const fdoublecomplex*,const fdoublecomplex*,const fdoublecomplex*,
      const fdoublecomplex*,const finteger*,fdoublecomplex*,const finteger*,
      finteger*);

extern void F77CALL (zhbev) (const char*,const char*,const finteger*,
      const finteger*,fdoublecomplex*,const finteger*,fdouble*,fdoublecomplex*,
      const finteger*,fdoublecomplex*,fdouble*,finteger*);

extern void F77CALL (zhbevd) (const char*,const char*,const finteger*,
      const finteger*,fdoublecomplex*,const finteger*,fdouble*,
      fdoublecomplex*,const finteger*,fdoublecomplex*,const finteger*,fdouble*,
      const finteger*,finteger*,const finteger*,finteger*);

extern void F77CALL (zhbevx) (const char*,const char*,const char*,
      const finteger*,const finteger*,fdoublecomplex*,const finteger*,
      fdoublecomplex*,const finteger*,const fdouble*,const fdouble*,
      const finteger*,const finteger*,const fdouble*,finteger*,fdouble*,
      fdoublecomplex*,const finteger*,fdoublecomplex*,fdouble*,finteger*,
      finteger*,finteger*);

extern void F77CALL (zhbgst) (const char*,const char*,const finteger*,
      const finteger*,const finteger*,fdoublecomplex*,const finteger*,
      const fdoublecomplex*,const finteger*,fdoublecomplex*,const finteger*,
      fdoublecomplex*,fdouble*,finteger*);

extern void F77CALL (zhbgv) (const char*,const char*,const finteger*,const finteger*,const finteger*,
      fdoublecomplex*,const finteger*,fdoublecomplex*,const finteger*,fdouble*,
      fdoublecomplex*,const finteger*,fdoublecomplex*,fdouble*,finteger*);

extern void F77CALL (zhbtrd) (const char*,const char*,const finteger*,
      const finteger*,fdoublecomplex*,const finteger*,fdouble*,fdouble*,
      fdoublecomplex*,const finteger*,fdoublecomplex*,finteger*);

extern void F77CALL (zhecon) (const char*,const finteger*,
      const fdoublecomplex*,const finteger*,const finteger*,const fdouble*,
      fdouble*,fdoublecomplex*,finteger*);

extern void F77CALL (zheev) (const char*,const char*,const finteger*,
      fdoublecomplex*,const finteger*,fdouble*,fdoublecomplex*,const finteger*,
      fdouble*,finteger*);

extern void F77CALL (zheevd) (const char*,const char*,const finteger*,
      fdoublecomplex*,const finteger*,fdouble*,fdoublecomplex*,
      const finteger*,fdouble*,const finteger*,finteger*,const finteger*,
      finteger*);

extern void F77CALL (zheevx) (const char*,const char*,const char*,
      const finteger*,fdoublecomplex*,const finteger*,const fdouble*,
      const fdouble*,const finteger*,const finteger*,const fdouble*,finteger*,
      fdouble*,fdoublecomplex*,const finteger*,fdoublecomplex*,const finteger*,
      fdouble*,finteger*,finteger*,finteger*);

extern void F77CALL (zhegs2) (const finteger*,const char*,const finteger*,
      fdoublecomplex*,const finteger*,const fdoublecomplex*,const finteger*,
      finteger*);

extern void F77CALL (zhegst) (const finteger*,const char*,const finteger*,
      fdoublecomplex*,const finteger*,const fdoublecomplex*,const finteger*,
      finteger*);

extern void F77CALL (zhegv) (const finteger*,const char*,const char*,
      const finteger*,fdoublecomplex*,const finteger*,fdoublecomplex*,
      const finteger*,fdouble*,fdoublecomplex*,const finteger*,fdouble*,
      finteger*);

extern void F77CALL (zherfs) (const char*,const finteger*,const finteger*,
      const fdoublecomplex*,const finteger*,const fdoublecomplex*,
      const finteger*,const finteger*,const fdoublecomplex*,const finteger*,
      fdoublecomplex*,const finteger*,fdouble*,fdouble*,fdoublecomplex*,
      fdouble*,finteger*);

extern void F77CALL (zhesv) (const char*,const finteger*,const finteger*,
      fdoublecomplex*,const finteger*,finteger*,fdoublecomplex*,
      const finteger*,fdoublecomplex*,const finteger*,finteger*);

extern void F77CALL (zhesvx) (const char*,const char*,const finteger*,
      const finteger*,const fdoublecomplex*,const finteger*,fdoublecomplex*,
      const finteger*,finteger*,const fdoublecomplex*,const finteger*,
      fdoublecomplex*,const finteger*,fdouble*,fdouble*,fdouble*,
      fdoublecomplex*,const finteger*,fdouble*,finteger*);

extern void F77CALL (zhetd2) (const char*,const finteger*,fdoublecomplex*,
      const finteger*,fdouble*,fdouble*,fdoublecomplex*,finteger*);

extern void F77CALL (zhetf2) (const char*,const finteger*,fdoublecomplex*,
      const finteger*,finteger*,finteger*);

extern void F77CALL (zhetrd) (const char*,const finteger*,fdoublecomplex*,
      const finteger*,fdouble*,fdouble*,fdoublecomplex*,fdoublecomplex*,
      const finteger*,finteger*);

extern void F77CALL (zhetrf) (const char*,const finteger*,fdoublecomplex*,
      const finteger*,finteger*,fdoublecomplex*,const finteger*,finteger*);

extern void F77CALL (zhetri) (const char*,const finteger*,fdoublecomplex*,
      const finteger*,const finteger*,fdoublecomplex*,finteger*);

extern void F77CALL (zhetrs) (const char*,const finteger*,const finteger*,
      const fdoublecomplex*,const finteger*,const finteger*,fdoublecomplex*,
      const finteger*,finteger*);

extern void F77CALL (zhgeqz) (const char*,const char*,const char*,
      const finteger*,const finteger*,const finteger*,fdoublecomplex*,
      const finteger*,fdoublecomplex*,const finteger*,fdoublecomplex*,
      fdoublecomplex*,fdoublecomplex*,const finteger*,fdoublecomplex*,
      const finteger*,fdoublecomplex*,const finteger*,fdouble*,finteger*);

extern void F77CALL (zhpcon) (const char*,const finteger*,
      const fdoublecomplex*,const finteger*,const fdouble*,fdouble*,
      fdoublecomplex*,finteger*);

extern void F77CALL (zhpev) (const char*,const char*,const finteger*,
      fdoublecomplex*,fdouble*,fdoublecomplex*,const finteger*,
      fdoublecomplex*,fdouble*,finteger*);

extern void F77CALL (zhpevd) (const char*,const char*,const finteger*,
      fdoublecomplex*,fdouble*,fdoublecomplex*,const finteger*,fdoublecomplex*,
      const finteger*,fdouble*,const finteger*,finteger*,const finteger*,
      finteger*);

extern void F77CALL (zhpevx) (const char*,const char*,const char*,
      const finteger*,fdoublecomplex*,const fdouble*,const fdouble*,
      const finteger*,const finteger*,const fdouble*,finteger*,fdouble*,
      fdoublecomplex*,const finteger*,fdoublecomplex*,fdouble*,finteger*,
      finteger*,finteger*);

extern void F77CALL (zhpgst) (const finteger*,const char*,const finteger*,
      fdoublecomplex*,const fdoublecomplex*,finteger*);

extern void F77CALL (zhpgv) (const finteger*,const char*,const char*,
      const finteger*,fdoublecomplex*,fdoublecomplex*,fdouble*,fdoublecomplex*,
      const finteger*,fdoublecomplex*,fdouble*,finteger*);

extern void F77CALL (zhprfs) (const char*,const finteger*,const finteger*,
      const fdoublecomplex*,const fdoublecomplex*,const finteger*,
      const fdoublecomplex*,const finteger*,fdoublecomplex*,const finteger*,
      fdouble*,fdouble*,fdoublecomplex*,fdouble*,finteger*);

extern void F77CALL (zhpsv) (const char*,const finteger*,const finteger*,
      fdoublecomplex*,finteger*,fdoublecomplex*,const finteger*,finteger*);

extern void F77CALL (zhpsvx) (const char*,const char*,const finteger*,
      const finteger*,const fdoublecomplex*,fdoublecomplex*,finteger*,
      const fdoublecomplex*,const finteger*,fdoublecomplex*,const finteger*,
      fdouble*,fdouble*,fdouble*,fdoublecomplex*,fdouble*,finteger*);

extern void F77CALL (zhptrd) (const char*,const finteger*,fdoublecomplex*,
      fdouble*,fdouble*,fdoublecomplex*,finteger*);

extern void F77CALL (zhptrf) (const char*,const finteger*,fdoublecomplex*,
      finteger*,finteger*);

extern void F77CALL (zhptri) (const char*,const finteger*,fdoublecomplex*,
      const finteger*,fdoublecomplex*,finteger*);

extern void F77CALL (zhptrs) (const char*,const finteger*,const finteger*,
      const fdoublecomplex*,const finteger*,fdoublecomplex*,const finteger*,
      finteger*);

extern void F77CALL (zhsein) (const char*,const char*,const char*,flogical*,
      const finteger*,const fdoublecomplex*,const finteger*,
      const fdoublecomplex*,fdoublecomplex*,finteger*,const fdoublecomplex*,
      finteger*,const finteger*,const finteger*,fdoublecomplex*,fdouble*,
      finteger*,finteger*,finteger*);

extern void F77CALL (zhseqr) (const char*,const char*,const finteger*,
      const finteger*,const finteger*,fdoublecomplex*,const finteger*,
      fdoublecomplex*,fdoublecomplex*,const finteger*,fdoublecomplex*,
      const finteger*,finteger*);

extern void F77CALL (zlabrd) (const finteger*,const finteger*,const finteger*,
      fdoublecomplex*,const finteger*,fdouble*,fdouble*,fdoublecomplex*,
      fdoublecomplex*,fdoublecomplex*,const finteger*,fdoublecomplex*,
      finteger*);

extern void F77CALL (zlacgv) (const finteger*,fdoublecomplex*,const finteger*);


extern void F77CALL (zlacon) (const finteger*,fdoublecomplex*,
      fdoublecomplex*,fdouble*,finteger*);

extern void F77CALL (zlacpy) (const char*,const finteger*,const finteger*,
      const fdoublecomplex*,const finteger*,fdoublecomplex*,const finteger*);

extern void F77CALL (zlacrm) (const finteger*,const finteger*,
      const fdoublecomplex*,const finteger*,const fdouble*,const finteger*,
      const fdoublecomplex*,const finteger*,fdouble*);

extern void F77CALL (zlacrt) (const finteger*,fdoublecomplex*,const finteger*,
      fdoublecomplex*,const finteger*,const fdoublecomplex*,
      const fdoublecomplex*);

#ifdef USE_F2C
extern void F77CALL (zladiv) (fdoublecomplex* ret_,const fdoublecomplex*,
      const fdoublecomplex*);
#else
extern fdoublecomplex F77CALL (zladiv) (const fdoublecomplex*,
      const fdoublecomplex*);
#endif

extern void F77CALL (zlaed0) (const finteger*,const finteger*,fdouble*,
      fdouble*,fdoublecomplex*,const finteger*,fdoublecomplex*,finteger*,
      fdouble*,const finteger*,finteger*);

extern void F77CALL (zlaed7) (const finteger*,const finteger*,const finteger*,
      const finteger*,const finteger*,const finteger*,fdouble*,fdoublecomplex*,
      const finteger*,const fdouble*,finteger*,fdouble*,finteger*,finteger*,
      finteger*,finteger*,const finteger*,const fdouble*,const fdoublecomplex*,
      const fdouble*,const finteger*,finteger*);

extern void F77CALL (zlaed8) (finteger*,const finteger*,const finteger*,
      fdoublecomplex*,const finteger*,fdouble*,fdouble*,const finteger*,
      const fdouble*,fdouble*,fdoublecomplex*,const finteger*,fdouble*,
      finteger*,finteger*,const finteger*,finteger*,finteger*,finteger*,
      fdouble*,finteger*);

extern void F77CALL (zlaein) (const flogical*,const flogical*,const finteger*,
      const fdoublecomplex*,const finteger*,const fdoublecomplex*,
      fdoublecomplex*,fdoublecomplex*,const finteger*,fdouble*,const fdouble*,
      const fdouble*,finteger*);

extern void F77CALL (zlaesy) (const fdoublecomplex*,const fdoublecomplex*,
      const fdoublecomplex*,fdoublecomplex*,fdoublecomplex*,fdoublecomplex*,
      fdoublecomplex*,fdoublecomplex*);

extern void F77CALL (zlaev2) (const fdoublecomplex*,const fdoublecomplex*,
      const fdoublecomplex*,fdouble*,fdouble*,fdouble*,fdoublecomplex*);

extern void F77CALL (zlags2) (const flogical*,const fdouble*,
      const fdoublecomplex*,const fdouble*,const fdouble*,
      const fdoublecomplex*,const fdouble*,fdouble*,fdoublecomplex*,fdouble*,
      fdoublecomplex*,fdouble*,fdoublecomplex*);

extern void F77CALL (zlagtm) (const char*,const finteger*,const finteger*,
      const fdouble*,const fdoublecomplex*,const fdoublecomplex*,
      const fdoublecomplex*,const fdoublecomplex*,const finteger*,
      const fdouble*,fdoublecomplex*,const finteger*);

extern void F77CALL (zlahef) (const char*,const finteger*,const finteger*,
      finteger*,fdoublecomplex*,const finteger*,finteger*,fdoublecomplex*,
      const finteger*,finteger*);

extern void F77CALL (zlahqr) (const flogical*,const flogical*,const finteger*,
      const finteger*,const finteger*,fdoublecomplex*,const finteger*,
      fdoublecomplex*,const finteger*,const finteger*,fdoublecomplex*,
      const finteger*,finteger*);

extern void F77CALL (zlahrd) (const finteger*,const finteger*,const finteger*,
      fdoublecomplex*,const finteger*,fdoublecomplex*,fdoublecomplex*,
      const finteger*,fdoublecomplex*,const finteger*);

extern void F77CALL (zlaic1) (const finteger*,const finteger*,
      const fdoublecomplex*,const fdouble*,const fdoublecomplex*,
      const fdoublecomplex*,fdouble*,fdoublecomplex*,fdoublecomplex*);

#ifdef USE_F2C
extern fdouble F77CALL (zlangb) (const char*,const finteger*,const finteger*,
      const finteger*,const fdoublecomplex*,const finteger*,fdouble*);

extern fdouble F77CALL (zlange) (const char*,const finteger*,const finteger*,
      const fdoublecomplex*,const finteger*,fdouble*);

extern fdouble F77CALL (zlangt) (const char*,const finteger*,
      const fdoublecomplex*,const fdoublecomplex*,const fdoublecomplex*);

extern fdouble F77CALL (zlanhb) (const char*,const char*,const finteger*,
      const finteger*,const fdoublecomplex*,const finteger*,fdouble*);

extern fdouble F77CALL (zlanhe) (const char*,const char*,const finteger*,
      const fdoublecomplex*,const finteger*,fdouble*);

extern fdouble F77CALL (zlanhp) (const char*,const char*,const finteger*,
      const fdoublecomplex*,fdouble*);

extern fdouble F77CALL (zlanhs) (const char*,const finteger*,
      const fdoublecomplex*,const finteger*,fdouble*);

extern fdouble F77CALL (zlanht) (const char*,const finteger*,const fdouble*,
      const fdoublecomplex*);

extern fdouble F77CALL (zlansb) (const char*,const char*,const finteger*,
      const finteger*, const fdoublecomplex*,const finteger*,fdouble*);

extern fdouble F77CALL (zlansp) (const char*,const char*,const finteger*,
      const fdoublecomplex*,fdouble*);

extern fdouble F77CALL (zlansy) (const char*,const char*,const finteger*,
      const fdoublecomplex*,const finteger*,fdouble*);

extern fdouble F77CALL (zlantb) (const char*,const char*,const char*,
      const finteger*,const finteger*,const fdoublecomplex*,const finteger*,
      fdouble*);

extern fdouble F77CALL (zlantp) (const char*,const char*,const char*,
      const finteger*,const fdoublecomplex*,fdouble*);

extern fdouble F77CALL (zlantr) (const char*,const char*,const char*,
      const finteger*,const finteger*,const fdoublecomplex*,const finteger*,
      fdouble*);
#else
extern fdouble F77CALL (zlangb) (const char*,const finteger*,const finteger*,
      const finteger*,const fdoublecomplex*,const finteger*,fdouble*);

extern fdouble F77CALL (zlange) (const char*,const finteger*,const finteger*,
      const fdoublecomplex*,const finteger*,fdouble*);

extern fdouble F77CALL (zlangt) (const char*,const finteger*,
      const fdoublecomplex*,const fdoublecomplex*,const fdoublecomplex*);

extern fdouble F77CALL (zlanhb) (const char*,const char*,const finteger*,
      const finteger*,const fdoublecomplex*,const finteger*,fdouble*);

extern fdouble F77CALL (zlanhe) (const char*,const char*,const finteger*,
      const fdoublecomplex*,const finteger*,fdouble*);

extern fdouble F77CALL (zlanhp) (const char*,const char*,const finteger*,
      const fdoublecomplex*,fdouble*);

extern fdouble F77CALL (zlanhs) (const char*,const finteger*,
      const fdoublecomplex*,const finteger*,fdouble*);

extern fdouble F77CALL (zlanht) (const char*,const finteger*,const fdouble*,
      const fdoublecomplex*);

extern fdouble F77CALL (zlansb) (const char*,const char*,const finteger*,
      const finteger*, const fdoublecomplex*,const finteger*,fdouble*);

extern fdouble F77CALL (zlansp) (const char*,const char*,const finteger*,
      const fdoublecomplex*,fdouble*);

extern fdouble F77CALL (zlansy) (const char*,const char*,const finteger*,
      const fdoublecomplex*,const finteger*,fdouble*);

extern fdouble F77CALL (zlantb) (const char*,const char*,const char*,
      const finteger*,const finteger*,const fdoublecomplex*,const finteger*,
      fdouble*);

extern fdouble F77CALL (zlantp) (const char*,const char*,const char*,
      const finteger*,const fdoublecomplex*,fdouble*);

extern fdouble F77CALL (zlantr) (const char*,const char*,const char*,
      const finteger*,const finteger*,const fdoublecomplex*,const finteger*,
      fdouble*);
#endif

extern void F77CALL (zlapll) (const finteger*,fdoublecomplex*,const finteger*,
      fdoublecomplex*,const finteger*,fdouble*);

extern void F77CALL (zlapmt) (const flogical*,const finteger*,const finteger*,
      fdoublecomplex*,const finteger*,const finteger*);

extern void F77CALL (zlaqgb) (const finteger*,const finteger*,const finteger*,
      const finteger*,fdoublecomplex*,const finteger*,fdouble*,fdouble*,
      fdouble*,fdouble*,const fdouble*,char*);

extern void F77CALL (zlaqge) (const finteger*,const finteger*,fdoublecomplex*,
      const finteger*,const fdouble*,const fdouble*,const fdouble*,
      const fdouble*,const fdouble*,char*);

extern void F77CALL (zlaqhb) (const char*,const finteger*,const finteger*,
      fdoublecomplex*,const finteger*,fdouble*,const fdouble*,const fdouble*,
      char*);

extern void F77CALL (zlaqhe) (const char*,const finteger*,fdoublecomplex*,
      const finteger*,const fdouble*,const fdouble*,const fdouble*,char*);

extern void F77CALL (zlaqhp) (const char*,const finteger*,fdoublecomplex*,
      const fdouble*,const fdouble*,const fdouble*,char*);

extern void F77CALL (zlaqsb) (const char*,const finteger*,const finteger*,
      fdoublecomplex*,const finteger*,fdouble*,const fdouble*,const fdouble*,char*);

extern void F77CALL (zlaqsp) (const char*,const finteger*,fdoublecomplex*,
      const fdouble*,const fdouble*,const fdouble*,char*);

extern void F77CALL (zlaqsy) (const char*,const finteger*,fdoublecomplex*,
      const finteger*,const fdouble*,const fdouble*,const fdouble*,char*);

extern void F77CALL (zlar2v) (const finteger*,fdoublecomplex*,fdoublecomplex*,
      fdoublecomplex*,const finteger*,const fdouble*,const fdoublecomplex*,
      const finteger*);

extern void F77CALL (zlarf) (char*,finteger*,finteger*,fdoublecomplex*,
      finteger*,fdoublecomplex*,const fdoublecomplex*,finteger*,
      const fdoublecomplex*);

extern void F77CALL (zlarfb) (const char*,const char*,const char*,const char*,
      const finteger*,const finteger*,const finteger*,const fdoublecomplex*,
      const finteger*,const fdoublecomplex*,const finteger*,fdoublecomplex*,
      const finteger*,fdoublecomplex*,const finteger*);

extern void F77CALL (zlarfg) (const finteger*,fdoublecomplex*,fdoublecomplex*,
      const finteger*,fdoublecomplex*);

extern void F77CALL (zlarft) (const char*,const char*,const finteger*,
      const finteger*,fdoublecomplex*,const finteger*,const fdoublecomplex*,
      fdoublecomplex*,const finteger*);

extern void F77CALL (zlarfx) (const char*,const finteger*,const finteger*,
      const fdoublecomplex*,const fdoublecomplex*,fdoublecomplex*,
      const finteger*,fdoublecomplex*);

extern void F77CALL (zlargv) (const finteger*,fdoublecomplex*,const finteger*,
      fdoublecomplex*,const finteger*,fdouble*,const finteger*);

extern void F77CALL (zlarnv) (const finteger*,finteger*,const finteger*,
      fdoublecomplex*);

extern void F77CALL (zlartg) (const fdoublecomplex*,const fdoublecomplex*,
      fdouble*,fdoublecomplex*,fdoublecomplex*);

extern void F77CALL (zlartv) (const finteger*,fdoublecomplex*,const finteger*,
      fdoublecomplex*,const finteger*,const fdouble*,const fdoublecomplex*,
      const finteger*);

extern void F77CALL (zlascl) (const char*,const finteger*,const finteger*,
      const fdouble*,const fdouble*,const finteger*,const finteger*,
      fdoublecomplex*,const finteger*,finteger*);

extern void F77CALL (zlaset) (const char*,const finteger*,const finteger*,
      const fdoublecomplex*,const fdoublecomplex*,fdoublecomplex*,
      const finteger*);

extern void F77CALL (zlasr) (const char*,const char*,const char*,
      const finteger*,const finteger*,const fdouble*,const fdouble*,
      fdoublecomplex*,const finteger*);

extern void F77CALL (zlassq) (const finteger*,const fdoublecomplex*,
      const finteger*,fdouble*,fdouble*);

extern void F77CALL (zlaswp) (const finteger*,fdoublecomplex*,const finteger*,
      const finteger*,const finteger*,const finteger*,const finteger*);

extern void F77CALL (zlasyf) (const char*,const finteger*,const finteger*,
      finteger*,fdoublecomplex*,const finteger*,finteger*,fdoublecomplex*,
      const finteger*,finteger*);

extern void F77CALL (zlatbs) (const char*,const char*,const char*,const char*,
      const finteger*,const finteger*,const fdoublecomplex*,const finteger*,
      fdoublecomplex*,fdouble*,fdouble*,finteger*);

extern void F77CALL (zlatps) (const char*,const char*,const char*,const char*,
      const finteger*,const fdoublecomplex*,fdoublecomplex*,fdouble*,fdouble*,
      finteger*);

extern void F77CALL (zlatrd) (const char*,const finteger*,const finteger*,
      fdoublecomplex*,const finteger*,fdouble*,fdoublecomplex*,
      fdoublecomplex*,const finteger*);

extern void F77CALL (zlatrs) (const char*,const char*,const char*,const char*,
      const finteger*,const fdoublecomplex*,const finteger*,fdoublecomplex*,
      fdouble*,fdouble*,finteger*);

extern void F77CALL (zlatzm) (const char*,const finteger*,const finteger*,
      const fdoublecomplex*,const finteger*,const fdoublecomplex*,
      fdoublecomplex*,fdoublecomplex*,const finteger*,fdoublecomplex*);

extern void F77CALL (zlauu2) (const char*,const finteger*,fdoublecomplex*,
      const finteger*,finteger*);

extern void F77CALL (zlauum) (const char*,const finteger*,fdoublecomplex*,
      const finteger*,finteger*);

extern void F77CALL (zpbcon) (const char*,const finteger*,const finteger*,
      const fdoublecomplex*,const finteger*,const fdouble*,fdouble*,
      fdoublecomplex*,fdouble*,finteger*);

extern void F77CALL (zpbequ) (const char*,const finteger*,const finteger*,
      const fdoublecomplex*,const finteger*,fdouble*,fdouble*,fdouble*,
      finteger*);

extern void F77CALL (zpbrfs) (const char*,const finteger*,const finteger*,
      const finteger*,const fdoublecomplex*,const finteger*,
      const fdoublecomplex*,const finteger*,const fdoublecomplex*,
      const finteger*,fdoublecomplex*,const finteger*,fdouble*,fdouble*,
      fdoublecomplex*,fdouble*,finteger*);

extern void F77CALL (zpbstf) (const char*,const finteger*,const finteger*,
      fdoublecomplex*,const finteger*,finteger*);

extern void F77CALL (zpbsv) (const char*,const finteger*,const finteger*,
      const finteger*,fdoublecomplex*,const finteger*,fdoublecomplex*,
      const finteger*,finteger*);

extern void F77CALL (zpbsvx) (const char*,const char*,const finteger*,
      const finteger*,const finteger*,fdoublecomplex*,const finteger*,
      fdoublecomplex*,const finteger*,char*,fdouble*,fdoublecomplex*,
      const finteger*,fdoublecomplex*,const finteger*,fdouble*,fdouble*,
      fdouble*,fdoublecomplex*,fdouble*,finteger*);

extern void F77CALL (zpbtf2) (const char*,const finteger*,const finteger*,
      fdoublecomplex*,const finteger*,finteger*);

extern void F77CALL (zpbtrf) (const char*,const finteger*,const finteger*,
      fdoublecomplex*,const finteger*,finteger*);

extern void F77CALL (zpbtrs) (const char*,const finteger*,const finteger*,
      const finteger*,const fdoublecomplex*,const finteger*,fdoublecomplex*,
      const finteger*,finteger*);

extern void F77CALL (zpocon) (const char*,const finteger*,
      const fdoublecomplex*,const finteger*,const fdouble*,fdouble*,
      fdoublecomplex*,fdouble*,finteger*);

extern void F77CALL (zpoequ) (const finteger*,const fdoublecomplex*,
      const finteger*,fdouble*,fdouble*,fdouble*,finteger*);

extern void F77CALL (zporfs) (const char*,const finteger*,const finteger*,
      const fdoublecomplex*,const finteger*,const fdoublecomplex*,
      const finteger*,const fdoublecomplex*,const finteger*,fdoublecomplex*,
      const finteger*,fdouble*,fdouble*,fdoublecomplex*,fdouble*,finteger*);

extern void F77CALL (zposv) (const char*,const finteger*,const finteger*,
      fdoublecomplex*,const finteger*,fdoublecomplex*,const finteger*,
      finteger*);

extern void F77CALL (zposvx) (const char*,const char*,const finteger*,
      const finteger*,fdoublecomplex*,const finteger*,fdoublecomplex*,
      const finteger*,char*,fdouble*,fdoublecomplex*,const finteger*,
      fdoublecomplex*,const finteger*,fdouble*,fdouble*,fdouble*,
      fdoublecomplex*,fdouble*,finteger*);

extern void F77CALL (zpotf2) (const char*,const finteger*,fdoublecomplex*,
      const finteger*,finteger*);

extern void F77CALL (zpotrf) (const char*,const finteger*,fdoublecomplex*,
      const finteger*,finteger*);

extern void F77CALL (zpotri) (const char*,const finteger*,fdoublecomplex*,
      const finteger*,finteger*);

extern void F77CALL (zpotrs) (const char*,const finteger*,const finteger*,
      const fdoublecomplex*,const finteger*,fdoublecomplex*,const finteger*,
      finteger*);

extern void F77CALL (zppcon) (const char*,const finteger*,
      const fdoublecomplex*,const fdouble*,fdouble*,fdoublecomplex*,fdouble*,
      finteger*);

extern void F77CALL (zppequ) (const char*,const finteger*,
      const fdoublecomplex*,fdouble*,fdouble*,fdouble*,finteger*);

extern void F77CALL (zpprfs) (const char*,const finteger*,const finteger*,
      const fdoublecomplex*,const fdoublecomplex*,const fdoublecomplex*,
      const finteger*,fdoublecomplex*,const finteger*,fdouble*,fdouble*,
      fdoublecomplex*,fdouble*,finteger*);

extern void F77CALL (zppsv) (const char*,const finteger*,const finteger*,
      fdoublecomplex*,fdoublecomplex*,const finteger*,finteger*);

extern void F77CALL (zppsvx) (const char*,const char*,const finteger*,
      const finteger*,fdoublecomplex*,fdoublecomplex*,char*,fdouble*,
      fdoublecomplex*,const finteger*,fdoublecomplex*,const finteger*,fdouble*,
      fdouble*,fdouble*,fdoublecomplex*,fdouble*,finteger*);

extern void F77CALL (zpptrf) (const char*,const finteger*,fdoublecomplex*,
      finteger*);

extern void F77CALL (zpptri) (const char*,const finteger*,fdoublecomplex*,
      finteger*);

extern void F77CALL (zpptrs) (const char*,const finteger*,const finteger*,
      const fdoublecomplex*,fdoublecomplex*,const finteger*,finteger*);

extern void F77CALL (zptcon) (const finteger*,const fdouble*,
      const fdoublecomplex*,const fdouble*,fdouble*,fdouble*,finteger*);

extern void F77CALL (zpteqr) (const char*,const finteger*,fdouble*,fdouble*,
      fdoublecomplex*,const finteger*,fdouble*,finteger*);

extern void F77CALL (zptrfs) (const char*,const finteger*,const finteger*,
      const fdouble*,const fdoublecomplex*,const fdouble*,
      const fdoublecomplex*,const fdoublecomplex*,const finteger*,
      fdoublecomplex*,const finteger*,fdouble*,fdouble*,fdoublecomplex*,
      fdouble*,finteger*);

extern void F77CALL (zptsv) (const finteger*,const finteger*,fdouble*,
      fdoublecomplex*,fdoublecomplex*,const finteger*,finteger*);

extern void F77CALL (zptsvx) (const char*,const finteger*,const finteger*,
      const fdouble*,const fdoublecomplex*,fdouble*,fdoublecomplex*,
      const fdoublecomplex*,const finteger*,fdoublecomplex*,const finteger*,
      fdouble*,fdouble*,fdouble*,fdoublecomplex*,fdouble*,finteger*);

extern void F77CALL (zpttrf) (const finteger*,fdouble*,fdoublecomplex*,
      finteger*);

extern void F77CALL (zpttrs) (const char*,const finteger*,const finteger*,
      const fdouble*,const fdoublecomplex*,fdoublecomplex*,const finteger*,
      finteger*);

extern void F77CALL (zrot) (const finteger*,fdoublecomplex*,const finteger*,
      fdoublecomplex*,const finteger*,const fdouble*,const fdoublecomplex*);

extern void F77CALL (zspcon) (const char*,const finteger*,
      const fdoublecomplex*,const finteger*,const fdouble*,fdouble*,
      fdoublecomplex*,finteger*);

extern void F77CALL (zspmv) (const char*,const finteger*,const fdoublecomplex*,
      const fdoublecomplex*,const fdoublecomplex*,const finteger*,
      const fdoublecomplex*,fdoublecomplex*,const finteger*);

extern void F77CALL (zspr) (const char*,const finteger*,const fdoublecomplex*,
      const fdoublecomplex*,const finteger*,fdoublecomplex*);

extern void F77CALL (zsprfs) (const char*,const finteger*,const finteger*,
      const fdoublecomplex*,const fdoublecomplex*,const finteger*,
      const fdoublecomplex*,const finteger*,fdoublecomplex*,const finteger*,
      fdouble*,fdouble*,fdoublecomplex*,fdouble*,finteger*);

extern void F77CALL (zspsv) (const char*,const finteger*,const finteger*,
      fdoublecomplex*,finteger*,fdoublecomplex*,const finteger*,finteger*);

extern void F77CALL (zspsvx) (const char*,const char*,const finteger*,
      const finteger*,const fdoublecomplex*,fdoublecomplex*,finteger*,
      const fdoublecomplex*,const finteger*,fdoublecomplex*,const finteger*,
      fdouble*,fdouble*,fdouble*,fdoublecomplex*,fdouble*,finteger*);

extern void F77CALL (zsptrf) (const char*,const finteger*,fdoublecomplex*,
      finteger*,finteger*);

extern void F77CALL (zsptri) (const char*,const finteger*,fdoublecomplex*,
      const finteger*,fdoublecomplex*,finteger*);

extern void F77CALL (zsptrs) (const char*,const finteger*,const finteger*,
      const fdoublecomplex*, const finteger*,fdoublecomplex*,const finteger*,
      finteger*);

extern void F77CALL (zsrot) (const finteger*,fdoublecomplex*,const finteger*,
      fdoublecomplex*,const finteger*,const fdouble*,const fdouble*);

extern void F77CALL (zdrscl) (const finteger*,const fdouble*,fdoublecomplex*,
      const finteger*);

extern void F77CALL (zstedc) (const char*,const finteger*,fdouble*,fdouble*,
      fdoublecomplex*,const finteger*,fdoublecomplex*,const finteger*,fdouble*,
      const finteger*,finteger*,const finteger*,finteger*);

extern void F77CALL (zstein) (const finteger*,const fdouble*,const fdouble*,
      const finteger*,const fdouble*,const finteger*,const finteger*,
      fdoublecomplex*,const finteger*,fdouble*,finteger*,finteger*,finteger*);

extern void F77CALL (zsteqr) (const char*,const finteger*,fdouble*,fdouble*,
      fdoublecomplex*,const finteger*,fdouble*,finteger*);

extern void F77CALL (zsycon) (const char*,const finteger*,
      const fdoublecomplex*,const finteger*,const finteger*,const fdouble*,
      fdouble*,fdoublecomplex*,finteger*);

extern void F77CALL (zsymv) (const char*,const finteger*,const fdoublecomplex*,
      const fdoublecomplex*,const finteger*,const fdoublecomplex*,
      const finteger*,const fdoublecomplex*,fdoublecomplex*,const finteger*);

extern void F77CALL (zsyr) (const char*,const finteger*,const fdoublecomplex*,
      const fdoublecomplex*,const finteger*,fdoublecomplex*,const finteger*);

extern void F77CALL (zsyrfs) (const char*,const finteger*,const finteger*,
      const fdoublecomplex*,const finteger*,const fdoublecomplex*,
      const finteger*,const finteger*,const fdoublecomplex*,const finteger*,
      fdoublecomplex*,const finteger*,fdouble*,fdouble*,fdoublecomplex*,
      fdouble*,finteger*);

extern void F77CALL (zsysv) (const char*,const finteger*,const finteger*,
      fdoublecomplex*,const finteger*,finteger*,fdoublecomplex*,
      const finteger*,fdoublecomplex*,const finteger*,finteger*);

extern void F77CALL (zsysvx) (const char*,const char*,const finteger*,
      const finteger*,const fdoublecomplex*,const finteger*,fdoublecomplex*,
      const finteger*,finteger*,const fdoublecomplex*,const finteger*,
      fdoublecomplex*,const finteger*,fdouble*,fdouble*,fdouble*,
      fdoublecomplex*,const finteger*,fdouble*,finteger*);

extern void F77CALL (zsytf2) (const char*,const finteger*,fdoublecomplex*,
      const finteger*,finteger*,finteger*);

extern void F77CALL (zsytrf) (const char*,const finteger*,fdoublecomplex*,
      const finteger*,finteger*,fdoublecomplex*,const finteger*,finteger*);

extern void F77CALL (zsytri) (const char*,const finteger*,fdoublecomplex*,
      const finteger*,const finteger*,fdoublecomplex*,finteger*);

extern void F77CALL (zsytrs) (const char*,const finteger*,const finteger*,
      const fdoublecomplex*,const finteger*,const finteger*,fdoublecomplex*,
      const finteger*,finteger*);

extern void F77CALL (ztbcon) (const char*,const char*,const char*,
      const finteger*,const finteger*,const fdoublecomplex*,const finteger*,
      fdouble*,fdoublecomplex*,fdouble*,finteger*);

extern void F77CALL (ztbrfs) (const char*,const char*,const char*,
      const finteger*,const finteger*,const finteger*,const fdoublecomplex*,
      const finteger*,const fdoublecomplex*,const finteger*,
      const fdoublecomplex*,const finteger*,fdouble*,fdouble*,fdoublecomplex*,
      fdouble*,finteger*);

extern void F77CALL (ztbtrs) (const char*,const char*,const char*,
      const finteger*,const finteger*,const finteger*,const fdoublecomplex*,
      const finteger*,fdoublecomplex*,const finteger*,finteger*);

extern void F77CALL (ztgevc) (const char*,const char*,const flogical*,
      const finteger*,const fdoublecomplex*,const finteger*,
      const fdoublecomplex*,const finteger*,fdoublecomplex*,const finteger*,
      fdoublecomplex*,const finteger*,const finteger*,finteger*,
      fdoublecomplex*,fdouble*,finteger*);

extern void F77CALL (ztgsja) (const char*,const char*,const char*,
      const finteger*,const finteger*,const finteger*,const finteger*,
      const finteger*,fdoublecomplex*,const finteger*,fdoublecomplex*,
      const finteger*,const fdouble*,const fdouble*,fdouble*,fdouble*,
      fdoublecomplex*,const finteger*,fdoublecomplex*,const finteger*,
      fdoublecomplex*,const finteger*,fdoublecomplex*,finteger*,finteger*);

extern void F77CALL (ztpcon) (const char*,const char*,const char*,
      const finteger*,const fdoublecomplex*,fdouble*,fdoublecomplex*,fdouble*,
      finteger*);

extern void F77CALL (ztprfs) (const char*,const char*,const char*,
      const finteger*,const finteger*,const fdoublecomplex*,
      const fdoublecomplex*,const finteger*,const fdoublecomplex*,
      const finteger*,fdouble*,fdouble*,fdoublecomplex*,fdouble*,finteger*);

extern void F77CALL (ztptri) (const char*,const char*,const finteger*,
      fdoublecomplex*,finteger*);

extern void F77CALL (ztptrs) (const char*,const char*,const char*,
      const finteger*,const finteger*,const fdoublecomplex*,fdoublecomplex*,
      const finteger*,finteger*);

extern void F77CALL (ztrcon) (const char*,const char*,const char*,
      const finteger*,const fdoublecomplex*,const finteger*,fdouble*,
      fdoublecomplex*,fdouble*,finteger*);

extern void F77CALL (ztrevc) (const char*,const char*,const flogical*,
      const finteger*,fdoublecomplex*,const finteger*,fdoublecomplex*,
      const finteger*,fdoublecomplex*,const finteger*,const finteger*,
      finteger*,fdoublecomplex*,fdouble*,finteger*);

extern void F77CALL (ztrexc) (const char*,const finteger*,fdoublecomplex*,
      const finteger*,fdoublecomplex*,const finteger*,const finteger*,
      const finteger*,finteger*);

extern void F77CALL (ztrrfs) (const char*,const char*,const char*,
      const finteger*,const finteger*,const fdoublecomplex*,const finteger*,
      const fdoublecomplex*,const finteger*,const fdoublecomplex*,
      const finteger*,fdouble*,fdouble*,fdoublecomplex*,fdouble*,finteger*);

extern void F77CALL (ztrsen) (const char*,const char*,const flogical*,
      const finteger*,fdoublecomplex*,const finteger*,fdoublecomplex*,
      const finteger*,fdoublecomplex*,finteger*,fdouble*,fdouble*,
      fdoublecomplex*,const finteger*,finteger*);

extern void F77CALL (ztrsna) (const char*,const char*,const flogical*,
      const finteger*,const fdoublecomplex*,const finteger*,
      const fdoublecomplex*,const finteger*,const fdoublecomplex*,
      const finteger*,fdouble*,fdouble*,const finteger*,finteger*,
      fdoublecomplex*,const finteger*,fdouble*,finteger*);

extern void F77CALL (ztrsyl) (const char*,const char*,const finteger*,
      const finteger*,const finteger*,const fdoublecomplex*,const finteger*,
      const fdoublecomplex*,const finteger*,fdoublecomplex*,const finteger*,
      fdouble*,finteger*);

extern void F77CALL (ztrti2) (const char*,const char*,const finteger*,
      fdoublecomplex*,const finteger*,finteger*);

extern void F77CALL (ztrtri) (const char*,const char*,const finteger*,
      fdoublecomplex*,const finteger*,finteger*);

extern void F77CALL (ztrtrs) (const char*,const char*,const char*,
      const finteger*,const finteger*,const fdoublecomplex*,const finteger*,
      fdoublecomplex*,const finteger*,finteger*);

extern void F77CALL (ztzrqf) (const finteger*,const finteger*,fdoublecomplex*,
      const finteger*,fdoublecomplex*,finteger*);

extern void F77CALL (zung2l) (const finteger*,const finteger*,const finteger*,
      fdoublecomplex*,const finteger*,const fdoublecomplex*,fdoublecomplex*,
      finteger*);

extern void F77CALL (zung2r) (const finteger*,const finteger*,const finteger*,
      fdoublecomplex*,const finteger*,const fdoublecomplex*,fdoublecomplex*,
      finteger*);

extern void F77CALL (zungbr) (const char*,const finteger*,const finteger*,
      const finteger*,fdoublecomplex*,const finteger*,const fdoublecomplex*,
      fdoublecomplex*,const finteger*,finteger*);

extern void F77CALL (zunghr) (const finteger*,const finteger*,const finteger*,
      fdoublecomplex*,const finteger*,const fdoublecomplex*,fdoublecomplex*,
      const finteger*,finteger*);

extern void F77CALL (zungl2) (const finteger*,const finteger*,const finteger*,
      fdoublecomplex*,const finteger*,const fdoublecomplex*,fdoublecomplex*,
      finteger*);

extern void F77CALL (zunglq) (const finteger*,const finteger*,const finteger*,
      fdoublecomplex*,const finteger*,const fdoublecomplex*,fdoublecomplex*,
      const finteger*,finteger*);

extern void F77CALL (zungql) (const finteger*,const finteger*,const finteger*,
      fdoublecomplex*,const finteger*,const fdoublecomplex*,fdoublecomplex*,
      const finteger*,finteger*);

extern void F77CALL (zungqr) (const finteger*,const finteger*,const finteger*,
      fdoublecomplex*,const finteger*,const fdoublecomplex*,fdoublecomplex*,
      const finteger*,finteger*);

extern void F77CALL (zungr2) (const finteger*,const finteger*,const finteger*,
      fdoublecomplex*,const finteger*,const fdoublecomplex*,fdoublecomplex*,
      finteger*);

extern void F77CALL (zungrq) (const finteger*,const finteger*,const finteger*,
      fdoublecomplex*,const finteger*,const fdoublecomplex*,fdoublecomplex*,
      const finteger*,finteger*);

extern void F77CALL (zungtr) (const char*,const finteger*,fdoublecomplex*,
      const finteger*,const fdoublecomplex*,fdoublecomplex*,const finteger*,
      finteger*);

extern void F77CALL (zunm2l) (const char*,const char*,const finteger*,
      const finteger*,const finteger*,const fdoublecomplex*,const finteger*,
      const fdoublecomplex*,fdoublecomplex*,const finteger*,fdoublecomplex*,
      finteger*);

extern void F77CALL (zunm2r) (const char*,const char*,const finteger*,
      const finteger*,const finteger*,const fdoublecomplex*,const finteger*,
      const fdoublecomplex*,fdoublecomplex*,const finteger*,fdoublecomplex*,
      finteger*);

extern void F77CALL (zunmbr) (const char*,const char*,const char*,
      const finteger*,const finteger*,const finteger*,const fdoublecomplex*,
      const finteger*,const fdoublecomplex*,fdoublecomplex*,const finteger*,
      fdoublecomplex*,const finteger*,finteger*);

extern void F77CALL (zunmhr) (const char*,const char*,const finteger*,
      const finteger*,const finteger*,const finteger*,const fdoublecomplex*,
      const finteger*,const fdoublecomplex*,fdoublecomplex*,const finteger*,
      fdoublecomplex*,const finteger*,finteger*);

extern void F77CALL (zunml2) (const char*,const char*,const finteger*,
      const finteger*,const finteger*,const fdoublecomplex*,const finteger*,
      const fdoublecomplex*,fdoublecomplex*,const finteger*,fdoublecomplex*,
      finteger*);

extern void F77CALL (zunmlq) (const char*,const char*,const finteger*,
      const finteger*,const finteger*,const fdoublecomplex*,const finteger*,
      const fdoublecomplex*,fdoublecomplex*,const finteger*,fdoublecomplex*,
      const finteger*,finteger*);

extern void F77CALL (zunmql) (const char*,const char*,const finteger*,
      const finteger*,const finteger*,const fdoublecomplex*,const finteger*,
      const fdoublecomplex*,fdoublecomplex*,const finteger*,fdoublecomplex*,
      const finteger*,finteger*);

extern void F77CALL (zunmqr) (const char*,const char*,const finteger*,
      const finteger*,const finteger*,const fdoublecomplex*,const finteger*,
      const fdoublecomplex*,fdoublecomplex*,const finteger*,fdoublecomplex*,
      const finteger*,finteger*);

extern void F77CALL (zunmr2) (const char*,const char*,const finteger*,
      const finteger*,const finteger*,const fdoublecomplex*,const finteger*,
      const fdoublecomplex*,fdoublecomplex*,const finteger*,fdoublecomplex*,
      finteger*);

extern void F77CALL (zunmrq) (const char*,const char*,const finteger*,
      const finteger*,const finteger*,const fdoublecomplex*,const finteger*,
      const fdoublecomplex*,fdoublecomplex*,const finteger*,fdoublecomplex*,
      const finteger*,finteger*);

extern void F77CALL (zunmtr) (const char*,const char*,const char*,
      const finteger*,const finteger*,const fdoublecomplex*,const finteger*,
      const fdoublecomplex*,fdoublecomplex*,const finteger*,fdoublecomplex*,
      const finteger*,finteger*);

extern void F77CALL (zupgtr) (const char*,const finteger*,
      const fdoublecomplex*,const fdoublecomplex*,fdoublecomplex*,
      const finteger*,fdoublecomplex*,finteger*);

extern void F77CALL (zupmtr) (const char*,const char*,const char*,
      const finteger*,const finteger*,const fdoublecomplex*,
      const fdoublecomplex*,fdoublecomplex*,const finteger*,
      fdoublecomplex*,finteger*);

#ifdef  __cplusplus
}
#endif                                               

#endif /* FLAPACK_H */
